PROCEDURE PUTPIC32(X,Y:LONGINT;PIC:PPICTURE);ASSEMBLER;
ASM
 { Variablenverteilung in der Prephase :
   EDI : X-Position
   EDX : Y-Position
   ECX : Hhe des Bildes
   EBX : Breite des Bildes
   ESI : Zeiger in das Bild
 }
  MOV EAX,[VIS]
  OR EAX,EAX
  JZ @EXT
  MOV ESI,PIC
  MOV ECX,[ESI]                { Hhe berprfen }
  OR ECX,ECX
  JZ @EXT
  MOV EBX,[ESI+4]              { Breite berprfen }
  OR EBX,EBX
  JZ @EXT
  ADD ESI,8
  MOV EDX,Y                    {  Y-SUBY auf Signed berprfen ! }
  SUB EDX,SUBY
  JNS @NONEGY
  NEG EDX
  SUB ECX,EDX                  { Hhe korrigieren }
  JS @EXT
  JZ @EXT
  MOV EAX,EBX                  { Breite stimmt noch... (keine x-Prfung) }
  MUL EDX                      { Anfangsposition korrigieren }
  SHL EAX,2
  ADD ESI,EAX
  XOR EDX,EDX                  { Y=0 ! }
  JMP @TOKNEGY
 @NONEGY:
  CMP EDX,MAXY                 { Y innerhalb des Fensters ? }
  JA @EXT
 @TOKNEGY:
  MOV EDI,X                    { X-SUBX auf Signed berprfen ! }
  SUB EDI,SUBX
  JNS @NONEGX
  NEG EDI
  SUB EBX,EDI                  { Breite korrigieren ! }
  JS @EXT
  JZ @EXT
  SHL EDI,2                    { Anfangsposition korrigieren ! }
  ADD ESI,EDI
  XOR EDI,EDI                  { X=0 ! }
  JMP @TOKNEGX
 @NONEGX:
  CMP EDI,[MAXX]               { X innerhalb des Fensters ? }
  JA @EXT
 @TOKNEGX:
  { Breite mu noch berprft werden ! }
  MOV EAX,EDI
  ADD EAX,EBX
  CMP EAX,MAXX
  JNA @OVERFLOWX
  MOV EBX,MAXX
  SUB EBX,EDI
  INC EBX
 @OVERFLOWX:
  { Hhe mu noch berprft werden ! }
  MOV EAX,EDX
  ADD EAX,ECX
  CMP EAX,MAXY
  JNA @OVERFLOWY
  MOV ECX,MAXY
  SUB ECX,EDX
  INC ECX
 @OVERFLOWY:
  { Anfangsposition im Bild sollte stimmen ! }
  ADD EDI,ADDX                 { Fensterverschiebung X }
  ADD EDX,ADDY                 { Fensterverschiebung Y }
  MOV EAX,WIDTH
  MUL EDX
  ADD EDI,EAX                  { Damit ist in EDI schon mal die Pre-Ziel-Ver }
  SHL EDI,2
  ADD EDI,[BUFFER]             { Und Zielposition fertig ! }
  { EDX ist obsolet geworden, in ECX befindet sich die Hhe => ndern ! }
  MOV EDX,ECX                  { EDX wird als Zhler fr die Hhe verwendet }
  { Beachte : EBX ist mit der neuen Breite belegt ! }
  MOV EAX,PIC                  { HADD berechnen => EAX }
  MOV EAX,[EAX+4]
  SUB EAX,EBX
  SHL EAX,2
  PUSH EBP
  MOV EBP,WIDTH
  SUB EBP,EBX
  SHL EBP,2
 @BIGLOOP:
  MOV ECX,EBX
  REP MOVSD
  ADD ESI,EAX
  ADD EDI,EBP
  DEC EDX
  JNE @BIGLOOP
  POP EBP
 @EXT:
END;
PROCEDURE COPY_64_64_32(DUMMY:DWORD);ASSEMBLER;
ASM
  MOV EAX,[PIXELS]
  XOR EDX,EDX
  MOV ESI,[BUFFER]
 @BIGLOOP:
  CMP EAX,16384
  JNA @RESTCOPY
  PUSH EAX
  PUSH EDX
  PUSH ESI
  MOV BX,WRWIN
  CALL SETBANK
  POP ESI
  POP EDX
  POP EAX
  MOV ECX,16384
  SUB EAX,ECX
  MOV EDI,[WRSEGL]
 @LP64:
  MOV EBX,[ESI]
  MOV FS:[EDI],EBX
  ADD ESI,4
  ADD EDI,4
  DEC ECX
  JNE @LP64
  INC EDX
  JMP @BIGLOOP
 @RESTCOPY:
  PUSH EAX
  PUSH EDX
  PUSH ESI
  MOV BX,WRWIN
  CALL SETBANK
  POP ESI
  POP DWORD PTR [OLDBANK]
  POP ECX
  MOV EDI,[WRSEGL]
 @LPR:
  MOV EBX,[ESI]
  MOV FS:[EDI],EBX
  ADD ESI,4
  ADD EDI,4
  DEC ECX
  JNE @LPR
END;
FUNCTION GET_64_64_32(X,Y:LONGINT):DWORD;ASSEMBLER;
ASM
  MOV ECX,X                    {                                            }
  CMP ECX,WIDTH                {  X-Position berprfen                     }
  JNB @EXT                     {                                            }
  MOV EDX,Y                    {                                            }
  CMP EDX,HEIGHT               {  Y-Position berprfen                     }
  JNB @EXT                     {                                            }
  MOV EAX,WIDTH                {                                            }
  MUL EDX                      {  Lineare Adresse im Bildschirmspeicher     }
  ADD EAX,ECX                  {  berechnen                                 }
  SHL EAX,2
  MOV EDX,EAX                  {                                            }
  SHR EDX,16                   {  Bank berprfen                           }
  CMP EDX,OLDBANK              {                                            }
  JZ @GOON                     {                                            }
  PUSH EAX                     {                                            }
  MOV OLDBANK,EDX              {  Bank setzen.                              }
  MOV BX,WRWIN                 {                                            }
  CALL SETBANK                 {                                            }
  POP EAX                      {                                            }
 @GOON:
  AND EAX,0FFFFh               { Lineare Adresse auf Bank-Offset reduzieren  }
  ADD EAX,[WRSEGL]             { Anfangsadresse des Bildschirmspeicher-F.    }
  MOV EAX,FS:[EAX]             { Und lesen                                   }
 @EXT:
END;
PROCEDURE PUT_64_64_32(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
  MOV ECX,X                    {                                            }
  CMP ECX,WIDTH                {  X-Position berprfen                     }
  JNB @EXT                     {                                            }
  MOV EDX,Y                    {                                            }
  CMP EDX,HEIGHT               {  Y-Position berprfen                     }
  JNB @EXT                     {                                            }
  MOV EAX,WIDTH                {                                            }
  MUL EDX                      {  Lineare Adresse im Bildschirmspeicher     }
  ADD EAX,ECX                  {  berechnen                                 }
  SHL EAX,2
  MOV EDX,EAX                  {                                            }
  SHR EDX,16                   {  Bank berprfen                           }
  CMP EDX,OLDBANK              {                                            }
  JZ @GOON                     {                                            }
  PUSH EAX                     {                                            }
  MOV OLDBANK,EDX              {  Bank setzen.                              }
  MOV BX,WRWIN                 {                                            }
  CALL SETBANK                 {                                            }
  POP EAX                      {                                            }
 @GOON:
  AND EAX,0FFFFh               { Lineare Adresse auf Bank-Offset reduzieren  }
  ADD EAX,[WRSEGL]             { Anfangsadresse des Bildschirmspeicher-F.    }
  MOV EBX,C                    { Farbwert laden                              }
  MOV FS:[EAX],EBX             { Und schreiben                               }
 @EXT:
END;
PROCEDURE BAR_B32(X,Y:LONGINT;H,B,C:DWORD);ASSEMBLER;
ASM
  MOV EAX,[VIS]
  OR EAX,EAX
  JZ @EXT
  MOV ESI,H
  OR ESI,ESI
  JZ NEAR @EXT
  MOV EBX,B
  OR EBX,EBX
  JZ NEAR @EXT
  MOV ECX,X
  SUB ECX,[SUBX]
  JNS @NXSIGN
  ADD EBX,ECX
  JS @EXT
  JZ @EXT
  XOR ECX,ECX
  JMP @XSIGN
 @NXSIGN:
  CMP ECX,[MAXX]
  JA @EXT
 @XSIGN:
  MOV EDX,Y
  SUB EDX,[SUBY]
  JNS @NYSIGN
  ADD ESI,EDX
  JS @EXT
  JZ @EXT
  XOR EDX,EDX
  JMP @YSIGN
 @NYSIGN:
  CMP EDX,[MAXY]
  JA @EXT
 @YSIGN:
  MOV EAX,ECX
  ADD EAX,EBX
  CMP EAX,[MAXX]
  JNA @NXOVER
  MOV EBX,[MAXX]
  SUB EBX,ECX
  INC EBX
 @NXOVER:
  MOV EAX,EDX
  ADD EAX,ESI
  CMP EAX,[MAXY]
  JNA @NYOVER
  MOV ESI,[MAXY]
  SUB ESI,EDX
  INC ESI
 @NYOVER:
  MOV EAX,[WIDTH]
  ADD EDX,[ADDY]
  MUL EDX
  ADD EAX,ECX
  ADD EAX,[ADDX]
  SHL EAX,2
  MOV EDI,EAX
  ADD EDI,[BUFFER]
  MOV EDX,[WIDTH]
  SUB EDX,EBX
  SHL EDX,2
  MOV EAX,C
 @MAINLOOP:
  MOV ECX,EBX
  REP STOSD
  ADD EDI,EDX
  DEC ESI
  JNE @MAINLOOP
 @EXT:
END;
FUNCTION GET_ABS_B32(X,Y:LONGINT):DWORD;ASSEMBLER;
ASM
  MOV ECX,X
  CMP ECX,[WIDTH]
  JNB @EXT
  MOV EDX,Y
  CMP EDX,[HEIGHT]
  JNB @EXT
  MOV EAX,[WIDTH]
  MUL EDX
  ADD EAX,ECX
  SHL EAX,2
  ADD EAX,[BUFFER]
  MOV EAX,[EAX]
 @EXT:
END;
PROCEDURE PUT_ABS_B32(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
  MOV ECX,X
  CMP ECX,[WIDTH]
  JNB @EXT
  MOV EDX,Y
  CMP EDX,[HEIGHT]
  JNB @EXT
  MOV EAX,[WIDTH]
  MUL EDX
  ADD EAX,ECX
  SHL EAX,2
  ADD EAX,[BUFFER]
  MOV EBX,[C]
  MOV [EAX],EBX
 @EXT:
END;
FUNCTION GET_B32(X,Y:LONGINT):DWORD;ASSEMBLER;
ASM
  MOV EAX,[VIS]
  OR EAX,EAX
  JZ @EXT
  MOV ECX,X
  SUB ECX,[SUBX]
  CMP ECX,[MAXX]
  JA @EXT
  MOV EDX,Y
  SUB EDX,[SUBY]
  CMP EDX,[MAXY]
  JA @EXT
  MOV EAX,[WIDTH]
  ADD EDX,[ADDY]
  MUL EDX
  ADD ECX,[ADDX]
  ADD EAX,ECX
  SHL EAX,2
  ADD EAX,[BUFFER]
  MOV EAX,[EAX]
 @EXT:
END;
PROCEDURE PUT_B32(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
  MOV EAX,[VIS]
  OR EAX,EAX
  JZ @EXT
  MOV ECX,X
  SUB ECX,[SUBX]
  CMP ECX,[MAXX]
  JA @EXT
  MOV EDX,Y
  SUB EDX,[SUBY]
  CMP EDX,[MAXY]
  JA @EXT
  MOV EAX,[WIDTH]
  ADD EDX,[ADDY]
  MUL EDX
  ADD ECX,[ADDX]
  ADD EAX,ECX
  SHL EAX,2
  ADD EAX,[BUFFER]
  MOV EBX,[C]
  MOV [EAX],EBX
 @EXT:
END;
PROCEDURE FILL_B32(C:DWORD);ASSEMBLER;
ASM
  MOV EDI,[BUFFER]
  MOV ECX,[PIXELS]
  MOV EAX,DWORD PTR C
  REP STOSD
END;