UNIT WINBAS;
INTERFACE
USES CRT,GRAPH,UMOUSE;
{$I MOUSEP.INC}
CONST GT_NULL=0;
      GT_WIN=1;
      GT_STDOBJ=2;
      GT_TRANSPARENT=3;
TYPE PWIN=^TWIN;
     TWIN=OBJECT
      CONSTRUCTOR INIT(BAS,GR:PWIN;PX,PY:LONGINT;PH,PB:DWORD;VISI:BOOLEAN;GT:DWORD);
      DESTRUCTOR DONE;
      PROCEDURE REDRAW;
      PROCEDURE PAINT;
      PROCEDURE SETAPPFRAME(P:PWIN);
      FUNCTION GETAFH:DWORD;
      FUNCTION GETAFB:DWORD;
      FUNCTION GETH:DWORD;
      FUNCTION GETB:DWORD;
      FUNCTION GETX:LONGINT;
      FUNCTION GETY:LONGINT;
      PROCEDURE SELECT;
      PROCEDURE UNSELECT;
      PROCEDURE MOVESIZE(PX,PY:LONGINT;PH,PB:DWORD);
      FUNCTION HASFOCUS:BOOLEAN;
      FUNCTION GETNEXTSTDOBJ:PWIN;
      FUNCTION GETNEXTWIN:PWIN;
      PROCEDURE BRINGTOFRONT;
      PROCEDURE ONDONE;VIRTUAL;
      PROCEDURE ONSELECT(FOC:BOOLEAN);VIRTUAL;
      PROCEDURE ONUNSELECT;VIRTUAL;
      PROCEDURE ONMOUSE(PX,PY:LONGINT;PB:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONKEY(C,C2:CHAR);VIRTUAL;
      PROCEDURE MOVE(PX,PY:LONGINT);VIRTUAL;
      PROCEDURE SIZE(PH,PB:DWORD);VIRTUAL;
      FUNCTION GETMOUSEPIC(VAR HX,HY:LONGINT):PPICTURE;VIRTUAL;
      PROCEDURE ONRESIZE;VIRTUAL;
      PROCEDURE CHECKSIZE(VAR PH,PB:DWORD);VIRTUAL;
      PROCEDURE SHOW;
      PROCEDURE HIDE;
      PROCEDURE ENABLEBLOCK;
      PROCEDURE DISABLEBLOCK;
      FUNCTION VISIBLE:BOOLEAN;
      PROCEDURE INVERTVIS;
      PRIVATE
      APPFRAME,AKTSUB:PWIN;
      GROUP:PWIN;
      VIS,BLOCK:BOOLEAN;
      X,Y:LONGINT;
      H,B,GTYP:DWORD;
      GRWIN:TSCRWIN;
      NEXT,LAST,OVER,UNDER,UNDERL,INEXT,ILAST,IUNDER,IUNDERL:PWIN;
      PROCEDURE CALCGRWINS;
     END;
FUNCTION GETOLDMOUSEB:DWORD;
PROCEDURE RUNWINENGINE;
FUNCTION INITWINENGINE(RESX,RESY:DWORD;BPP:DWORD):BOOLEAN;
FUNCTION CRSTR:STRING;
PROCEDURE CRLEA;
IMPLEMENTATION
VAR REDRAWALL:BOOLEAN;
    MOUSEFOC,OBJFOC,MAINWIN:PWIN;
    AKTMOUSE,AKTMOUSEPIC,MOUSESAV:PPICTURE;
    OLDMOUSEX,OLDMOUSEY,HOTSPOTX,HOTSPOTY:LONGINT;
    OLDMOUSEB:DWORD;
    CRLEVEL:DWORD;
PROCEDURE TWIN.INVERTVIS;
BEGIN
 IF VIS THEN HIDE ELSE SHOW;
END;
FUNCTION TWIN.VISIBLE:BOOLEAN;
BEGIN
 VISIBLE:=VIS;
END;
PROCEDURE CRLEA;
BEGIN
 DEC(CRLEVEL);
END;
FUNCTION CRSTR:STRING;
VAR I:DWORD;
BEGIN
 CRSTR:='';
 FOR I:=1 TO CRLEVEL DO CRSTR:=CRSTR+' ';
 INC(CRLEVEL);
END;
FUNCTION INITWINENGINE(RESX,RESY:DWORD;BPP:DWORD):BOOLEAN;
BEGIN
 IF AUTOSELECT(0,RESX,RESY,BPP)=$FFFFFFFF THEN
 BEGIN
  WRITELN('Grafikmodus nicht gefunden !');
  INITWINENGINE:=FALSE;
  HALT;
 END;
 INITMODE;
 SETMOUSEFIELD(HEIGHT,WIDTH);
 MOUSESPEED(1,1);
 INITWINENGINE:=TRUE;
END;
PROCEDURE TWIN.ENABLEBLOCK;
BEGIN
 BLOCK:=TRUE;
END;
PROCEDURE TWIN.DISABLEBLOCK;
BEGIN
 BLOCK:=FALSE;
END;
PROCEDURE TWIN.HIDE;
BEGIN
 IF VIS THEN
 BEGIN
  VIS:=FALSE;
  CALCGRWINS;
  IF OVER<>NIL THEN OVER^.REDRAW;
 END;
END;
PROCEDURE TWIN.SHOW;
BEGIN
 IF NOT VIS THEN
 BEGIN
  VIS:=TRUE;
  CALCGRWINS;
 END;
END;
FUNCTION TWIN.GETAFB:DWORD;
VAR P:PWIN;
BEGIN
 P:=@SELF;
 WHILE P^.APPFRAME<>NIL DO P:=P^.APPFRAME;
 GETAFB:=P^.B;
END;
FUNCTION TWIN.GETAFH:DWORD;
VAR P:PWIN;
BEGIN
 P:=@SELF;
 WHILE P^.APPFRAME<>NIL DO P:=P^.APPFRAME;
 GETAFH:=P^.H;
END;
PROCEDURE TWIN.CHECKSIZE(VAR PH,PB:DWORD);
BEGIN
END;
FUNCTION GETOLDMOUSEB:DWORD;
BEGIN
 GETOLDMOUSEB:=OLDMOUSEB;
END;
PROCEDURE TWIN.ONRESIZE;
BEGIN
END;
PROCEDURE TWIN.BRINGTOFRONT;
BEGIN
 IF (NEXT=NIL) THEN EXIT;
 IF LAST<>NIL THEN LAST^.NEXT:=NEXT ELSE OVER^.UNDER:=NEXT;
 NEXT^.LAST:=LAST;
 LAST:=OVER^.UNDERL;
 IF LAST<>NIL THEN LAST^.NEXT:=@SELF;
 NEXT:=NIL;
 OVER^.UNDERL:=@SELF;
 REDRAW;
END;
PROCEDURE TWIN.CALCGRWINS;
VAR P:PWIN;
BEGIN
 IF OVER<>NIL THEN
 BEGIN
  CREATESUBWIN(OVER^.GRWIN,X,Y,H,B,VIS,GRWIN);
 END ELSE CREATEABSWIN(X,Y,H,B,VIS,GRWIN);
 P:=UNDER;
 WHILE P<>NIL DO
 BEGIN
  P^.CALCGRWINS;
  P:=P^.NEXT;
 END;
 IF GRWIN.VIS THEN REDRAW;
END;
PROCEDURE TWIN.MOVESIZE(PX,PY:LONGINT;PH,PB:DWORD);
BEGIN
 MOVE(PX,PY);
 SIZE(PH,PB);
END;
PROCEDURE TWIN.SIZE(PH,PB:DWORD);
BEGIN
 CHECKSIZE(PH,PB);
 H:=PH;
 B:=PB;
 CALCGRWINS;
 ONRESIZE;
END;
PROCEDURE TWIN.MOVE(PX,PY:LONGINT);
BEGIN
 X:=PX;
 Y:=PY;
 CALCGRWINS;
END;
FUNCTION TWIN.GETX:LONGINT;
BEGIN
 GETX:=X;
END;
FUNCTION TWIN.GETY:LONGINT;
BEGIN
 GETY:=Y;
END;
FUNCTION TWIN.GETNEXTWIN:PWIN;
VAR P,S,W:PWIN;
    I:DWORD;
    MW:BOOLEAN;
BEGIN
 W:=@SELF;
 WRITELN('GETNEXTWIN from ',DWORD(W));
 WHILE (W<>NIL) AND (W^.GTYP<>GT_WIN) DO W:=W^.OVER;
 IF W=NIL THEN W:=@SELF;
 WRITELN(' -> ',DWORD(W));
 IF (W^.IUNDER<>NIL) THEN
 BEGIN
  P:=W^.IUNDER;
  S:=W;
  WRITELN('SIUNDER -> ',DWORD(S),'\',DWORD(P));
 END
 ELSE IF W^.INEXT<>NIL THEN
 BEGIN
  P:=W^.INEXT;
  S:=W^.OVER;
  WRITELN('SINEXT -> ',DWORD(S),'\',DWORD(P));
 END ELSE IF W^.OVER<>NIL THEN
 BEGIN
  P:=W^.OVER;
  S:=P^.OVER;
  WRITELN('SOVER -> ',DWORD(S),'\',DWORD(P));
 END ELSE
 BEGIN
  { Naja, eigentlich kann das Objekt ja nur alleine sein...nochmal prfen ! }
  P:=MAINWIN;
  S:=NIL;
  WRITELN('SMAINWIN -> ',DWORD(S),'\',DWORD(P));
 END;
 WHILE (P<>NIL) AND (P^.BLOCK OR (NOT P^.VIS)) DO P:=P^.INEXT;
 I:=0;
 MW:=FALSE;
 WHILE (P<>W) DO
 BEGIN
  INC(I);
  IF I>1000 THEN
  BEGIN
   WRITELN('A fucking edge GETNEXTWIN bug !');
   HALT;
  END;
  IF P<>NIL THEN
  BEGIN
   IF (P^.GRWIN.VIS) AND (P^.GTYP=GT_WIN) AND (P<>W) AND (P^.GROUP<>W) THEN
   BEGIN
    IF P^.GROUP<>NIL THEN GETNEXTWIN:=P^.GROUP ELSE GETNEXTWIN:=P;
    WRITELN('Found : ',DWORD(GETNEXTWIN));
    EXIT;
   END;
  END;
  IF P=NIL THEN
  BEGIN
   IF (S=NIL) THEN
   BEGIN
    IF MW THEN
    BEGIN
     WRITELN('MAINWIN 2 !!!');
     IF OBJFOC<>NIL THEN GETNEXTWIN:=OBJFOC ELSE GETNEXTWIN:=MAINWIN;
     EXIT;
    END;
    MW:=TRUE;
    P:=MAINWIN;
    WRITELN('MAINWIN -> ',DWORD(S),'\',DWORD(P));
   END
   ELSE
   BEGIN
    IF (S^.BLOCK) THEN
    BEGIN
     P:=S^.IUNDER;
     WRITELN('BLOCK-REDIR>OVER+IUNDER -> ',DWORD(S),'\',DWORD(P));
    END
    ELSE
    BEGIN
     P:=S^.INEXT;
     S:=S^.OVER;
     WRITELN('OVER+INEXT -> ',DWORD(S),'\',DWORD(P));
    END;
   END;
  END
  ELSE
  BEGIN
   IF (P^.IUNDER<>NIL) THEN
   BEGIN
    S:=P;
    P:=P^.IUNDER;
    WRITELN('IUNDER -> ',DWORD(S),'\',DWORD(P));
   END
   ELSE
   BEGIN
    IF (S=NIL) AND (P^.INEXT=NIL) THEN
    BEGIN
     WRITELN('IUNDER -> ',DWORD(S),'\',DWORD(P));
     S:=P;
     P:=P^.IUNDER
    END
    ELSE
    BEGIN
     P:=P^.INEXT;
     WRITELN('INEXT -> ',DWORD(S),'\',DWORD(P));
    END;
   END;
  END;
  WHILE (P<>NIL) AND (P^.BLOCK) DO
  BEGIN
   P:=P^.INEXT;
   WRITELN('Block -> INEXT ->',DWORD(S),'\',DWORD(P));
  END;
 END;
 GETNEXTWIN:=W;
END;
FUNCTION TWIN.GETNEXTSTDOBJ:PWIN;
VAR P,S:PWIN;
    I:DWORD;
BEGIN
 IF IUNDER<>NIL THEN
 BEGIN
  P:=IUNDER;
  S:=@SELF;
 END
 ELSE
 BEGIN
  P:=INEXT;
  S:=OVER;
 END;
 I:=0;
 WHILE (P<>@SELF) DO
 BEGIN
  INC(I);
  IF I>1000 THEN
  BEGIN
   WRITELN('A fucking edge GETNEXTSTDOBJ bug !');
   HALT;
  END;
  IF P<>NIL THEN
  BEGIN
   IF (P^.GTYP=GT_STDOBJ) AND (P<>@SELF) AND (P^.GROUP=NIL) THEN
   BEGIN
    IF P^.GROUP<>NIL THEN GETNEXTSTDOBJ:=P^.GROUP ELSE GETNEXTSTDOBJ:=P;
    EXIT;
   END;
  END;
  IF P=NIL THEN
  BEGIN
   IF S=NIL THEN P:=MAINWIN ELSE
   BEGIN
    IF S^.GTYP=GT_WIN THEN
    BEGIN
     P:=S^.IUNDER
    END
    ELSE
    BEGIN
     P:=S^.INEXT;
     S:=S^.OVER;
    END;
   END;
  END
  ELSE
  BEGIN
   IF (P^.IUNDER<>NIL) AND (P^.GTYP<>GT_WIN) THEN
   BEGIN
    S:=P;
    P:=P^.IUNDER;
   END ELSE P:=P^.INEXT;
  END;
 END;
 GETNEXTSTDOBJ:=@SELF;
END;
PROCEDURE TWIN.ONKEY(C,C2:CHAR);
BEGIN
END;
PROCEDURE POLLKEYB;
VAR C,C2:CHAR;
    P:PWIN;
BEGIN
 WHILE KEYPRESSED DO
 BEGIN
  C:=READKEY;
  IF C=#0 THEN C2:=READKEY;
  CASE C OF
   #9:IF OLDMOUSEB=0 THEN
   BEGIN
    IF (OBJFOC=NIL) AND (MAINWIN<>NIL) THEN MAINWIN^.GETNEXTWIN^.SELECT;
    IF OBJFOC<>NIL THEN OBJFOC^.GETNEXTSTDOBJ^.SELECT;
   END;
   #0:CASE C2 OF
    #64:IF OLDMOUSEB=0 THEN
    BEGIN
     IF OBJFOC<>NIL THEN OBJFOC^.GETNEXTWIN^.SELECT ELSE
     BEGIN
      IF MAINWIN<>NIL THEN MAINWIN^.GETNEXTWIN^.SELECT;
     END;
    END;
    ELSE IF OBJFOC<>NIL THEN OBJFOC^.ONKEY(C,C2);
   END
   ELSE IF OBJFOC<>NIL THEN OBJFOC^.ONKEY(C,C2);
  END;
 END;
END;
FUNCTION TWIN.HASFOCUS:BOOLEAN;
BEGIN
 HASFOCUS:=(OBJFOC=@SELF);
END;
FUNCTION TWIN.GETMOUSEPIC(VAR HX,HY:LONGINT):PPICTURE;
BEGIN
 GETMOUSEPIC:=@QSTDMSPIC_POINTER;
 HX:=0;
 HY:=0;
END;
PROCEDURE TWIN.UNSELECT;
VAR P:PWIN;
BEGIN
 IF MOUSEFOC=@SELF THEN MOUSEFOC:=NIL;
 IF OBJFOC<>@SELF THEN EXIT;
 P:=@SELF;
 WHILE P<>NIL DO
 BEGIN
  P^.ONUNSELECT;
  P:=P^.OVER;
 END;
 OBJFOC:=NIL;
END;
PROCEDURE TWIN.SELECT;
VAR LEV,Z:PWIN;
BEGIN
 WRITELN('Selectc : ',DWORD(@SELF));
 LEV:=@SELF;
 WHILE LEV^.GROUP<>NIL DO
 BEGIN
  LEV:=LEV^.GROUP;
  WRITELN('Selectc2 : ',DWORD(LEV));
 END;
 WHILE (LEV<>NIL) AND (LEV^.AKTSUB<>NIL) DO LEV:=LEV^.AKTSUB;
 WRITELN('Selectc3 : ',DWORD(LEV));
 IF OBJFOC=LEV THEN EXIT;
 IF OBJFOC<>NIL THEN OBJFOC^.UNSELECT;
 OBJFOC:=LEV;
 IF LEV=NIL THEN EXIT;
 IF LEV^.GTYP=GT_WIN THEN Z:=NIL ELSE Z:=LEV;
 WRITELN('Select : ',DWORD(LEV));
 LEV^.ONSELECT(TRUE);
 LEV:=LEV^.OVER;
 WHILE LEV<>NIL DO
 BEGIN
  LEV^.ONSELECT(FALSE);
  IF (LEV^.GTYP=GT_WIN) AND (Z<>NIL) THEN
  BEGIN
   LEV^.AKTSUB:=Z;
   Z:=NIL;
  END;
  LEV:=LEV^.OVER;
 END;
END;
FUNCTION GETOBJATABSPOS(X,Y:LONGINT):PWIN;
VAR P,P2:PWIN;
    DUMMYC:DWORD;
BEGIN
 P:=NIL;
 P2:=MAINWIN;
 DUMMYC:=0;
 WHILE P2<>NIL DO
 BEGIN
  IF (P2^.GRWIN.VIS) AND
     (P2^.GRWIN.ADDX<=X) AND
     (P2^.GRWIN.ADDY<=Y) AND
     (P2^.GRWIN.ADDX+P2^.GRWIN.MAXX>=X) AND
     (P2^.GRWIN.ADDY+P2^.GRWIN.MAXY>=Y) THEN
  BEGIN
   P:=P2;
   IF P^.GTYP=GT_TRANSPARENT THEN INC(DUMMYC);
   IF (DUMMYC<>0) AND (P2^.UNDERL=NIL) THEN
   BEGIN
    P2:=P2^.LAST;
    DEC(DUMMYC);
   END ELSE P2:=P2^.UNDERL;
  END
  ELSE
  BEGIN
   IF (P<>NIL) AND (P^.GTYP=GT_TRANSPARENT) THEN
   BEGIN
    IF P2^.LAST=NIL THEN
    BEGIN
     WHILE (DUMMYC<>0) DO
     BEGIN
      P2:=P2^.OVER;
      DEC(DUMMYC);
     END;
    END;
   END;
   P2:=P2^.LAST;
  END;
 END;
 GETOBJATABSPOS:=P;
END;
PROCEDURE TWIN.SETAPPFRAME(P:PWIN);
BEGIN
 APPFRAME:=P;
END;
FUNCTION TWIN.GETH:DWORD;
BEGIN
 GETH:=H;
END;
FUNCTION TWIN.GETB:DWORD;
BEGIN
 GETB:=B;
END;
PROCEDURE TWIN.PAINT;
VAR P:PWIN;
BEGIN
 GRAPH.SETWIN(GRWIN);
 ONPAINT;
 P:=UNDER;
 WHILE P<>NIL DO
 BEGIN
  P^.PAINT;
  P:=P^.NEXT;
 END;
END;
PROCEDURE SETMOUSEPIC(P:PPICTURE;HX,HY:LONGINT);
VAR H,B:DWORD;
BEGIN
 IF MOUSESAV<>NIL THEN
 BEGIN
  DIRECT_PUTPIC(OLDMOUSEX-HOTSPOTX,OLDMOUSEY-HOTSPOTY,MOUSESAV);
  H:=MOUSESAV^.B;
  B:=MOUSESAV^.H;
  FREEMEM(AKTMOUSE,H*B*4+8);
  FREEMEM(MOUSESAV,H*B*4+8);
 END;
 HOTSPOTX:=HX;
 HOTSPOTY:=HY;
 AKTMOUSEPIC:=P;
 IF P=NIL THEN
 BEGIN
  MOUSESAV:=NIL;
  AKTMOUSE:=NIL;
 END
 ELSE
 BEGIN
  GETMEM(MOUSESAV,P^.B*P^.H*4+8);
  GETMEM(AKTMOUSE,P^.B*P^.H*4+8);
  CONVDPIC(P,AKTMOUSE);
  MOUSESAV^.H:=P^.H;
  MOUSESAV^.B:=P^.B;
  DIRECT_GETPIC(OLDMOUSEX-HOTSPOTX,OLDMOUSEY-HOTSPOTY,MOUSESAV);
  DIRECT_PUTPICSPZ(OLDMOUSEX-HOTSPOTX,OLDMOUSEY-HOTSPOTY,AKTMOUSE);
 END;
END;
PROCEDURE POLLMOUSE;
VAR T:PWIN;
    HX,HY:LONGINT;
    NEWMSPIC:PPICTURE;
BEGIN
 IF UMOUSE.POLLMOUSE THEN
 BEGIN
  T:=GETOBJATABSPOS(MOUSEX,MOUSEY);
  IF T<>NIL THEN
  BEGIN
   IF (MOUSEB<>0) AND (OLDMOUSEB=0) THEN
   BEGIN
    IF T^.BLOCK THEN MOUSEFOC:=NIL ELSE
    BEGIN
     MOUSEFOC:=T;
     MOUSEFOC^.SELECT;
    END;
   END;
   IF (MOUSEB=0) OR (OLDMOUSEB=0) THEN
   BEGIN
    NEWMSPIC:=T^.GETMOUSEPIC(HX,HY);
    IF (NEWMSPIC<>AKTMOUSEPIC) OR (HX<>HOTSPOTX) OR (HY<>HOTSPOTY) then
    BEGIN
     SETMOUSEPIC(NEWMSPIC,HX,HY);
    END;
   END;
  END;
  IF AKTMOUSE<>NIL THEN
  BEGIN
   DIRECT_PUTPIC(OLDMOUSEX-HOTSPOTX,OLDMOUSEY-HOTSPOTY,MOUSESAV);
   DIRECT_GETPIC(MOUSEX-HOTSPOTX,MOUSEY-HOTSPOTY,MOUSESAV);
   DIRECT_PUTPICSPZ(MOUSEX-HOTSPOTX,MOUSEY-HOTSPOTY,AKTMOUSE);
  END;
  IF MOUSEFOC<>NIL THEN WITH MOUSEFOC^ DO
  BEGIN
   ONMOUSE(MOUSEX-GRWIN.ADDX+GRWIN.SUBX,MOUSEY-GRWIN.ADDY+GRWIN.SUBY,MOUSEB,MOUSEX,MOUSEY);
  END;
  OLDMOUSEX:=MOUSEX;
  OLDMOUSEY:=MOUSEY;
  OLDMOUSEB:=MOUSEB;
 END;
END;
PROCEDURE RUNWINENGINE;
BEGIN
 POLLKEYB;
 POLLMOUSE;
 IF REDRAWALL AND (MAINWIN<>NIL) THEN
 BEGIN
  REDRAWALL:=FALSE;
  MAINWIN^.PAINT;
  IF AKTMOUSE<>NIL THEN
  BEGIN
   ABS_GETPIC(OLDMOUSEX-HOTSPOTX,OLDMOUSEY-HOTSPOTY,MOUSESAV);
   ABS_PUTPICSPZ(OLDMOUSEX-HOTSPOTX,OLDMOUSEY-HOTSPOTY,AKTMOUSE);
  END;
  GRAPH.COPY(0);
 END;
END;
PROCEDURE TWIN.REDRAW;
BEGIN
 REDRAWALL:=REDRAWALL OR GRWIN.VIS;
END;
PROCEDURE TWIN.ONPAINT;
BEGIN
END;
PROCEDURE TWIN.ONMOUSE(PX,PY:LONGINT;PB:DWORD;AX,AY:LONGINT);
BEGIN
END;
PROCEDURE TWIN.ONSELECT(FOC:BOOLEAN);
BEGIN
END;
PROCEDURE TWIN.ONUNSELECT;
BEGIN
END;
PROCEDURE TWIN.ONDONE;
BEGIN
END;
DESTRUCTOR TWIN.DONE;
VAR P,P2:PWIN;
BEGIN
 WRITELN('Done (',DWORD(@SELF),')');
 IF MOUSEFOC=@SELF THEN MOUSEFOC:=NIL;
 IF OBJFOC=@SELF THEN OBJFOC:=NIL;
 IF MAINWIN=@SELF THEN MAINWIN:=NIL;
 P:=UNDER;
 WHILE P<>NIL DO
 BEGIN
  P2:=P^.NEXT;
  DISPOSE(P,DONE);
  P:=P2;
 END;
 ONDONE;
 IF NEXT<>NIL THEN NEXT^.LAST:=LAST ELSE IF OVER<>NIL THEN OVER^.UNDERL:=LAST;
 IF LAST<>NIL THEN LAST^.NEXT:=NEXT ELSE IF OVER<>NIL THEN OVER^.UNDER:=NEXT;
 IF INEXT<>NIL THEN INEXT^.ILAST:=ILAST ELSE IF OVER<>NIL THEN OVER^.IUNDERL:=ILAST;
 IF ILAST<>NIL THEN ILAST^.INEXT:=INEXT ELSE IF OVER<>NIL THEN OVER^.IUNDER:=INEXT;
END;
CONSTRUCTOR TWIN.INIT(BAS,GR:PWIN;PX,PY:LONGINT;PH,PB:DWORD;VISI:BOOLEAN;GT:DWORD);
BEGIN
 WRITELN(CRSTR,'Create TWin (',DWORD(@SELF),') : ',PX,':',PY,'  ',PH,'*',PB);
 CRLEA;
 WHILE (GR<>NIL) AND (GR^.GROUP<>NIL) DO GR:=GR^.GROUP;
 WHILE (GR<>NIL) AND (GR^.APPFRAME<>NIL) DO GR:=GR^.APPFRAME;
 IF BAS<>NIL THEN WHILE BAS^.APPFRAME<>NIL DO BAS:=BAS^.APPFRAME;
 X:=PX;
 Y:=PY;
 H:=PH;
 B:=PB;
 VIS:=VISI;
 LAST:=NIL;
 OVER:=BAS;
 UNDER:=NIL;
 IUNDER:=NIL;
 IUNDERL:=NIL;
 UNDERL:=NIL;
 GROUP:=GR;
 GTYP:=GT;
 IF BAS=NIL THEN
 BEGIN
  NEXT:=NIL;
  INEXT:=NIL;
  ILAST:=NIL;
  MAINWIN:=@SELF;
  CREATEABSWIN(PX,PY,PH,PB,VISI,GRWIN);
 END
 ELSE
 BEGIN
  NEXT:=BAS^.UNDER;
  IF NEXT<>NIL THEN NEXT^.LAST:=@SELF ELSE BAS^.UNDERL:=@SELF;
  BAS^.UNDER:=@SELF;
  ILAST:=BAS^.IUNDERL;
  IF ILAST<>NIL THEN ILAST^.INEXT:=@SELF ELSE BAS^.IUNDER:=@SELF;
  BAS^.IUNDERL:=@SELF;
  CREATESUBWIN(BAS^.GRWIN,PX,PY,PH,PB,VISI,GRWIN);
 END;
 APPFRAME:=NIL;
 AKTSUB:=NIL;
 BLOCK:=FALSE;
 REDRAW;
END;
END.
