UNIT FILES;
{$I-}
INTERFACE
USES ALLBAS;
CONST BUFSIZE=32768;
TYPE PWFILE=^TWFILE;
     TWFILE=OBJECT
      CONSTRUCTOR INIT(FN:STRING);
      CONSTRUCTOR INITRU(FN:STRING;VAR CR:BOOLEAN);
      DESTRUCTOR DONE;
      PROCEDURE WRITE(D,C:DWORD);
      PROCEDURE WRITEB(VAR DATA;C:DWORD);
      PROCEDURE WRITE(D:DWORD);
      PROCEDURE WRITES(S:STRING);
      FUNCTION POSITION:DWORD;
      PROCEDURE FLUSH;
      PROCEDURE SEEK(P:DWORD);
      PROCEDURE SEEKB(P:DWORD);
      PRIVATE
      BPOS:DWORD;
      BUFPOS:DWORD;
      BUFFER:ARRAY[0..BUFSIZE SHR 2-1] OF DWORD;
      F:FILE;
     END;
TYPE PRFILE=^TRFILE;
     TRFILE=OBJECT
      CONSTRUCTOR INIT(FN:STRING);
      DESTRUCTOR DONE;
      FUNCTION READS:STRING;
      FUNCTION READ:DWORD;VIRTUAL;
      FUNCTION READ(C:DWORD):DWORD;
      PROCEDURE READ(VAR DATA;C:DWORD);
      FUNCTION POSITION:DWORD;
      PROCEDURE SEEK(P:DWORD);
      PROCEDURE SEEKB(P:DWORD);
      FUNCTION GETOLDFILESIZE:DWORD;
      PRIVATE
      FILESZ:DWORD;
      BPOS:DWORD;
      BUFPOS,BUFFILL:DWORD;
      BUFFER:ARRAY[0..BUFSIZE SHR 2-1] OF DWORD;
      F:FILE;
     END;
IMPLEMENTATION
FUNCTION TRFILE.GETOLDFILESIZE:DWORD;
BEGIN
 GETOLDFILESIZE:=FILESZ;
END;
PROCEDURE TWFILE.SEEKB(P:DWORD);
BEGIN
 FLUSH;
 SYSTEM.SEEK(F,P);
 BUFPOS:=0;
 BPOS:=P SHL 3;
END;
PROCEDURE TWFILE.SEEK(P:DWORD);
VAR R:DWORD;
BEGIN
 IF P<>BPOS THEN
 BEGIN
  FLUSH;
  SYSTEM.SEEK(F,P SHR 3);
  BUFPOS:=P AND 7;
  BPOS:=P;
 END;
END;
PROCEDURE TWFILE.FLUSH;
BEGIN
 IF BUFPOS<>0 THEN
 BEGIN
  BLOCKWRITE(F,BUFFER,(BUFPOS SHR 3)+ORD(BUFPOS AND 7<>0));
  FILLCHAR(BUFFER,BUFSIZE*4,0);
  BUFPOS:=0;
 END;
END;
PROCEDURE TWFILE.WRITEB(VAR DATA;C:DWORD);
VAR I:DWORD;
    C32:DWORD;
BEGIN
 C32:=C SHR 5;
 I:=0;
 WHILE C32<>0 DO
 BEGIN
  WRITE(TDWORDARR(DATA)[I],32);
  INC(I);
  DEC(C32);
 END;
 IF C AND 31<>0 THEN WRITE(TDWORDARR(DATA)[I],C AND 31);
END;
PROCEDURE TWFILE.WRITES(S:STRING);
VAR I:DWORD;
BEGIN
 WRITE(BYTE(S[0]),8);
 FOR I:=1 TO LENGTH(S) DO WRITE(BYTE(S[I]),8);
END;
PROCEDURE TWFILE.WRITE(D,C:DWORD);
VAR I:DWORD;
BEGIN
 IF C=0 THEN EXIT;
 FOR I:=0 TO C-1 DO WRITE(D SHR I);
END;
FUNCTION TWFILE.POSITION:DWORD;
BEGIN
 POSITION:=BPOS;
END;
PROCEDURE TWFILE.WRITE(D:DWORD);
VAR BP:DWORD;
BEGIN
 BP:=BUFPOS SHR 5;
 BUFFER[BP]:=BUFFER[BP] OR (D AND 1) SHL (BUFPOS AND 31);
 INC(BUFPOS);
 IF BUFPOS>=DWORD(BUFSIZE)*8 THEN FLUSH;
 INC(BPOS);
END;
CONSTRUCTOR TWFILE.INITRU(FN:STRING;VAR CR:BOOLEAN);
BEGIN
 ASSIGN(F,FN);
 RESET(F,1);
 IF IORESULT<>0 THEN
 BEGIN
  REWRITE(F,1);
  IF IORESULT<>0 THEN FAIL;
  CLOSE(F);
  RESET(F,1);
  CR:=TRUE;
 END ELSE CR:=FALSE;
 FILLCHAR(BUFFER,BUFSIZE*4,0);
 BUFPOS:=0;
 BPOS:=0;
END;
CONSTRUCTOR TWFILE.INIT(FN:STRING);
BEGIN
 ASSIGN(F,FN);
 REWRITE(F,1);
 FILLCHAR(BUFFER,BUFSIZE*4,0);
 IF IORESULT<>0 THEN FAIL;
 BUFPOS:=0;
 BPOS:=0;
END;
DESTRUCTOR TWFILE.DONE;
BEGIN
 FLUSH;
 CLOSE(F);
END;
PROCEDURE TRFILE.SEEK(P:DWORD);
VAR R:DWORD;
BEGIN
 R:=BPOS-BUFPOS;
 IF (P>=R) AND (P<R+BUFFILL*8) THEN
 BEGIN
  BUFPOS:=(P-R);
 END
 ELSE
 BEGIN
  SYSTEM.SEEK(F,P SHR 3);
  BLOCKREAD(F,BUFFER,BUFSIZE,BUFFILL);
  BUFPOS:=P AND 7;
 END;
 BPOS:=P;
END;
PROCEDURE TRFILE.SEEKB(P:DWORD);
VAR R:DWORD;
BEGIN
 SYSTEM.SEEK(F,P);
 BLOCKREAD(F,BUFFER,BUFSIZE,BUFFILL);
 BUFPOS:=0;
 BPOS:=P SHL 3;
END;
FUNCTION TRFILE.POSITION:DWORD;
BEGIN
 POSITION:=BPOS;
END;
FUNCTION TRFILE.READS:STRING;
VAR I:DWORD;
BEGIN
 READS[0]:=CHAR(READ(8));
 FOR I:=1 TO BYTE(READS[0]) DO READS[I]:=CHAR(READ(8));
END;
PROCEDURE TRFILE.READ(VAR DATA;C:DWORD);
VAR I:DWORD;
    C32:DWORD;
BEGIN
 C32:=C SHR 5;
 I:=0;
 WHILE C32<>0 DO
 BEGIN
  TDWORDARR(DATA)[I]:=READ(32);
  INC(I);
  DEC(C32);
 END;
 IF C AND 31<>0 THEN TDWORDARR(DATA)[I]:=READ(C AND 31);
END;
FUNCTION TRFILE.READ(C:DWORD):DWORD;
VAR I:DWORD;
BEGIN
 READ:=0;
 I:=0;
 WHILE C<>0 DO
 BEGIN
  READ:=READ OR (TRFILE.READ SHL I);
  DEC(C);
  INC(I);
 END;
END;
FUNCTION TRFILE.READ:DWORD;
BEGIN
 READ:=(BUFFER[BUFPOS SHR 5] SHR (BUFPOS AND 31)) AND 1;
 INC(BUFPOS);
 IF BUFPOS>=BUFFILL*8 THEN
 BEGIN
  BLOCKREAD(F,BUFFER,BUFSIZE,BUFFILL);
  BUFPOS:=0;
 END;
 INC(BPOS);
END;
DESTRUCTOR TRFILE.DONE;
BEGIN
 CLOSE(F);
END;
CONSTRUCTOR TRFILE.INIT(FN:STRING);
BEGIN
 ASSIGN(F,FN);
 RESET(F,1);
 FILESZ:=FILESIZE(F);
 IF IORESULT<>0 THEN FAIL;
 BUFPOS:=0;
 BLOCKREAD(F,BUFFER,BUFSIZE,BUFFILL);
 BPOS:=0;
END;
END.