UNIT MENGEN;
INTERFACE
TYPE PMENGE=^TMENGE;
     TMENGE=OBJECT
      PROCEDURE DISPLAY;
      PROCEDURE RESET(A,E:LONGINT);
      PROCEDURE REDUCE(A,E:LONGINT);
      PROCEDURE DELETE(NR:DWORD);
      FUNCTION SIZE:DWORD;
      FUNCTION CODE(W:LONGINT):DWORD;
      FUNCTION DECODE(W:DWORD):LONGINT;
      PROCEDURE EXCLUDE(A,E:LONGINT);
      PRIVATE
      COUNT:DWORD;
      INTL:ARRAY[0..7] OF LONGINT;
      INTH:ARRAY[0..7] OF LONGINT;
     END;
IMPLEMENTATION
PROCEDURE TMENGE.DISPLAY;
VAR I:DWORD;
BEGIN
 WRITELN('INTV');
 FOR I:=0 TO COUNT-1 DO
 BEGIN
  WRITELN(I+1:3,' : ',INTL[I],'..',INTH[I]);
 END;
END;
FUNCTION TMENGE.DECODE(W:DWORD):LONGINT;
VAR I:DWORD;
BEGIN
 I:=0;
 WHILE I<COUNT DO
 BEGIN
  IF (W>INTH[I]-INTL[I]) THEN DEC(W,INTH[I]-INTL[I]+1) ELSE
  BEGIN
   DECODE:=W+INTL[I];
   EXIT;
  END;
 END;
END;
FUNCTION TMENGE.CODE(W:LONGINT):DWORD;
VAR I:DWORD;
BEGIN
 I:=0;
 CODE:=0;
 WHILE I<COUNT DO
 BEGIN
  IF (W>=INTL[I]) AND (W<=INTH[I]) THEN
  BEGIN
   INC(CODE,(W-INTL[I]));
   EXIT;
  END ELSE INC(CODE,INTH[I]-INTL[I]+1);
  INC(I);
 END;
END;
FUNCTION TMENGE.SIZE:DWORD;
VAR I:DWORD;
BEGIN
 SIZE:=0;
 FOR I:=0 TO COUNT-1 DO
 BEGIN
  SIZE:=SIZE+(INTH[I]-INTL[I]+1);
 END;
END;
PROCEDURE TMENGE.DELETE(NR:DWORD);
VAR I:DWORD;
BEGIN
 IF COUNT=1 THEN
 BEGIN
  WRITELN('Upps-> Nothing left...');
  HALT;
 END;
 FOR I:=NR TO COUNT-2 DO
 BEGIN
  INTL[I]:=INTL[I+1];
  INTH[I]:=INTH[I+1];
 END;
 DEC(COUNT);
 IF COUNT=0 THEN
 BEGIN
  WRITELN('Achtung, eine Menge wurde leer !');
 END;
END;
PROCEDURE TMENGE.REDUCE(A,E:LONGINT);
VAR I:DWORD;
BEGIN
 I:=0;
 REPEAT
  { Liegt das Intervall ganz wo anders ? }
  IF (INTL[I]>E) OR (INTH[I]<A) THEN
  BEGIN
   { Lschen }
   DELETE(I);
  END
  ELSE
  BEGIN
   { Sonst mu das Intervall nur beschnitten werden ! }
   { Die Intervalle berschneiden sich, daher }
   IF INTL[I]<A THEN INTL[I]:=A;
   IF INTH[I]>E THEN INTH[I]:=E;
   INC(I);
  END;
 UNTIL I=COUNT;
END;
PROCEDURE TMENGE.EXCLUDE(A,E:LONGINT);
VAR I,C:DWORD;
BEGIN
{ WRITELN('Exclude ',A,'..',E);}
 C:=COUNT; { Es ist nicht notwendig, neue Intervalle zu prfen ! }
 I:=0;
 WHILE I<C DO
 BEGIN
  IF ((A>=INTL[I]) AND (A<=INTH[I])) OR
     ((E>=INTL[I]) AND (E<=INTH[I])) THEN
  BEGIN
   { Ok, das Intervall wird angetastet }
   IF (A>INTL[I]) THEN
   BEGIN
    { Ok, damit wird das Intervall 1 von INTL[I]..A-1 gehen, wann kommt
      ein neues hinzu ? Wenn E<INTH[I] !!!}
    IF E<INTH[I] THEN
    BEGIN
     { Dieses Intervall mu von E+1..INTH[I] gehen ! }
     WRITELN('Add Intervall : ',E+1,'...',INTH[I]);
     INTL[COUNT]:=E+1;
     INTH[COUNT]:=INTH[I];
     INC(COUNT);
     INTH[I]:=A-1;
    END;
   END
   ELSE
   BEGIN
    { Es gibt kein unteres Intervall hier, da A<=INTL[I] }
    { Wann bleibt oben etwas brig ? E<INTH[I] }
    IF E<INTH[I] THEN
    BEGIN
     INTL[I]:=E+1;
    END
    ELSE
    BEGIN
     { Alles Weg ? }
     WRITELN('EXCLUDE\DELETE Nr.',I,' (',INTL[I],'..',INTH[I],')');
     DELETE(I);
     DEC(C);
     DEC(I);
    END;
   END;
  END;
  INC(I);
 END;
END;
PROCEDURE TMENGE.RESET(A,E:LONGINT);
BEGIN
 COUNT:=1;
 INTL[0]:=A;
 INTH[0]:=E;
END;
END.
