UNIT PICSTD;
INTERFACE
{ Achtung : BMP_LOAD ist nicht Streamfhig, da SEEK ntig ist ! }
{$I-}
IMPLEMENTATION
USES PICBAS,FILES;
FUNCTION RGB_SAVE(P:PEPICTURE;F:PWFILE):BOOLEAN;
VAR I,N,HI,WI:DWORD;
BEGIN
 WITH P^ DO
 BEGIN
  HI:=GETHEIGHT;
  WI:=GETWIDTH;
  F^.WRITE(HI,32);
  F^.WRITE(WI,32);
  FOR I:=0 TO HI-1 DO
  BEGIN
   FOR N:=0 TO WI-1 DO
   BEGIN
    F^.WRITE(GETPIXEL(N,I),32);
   END;
  END;
 END;
 RGB_SAVE:=TRUE;
END;
FUNCTION RGB_LOAD(P:PEPICTURE;F:PRFILE):BOOLEAN;
VAR I,N,HI,WI:DWORD;
BEGIN
 WITH P^ DO
 BEGIN
  F^.READ(HI,32);
  F^.READ(WI,32);
  ALLOCATE(HI,WI);
  FOR I:=0 TO HI-1 DO
  BEGIN
   FOR N:=0 TO WI-1 DO
   BEGIN
    PUTPIXEL(N,I,F^.READ(32));
   END;
  END;
 END;
 RGB_LOAD:=TRUE;
END;
TYPE BITMAPFILEHEADER=RECORD
      BFTYPE:WORD; {Should be $4D42}
      FILESZ:LONGINT;
      RES1:LONGINT;
      BITSTART:WORD;
      RES2:LONGINT;
      RES3:WORD;
     END;
TYPE BITMAPINFOHEADER=RECORD
      WIDTH:LONGINT;
      HEIGHT:LONGINT;
      BITPLANES:WORD;
      BPC:WORD;
      COMPR:LONGINT;
      BMPSZ:LONGINT;
      HRES,VRES:LONGINT;
      USEDCOLORS:LONGINT;
      IMPORTCOL:WORD;
      RES1:WORD;
     END;
FUNCTION BMP_SAVE(P:PEPICTURE;F:PWFILE):BOOLEAN;
VAR FILEHEADER:BITMAPFILEHEADER;
    INFOHEADER:BITMAPINFOHEADER;
    C,I,N,REST,HI,WI:DWORD;
BEGIN
 WITH P^ DO
 BEGIN
  HI:=GETHEIGHT;
  WI:=GETWIDTH;
  INFOHEADER.BMPSZ:=HI*(WI*3+WI MOD 4);
  FILEHEADER.BFTYPE:=$4D42;
  FILEHEADER.FILESZ:=SIZEOF(FILEHEADER)+SIZEOF(INFOHEADER)+INFOHEADER.BMPSZ;
  FILEHEADER.BITSTART:=SIZEOF(FILEHEADER)+SIZEOF(INFOHEADER);
  FILEHEADER.RES1:=0;
  FILEHEADER.RES2:=2621440;
  FILEHEADER.RES3:=0;
  INFOHEADER.BITPLANES:=1;
  INFOHEADER.BPC:=24;
  INFOHEADER.HEIGHT:=HI;
  INFOHEADER.WIDTH:=WI;
  INFOHEADER.HRES:=0;
  INFOHEADER.VRES:=0;
  INFOHEADER.USEDCOLORS:=0;
  INFOHEADER.IMPORTCOL:=0;
  INFOHEADER.RES1:=0;
  INFOHEADER.COMPR:=0;
  F^.WRITEB(FILEHEADER,SIZEOF(FILEHEADER)*8);
  F^.WRITEB(INFOHEADER,SIZEOF(INFOHEADER)*8);
  REST:=(WI MOD 4)*8;
  FOR I:=HI-1 DOWNTO 0 DO
  BEGIN
   FOR N:=0 TO WI-1 DO
   BEGIN
    C:=GETPIXEL(N,I);
    F^.WRITE(C SHR 16,8);
    F^.WRITE(C SHR 8,8);
    F^.WRITE(C,8);
   END;
   F^.WRITE(0,REST);
  END;
 END;
 BMP_SAVE:=TRUE;
END;
FUNCTION BMP_LOAD(P:PEPICTURE;F:PRFILE):BOOLEAN;
VAR FILEHEADER:BITMAPFILEHEADER;
    INFOHEADER:BITMAPINFOHEADER;
    I,N,REST,HI,WI:DWORD;
BEGIN
 WITH P^ DO
 BEGIN
  F^.READ(FILEHEADER,SIZEOF(FILEHEADER)*8);
  IF FILEHEADER.BFTYPE=$4D42 THEN
  BEGIN
   F^.READ(INFOHEADER,SIZEOF(INFOHEADER)*8);
   CASE INFOHEADER.BPC OF
    24:
    BEGIN
     HI:=INFOHEADER.HEIGHT;
     WI:=INFOHEADER.WIDTH;
     ALLOCATE(HI,WI);
     REST:=(WI MOD 4)*8;
     F^.SEEK(FILEHEADER.BITSTART*8);
     FOR I:=HI-1 DOWNTO 0 DO
     BEGIN
      FOR N:=0 TO WI-1 DO
      BEGIN
       PUTPIXEL(N,I,(F^.READ(8) SHL 16)+(F^.READ(8) SHL 8)+F^.READ(8));
      END;
      F^.READ(REST);
     END;
     BMP_LOAD:=TRUE;
    END;
    ELSE BMP_LOAD:=FALSE;
   END;
  END ELSE BMP_LOAD:=FALSE;
 END;
END;
BEGIN
 REGISTERFORMAT('.BMP',@BMP_LOAD,@BMP_SAVE);
 REGISTERFORMAT('.RGB',@RGB_LOAD,@RGB_SAVE);
END.
