UNIT PICWIN;
INTERFACE
USES WINBAS,PICBAS,WINSTD,GRAPH,DOS;
{$I END.INC}
{$I FULLIMG.INC}
TYPE PPICTUREFIELDF=^TPICTUREFIELDF;
     PPICTUREFIELD=^TPICTUREFIELD;
     TPICTUREFIELDF=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PDESKTOP;SCR:PPICTUREFIELD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE ONKEY(C,C2:CHAR);VIRTUAL;
      PRIVATE
      PICF:PPICTUREFIELD;
     END;
     TPICTUREFIELD=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;BCL:DWORD;DSK:PDESKTOP);
      PROCEDURE ONDONE;VIRTUAL;
      PROCEDURE ONPAINT;VIRTUAL;
      FUNCTION LOAD(FN:STRING):BOOLEAN;
      PROCEDURE ONRESIZE;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE FULLSCR;
      PROCEDURE NORMALSCR;
      PROCEDURE SETPIXX(R:REAL);
      FUNCTION GETPIXX:REAL;
      PROCEDURE SETCOLORM(R,G,B:DWORD);
      PROCEDURE GETCOLORM(VAR R,G,B:DWORD);
      PRIVATE
      PIXX:REAL;
      STAT:DWORD;
      BACKCOLOR:DWORD;
      PIC:PEPICTURE;
      FULL:PPICTUREFIELDF;
      SX,SY:LONGINT;
      SH,SB:DWORD;
      ZOOMING:BOOLEAN;
      BX,BY:LONGINT;
      ZOOMX,ZOOMY:LONGINT;
      ZOOMH,ZOOMB:DWORD;
      DESK:PDESKTOP;
      PROCEDURE RELOADBUF;
     END;
TYPE PPICTUREVIEW=^TPICTUREVIEW;
     PPICTUREVIEW_COLORCONTR=^TPICTUREVIEW_COLORCONTR;
     PPICTUREVIEW_COLORCONTR_W=^TPICTUREVIEW_COLORCONTR_W;
     PPICTUREVIEW_COLORCONTR_C=^TPICTUREVIEW_COLORCONTR_C;
     TPICTUREVIEW_COLORCONTR_C=OBJECT(TCOLORPERCONTROL)
      CONSTRUCTOR INIT(BAS:PPICTUREVIEW_COLORCONTR_W;V:PPICTUREVIEW);
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      VIEW:PPICTUREVIEW;
     END;
     TPICTUREVIEW_COLORCONTR_W=OBJECT(TWINDOW)
      CONSTRUCTOR INIT(BAS:PPICTUREVIEW_COLORCONTR;V:PPICTUREVIEW);
      PROCEDURE ONDONE;VIRTUAL;
      FUNCTION CANCLOSE:BOOLEAN;VIRTUAL;
      PRIVATE
      COLORCONTR:PPICTUREVIEW_COLORCONTR;
      CONTR:PPICTUREVIEW_COLORCONTR_C;
      VIEW:PPICTUREVIEW;
     END;
     TPICTUREVIEW_COLORCONTR=OBJECT(TBUTTON)
      CONSTRUCTOR INIT(BAS:PPICTUREVIEW);
      PROCEDURE ONCLICK;VIRTUAL;
      PROCEDURE ONDONE;VIRTUAL;
      PRIVATE
      WINDOW:PPICTUREVIEW_COLORCONTR_W;
      VIEW:PPICTUREVIEW;
     END;
     PPICTUREVIEW_BACKGROUND=^TPICTUREVIEW_BACKGROUND;
     PPICTUREVIEW_BACKGROUND_C=^TPICTUREVIEW_BACKGROUND_C;
     PPICTUREVIEW_BACKGROUND_W=^TPICTUREVIEW_BACKGROUND_W;
     TPICTUREVIEW_BACKGROUND_C=OBJECT(TCOLORCONTROL)
      CONSTRUCTOR INIT(BAS:PPICTUREVIEW_BACKGROUND_W;V:PPICTUREVIEW);
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      VIEW:PPICTUREVIEW;
     END;
     TPICTUREVIEW_BACKGROUND_W=OBJECT(TWINDOW)
      CONSTRUCTOR INIT(BAS:PPICTUREVIEW_BACKGROUND;V:PPICTUREVIEW);
      PROCEDURE ONDONE;VIRTUAL;
      FUNCTION CANCLOSE:BOOLEAN;VIRTUAL;
      PRIVATE
      BACKGR:PPICTUREVIEW_BACKGROUND;
      CONTR:PPICTUREVIEW_BACKGROUND_C;
      VIEW:PPICTUREVIEW;
     END;
     TPICTUREVIEW_BACKGROUND=OBJECT(TBUTTON)
      CONSTRUCTOR INIT(BAS:PPICTUREVIEW);
      PROCEDURE ONCLICK;VIRTUAL;
      PROCEDURE ONDONE;VIRTUAL;
      PRIVATE
      WINDOW:PPICTUREVIEW_BACKGROUND_W;
      VIEW:PPICTUREVIEW;
     END;
     PPICTUREVIEW_BE=^TPICTUREVIEW_BE;
     PPICTUREVIEW_BF=^TPICTUREVIEW_BF;
     PPICTUREVIEW_FS=^TPICTUREVIEW_FS;
     TPICTUREVIEW_FS=OBJECT(TFILEDIRBOX)
      CONSTRUCTOR INIT(BAS:PPICTUREVIEW;DIR:STRING);
      PROCEDURE ONSELECTFILE(NAME:STRING);VIRTUAL;
      PRIVATE
      VIEW:PPICTUREVIEW;
     END;
     TPICTUREVIEW_BE=OBJECT(TBUTTON)
      CONSTRUCTOR INIT(BAS:PPICTUREVIEW);
      PROCEDURE ONCLICK;VIRTUAL;
      PRIVATE
      VIEW:PPICTUREVIEW;
     END;
     TPICTUREVIEW_BF=OBJECT(TBUTTON)
      CONSTRUCTOR INIT(BAS:PPICTUREVIEW);
      PROCEDURE ONCLICK;VIRTUAL;
      PRIVATE
      VIEW:PPICTUREVIEW;
     END;
     TPICTUREVIEW=OBJECT
      ONSIGNAL_ENDP:PROCEDURE(SENDER:PPICTUREVIEW);
      CONSTRUCTOR INIT(DESK:PDESKTOP;DIR:STRING;F:PFONT);
      PROCEDURE ONSIGNAL_END;VIRTUAL;
      PROCEDURE SETPIXX(R:REAL);
      FUNCTION LOAD(FN:STRING):BOOLEAN;
      PRIVATE
      DESKTOP:PDESKTOP;
      CURDIR:STRING;
      PATHONLY,FILEONLY,EXTONLY:STRING;
      BAR:PLABEL;
      B_ENDE:PPICTUREVIEW_BE;
      B_FULLSCR:PPICTUREVIEW_BF;
      LISTB:PPICTUREVIEW_FS;
      PICF:PPICTUREFIELD;
      FONT:PFONT;
      BX:DWORD;
      REDM,GREENM,BLUEM:DWORD;
      FUNCTION GETBARX:DWORD;
     END;
IMPLEMENTATION
PROCEDURE TPICTUREVIEW_COLORCONTR_C.ONCHANGE;
VAR R,G,B:DWORD;
BEGIN
 R:=GETREDV;
 G:=GETGREENV;
 B:=GETBLUEV;
 VIEW^.PICF^.SETCOLORM(R,G,B);
END;
CONSTRUCTOR TPICTUREVIEW_COLORCONTR_C.INIT(BAS:PPICTUREVIEW_COLORCONTR_W;V:PPICTUREVIEW);
VAR R,G,B:DWORD;
BEGIN
 INHERITED INIT(BAS,0,0,60,222,TRUE,V^.FONT);
 VIEW:=V;
 V^.PICF^.GETCOLORM(R,G,B);
 SETCOLOR(0,B);
 SETCOLOR(8,G);
 SETCOLOR(16,R);
END;
PROCEDURE TPICTUREVIEW_COLORCONTR_W.ONDONE;
BEGIN
 COLORCONTR^.WINDOW:=NIL;
END;
FUNCTION TPICTUREVIEW_COLORCONTR_W.CANCLOSE:BOOLEAN;
BEGIN
 HIDE;
 CANCLOSE:=FALSE;
END;
CONSTRUCTOR TPICTUREVIEW_COLORCONTR_W.INIT(BAS:PPICTUREVIEW_COLORCONTR;V:PPICTUREVIEW);
BEGIN
 INHERITED INIT(V^.DESKTOP^.ONTOP,V^.DESKTOP^.GETB DIV 2-115,V^.DESKTOP^.GETH DIV 2-46,93,230,FALSE,'Farbkomponenten',FALSE,V^.FONT);
 VIEW:=V;
 COLORCONTR:=BAS;
 NEW(CONTR,INIT(@SELF,V));
END;
PROCEDURE TPICTUREVIEW_BACKGROUND_C.ONCHANGE;
BEGIN
 VIEW^.PICF^.BACKCOLOR:=CONV(GETCOLOR);
 VIEW^.PICF^.REDRAW;
END;
PROCEDURE TPICTUREVIEW_COLORCONTR.ONCLICK;
BEGIN
 IF WINDOW<>NIL THEN WINDOW^.INVERTVIS;
END;
PROCEDURE TPICTUREVIEW_COLORCONTR.ONDONE;
BEGIN
 IF WINDOW<>NIL THEN DISPOSE(WINDOW,DONE);
END;
CONSTRUCTOR TPICTUREVIEW_COLORCONTR.INIT(BAS:PPICTUREVIEW);
BEGIN
 INHERITED INIT(BAS^.BAR,NIL,BAS^.GETBARX,0,25,25,TRUE,'CC',NIL,BAS^.FONT);
 VIEW:=BAS;
 NEW(WINDOW,INIT(@SELF,BAS));
END;
CONSTRUCTOR TPICTUREVIEW_BACKGROUND_C.INIT(BAS:PPICTUREVIEW_BACKGROUND_W;V:PPICTUREVIEW);
BEGIN
 INHERITED INIT(BAS,0,0,60,212,TRUE,V^.FONT);
 VIEW:=V;
 SETCOLOR(V^.PICF^.BACKCOLOR);
END;
CONSTRUCTOR TPICTUREVIEW_BACKGROUND_W.INIT(BAS:PPICTUREVIEW_BACKGROUND;V:PPICTUREVIEW);
BEGIN
 INHERITED INIT(V^.DESKTOP^.ONTOP,V^.DESKTOP^.GETB DIV 2-110,V^.DESKTOP^.GETH DIV 2-46,93,220,FALSE,'Hintergrund',FALSE,V^.FONT);
 VIEW:=V;
 BACKGR:=BAS;
 NEW(CONTR,INIT(@SELF,V));
END;
FUNCTION TPICTUREVIEW_BACKGROUND_W.CANCLOSE:BOOLEAN;
BEGIN
 HIDE;
 CANCLOSE:=FALSE;
END;
PROCEDURE TPICTUREVIEW_BACKGROUND_W.ONDONE;
BEGIN
 BACKGR^.WINDOW:=NIL;
END;
PROCEDURE TPICTUREVIEW_BACKGROUND.ONDONE;
BEGIN
 IF WINDOW<>NIL THEN DISPOSE(WINDOW,DONE);
END;
PROCEDURE TPICTUREVIEW_BACKGROUND.ONCLICK;
BEGIN
 IF WINDOW<>NIL THEN WINDOW^.INVERTVIS;
END;
CONSTRUCTOR TPICTUREVIEW_BACKGROUND.INIT(BAS:PPICTUREVIEW);
BEGIN
 INHERITED INIT(BAS^.BAR,NIL,BAS^.GETBARX,0,25,25,TRUE,'BC',NIL,BAS^.FONT);
 VIEW:=BAS;
 NEW(WINDOW,INIT(@SELF,BAS));
END;
FUNCTION TPICTUREVIEW.GETBARX:DWORD;
BEGIN
 GETBARX:=BX;
 BX:=BX-25;
END;
PROCEDURE TPICTUREVIEW.SETPIXX(R:REAL);
BEGIN
 PICF^.SETPIXX(R);
END;
PROCEDURE TPICTUREVIEW_BF.ONCLICK;
BEGIN
 VIEW^.PICF^.FULLSCR;
END;
CONSTRUCTOR TPICTUREVIEW_BF.INIT(BAS:PPICTUREVIEW);
BEGIN
 INHERITED INIT(BAS^.BAR,NIL,BAS^.BAR^.GETB-75,0,25,25,TRUE,'',CONVPIC(@PICD_FULLIMG),BAS^.FONT);
 VIEW:=BAS;
END;
PROCEDURE TPICTUREVIEW_BE.ONCLICK;
BEGIN
 VIEW^.ONSIGNAL_END;
END;
PROCEDURE TPICTUREVIEW.ONSIGNAL_END;
BEGIN
 IF ONSIGNAL_ENDP<>NIL THEN ONSIGNAL_ENDP(@SELF);
END;
CONSTRUCTOR TPICTUREVIEW_BE.INIT(BAS:PPICTUREVIEW);
BEGIN
 INHERITED INIT(BAS^.BAR,NIL,BAS^.BAR^.GETB-25,0,25,25,TRUE,'',CONVPIC(@PICD_END),BAS^.FONT);
 VIEW:=BAS;
END;
PROCEDURE TPICTUREVIEW_FS.ONSELECTFILE(NAME:STRING);
BEGIN
 VIEW^.LOAD(NAME);
END;
CONSTRUCTOR TPICTUREVIEW_FS.INIT(BAS:PPICTUREVIEW;DIR:STRING);
BEGIN
 INHERITED INIT(BAS^.DESKTOP,0,0,BAS^.DESKTOP^.GETH,BAS^.DESKTOP^.GETB DIV 4,TRUE,DIR,BAS^.FONT);
 VIEW:=BAS;
END;
FUNCTION TPICTUREVIEW.LOAD(FN:STRING):BOOLEAN;
VAR H,B:DWORD;
    S1,S2:STRING;
BEGIN
 IF PICF^.LOAD(FN) THEN
 BEGIN
  H:=PICF^.PIC^.GETHEIGHT;
  B:=PICF^.PIC^.GETWIDTH;
  STR(H,S1);
  STR(B,S2);
  BAR^.SETCAPTION(#255+FN+' ('+S1+'*'+S2+')');
 END;
END;
CONSTRUCTOR TPICTUREVIEW.INIT(DESK:PDESKTOP;DIR:STRING;F:PFONT);
BEGIN
 FONT:=F;
 DESKTOP:=DESK;
 ONSIGNAL_ENDP:=NIL;
 NEW(BAR,INIT(DESK,NIL,DESK^.GETB DIV 4,DESK^.GETH-25,25,DESK^.GETB-DESK^.GETB DIV 4,TRUE,#255+'-.-',F));
 NEW(B_FULLSCR,INIT(@SELF));
 NEW(B_ENDE,INIT(@SELF));
 NEW(LISTB,INIT(@SELF,DIR));
 NEW(PICF,INIT(DESK,DESK,LISTB^.GETB,0,DESK^.GETH-25,DESK^.GETB-LISTB^.GETB,TRUE,CL_BLACK,DESK));
 BX:=BAR^.GETB-100;
END;
PROCEDURE TPICTUREFIELD.SETPIXX(R:REAL);
BEGIN
 IF R<>PIXX THEN
 BEGIN
  PIXX:=R;
  RELOADBUF;
 END;
END;
FUNCTION TPICTUREFIELD.GETPIXX:REAL;
BEGIN
 GETPIXX:=PIXX;
END;
PROCEDURE TPICTUREFIELD.NORMALSCR;
BEGIN
 IF (STAT=1) THEN
 BEGIN
  FULL^.HIDE;
  DESK^.NORMAL;
  SELECT;
  STAT:=0;
  RELOADBUF;
  REDRAW;
 END;
END;
PROCEDURE TPICTUREFIELD.FULLSCR;
BEGIN
 IF (FULL<>NIL) AND (STAT=0) THEN
 BEGIN
  STAT:=1;
  RELOADBUF;
  FULL^.SHOW;
  FULL^.SELECT;
  DESK^.MODAL;
 END;
END;
PROCEDURE TPICTUREFIELDF.ONKEY(C,C2:CHAR);
BEGIN
 CASE C OF
  #32:PICF^.NORMALSCR;
 END;
END;
PROCEDURE TPICTUREFIELDF.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
BEGIN
 PICF^.ONMOUSE(X,Y,B,AX,AY);
END;
PROCEDURE TPICTUREFIELDF.ONPAINT;
BEGIN
 BAR(0,0,GETH,GETB,PICF^.BACKCOLOR);
 PICF^.PIC^.SHOWCENTER(0,0,GETH,GETB);
 WITH PICF^ DO
 BEGIN
  IF ZOOMING THEN BARFTRA(ZOOMX,ZOOMY,ZOOMH,ZOOMB,CL_LBLUE,16384);
 END;
END;
CONSTRUCTOR TPICTUREFIELDF.INIT(BAS:PDESKTOP;SCR:PPICTUREFIELD);
BEGIN
 INHERITED INIT(BAS^.ONMODAL,NIL,0,0,BAS^.ONMODAL^.GETH,BAS^.ONMODAL^.GETB,FALSE,GT_STDOBJ);
 PICF:=SCR;
END;
PROCEDURE TPICTUREFIELD.RELOADBUF;
VAR H,B:DWORD;
BEGIN
 CASE STAT OF
  0:
  BEGIN
   H:=GETH;
   B:=GETB;
  END;
  1:
  BEGIN
   H:=FULL^.GETH;
   B:=FULL^.GETB;
  END;
 END;
 PIC^.BUFSMOOTHIDEAL(H,B,PIXX,SX,SY,SH,SB);
 REDRAW;
END;
PROCEDURE TPICTUREFIELD.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
VAR NX,NY:LONGINT;
    NH,NB:DWORD;
    HI,WI:DWORD;
BEGIN
 CASE STAT OF
  0:
  BEGIN
   HI:=GETH;
   WI:=GETB;
  END;
  1:
  BEGIN
   HI:=FULL^.GETH;
   WI:=FULL^.GETB;
  END;
 END;
 IF ZOOMING THEN
 BEGIN
  IF B=1 THEN
  BEGIN
   IF X<BX THEN
   BEGIN
    ZOOMX:=X;
    ZOOMB:=BX-X+1;
   END
   ELSE
   BEGIN
    ZOOMX:=BX;
    ZOOMB:=X-BX+1;
   END;
   IF Y<BY THEN
   BEGIN
    ZOOMY:=Y;
    ZOOMH:=BY-Y+1;
   END
   ELSE
   BEGIN
    ZOOMY:=BY;
    ZOOMH:=Y-BY+1;
   END;
   REDRAW;
  END
  ELSE
  BEGIN
   IF B=0 THEN
   BEGIN
    IF (ZOOMH<3) OR (ZOOMB<3) THEN
    BEGIN
     SX:=0;
     SY:=0;
     SH:=PIC^.GETHEIGHT;
     SB:=PIC^.GETWIDTH;
    END
    ELSE
    BEGIN
     PIC^.EXTRIDEAL(ZOOMX,ZOOMY,ZOOMH,ZOOMB,HI,WI,PIXX,SX,SY,SH,SB);
     SX:=ZOOMX;
     SY:=ZOOMY;
     SH:=ZOOMH;
     SB:=ZOOMB;
    END;
    RELOADBUF;
   END;
   ZOOMING:=FALSE;
   REDRAW;
  END;
 END
 ELSE
 BEGIN
  IF B=1 THEN
  BEGIN
   ZOOMING:=TRUE;
   BX:=X;
   BY:=Y;
   ZOOMX:=X;
   ZOOMY:=Y;
   ZOOMH:=1;
   ZOOMB:=1;
  END ELSE IF B=4 THEN
  BEGIN
   SX:=0;
   SY:=0;
   SH:=PIC^.GETHEIGHT;
   SB:=PIC^.GETWIDTH;
   RELOADBUF;
  END ELSE IF B=2 THEN
  BEGIN
   CASE STAT OF
    0:FULLSCR;
    1:NORMALSCR;
   END;
  END;
 END;
END;
PROCEDURE TPICTUREFIELD.ONDONE;
BEGIN
 DISPOSE(PIC,DESTROY);
END;
PROCEDURE TPICTUREFIELD.ONRESIZE;
BEGIN
 RELOADBUF;
END;
FUNCTION TPICTUREFIELD.LOAD(FN:STRING):BOOLEAN;
BEGIN
 LOAD:=PIC^.LOAD(FN);
 IF LOAD THEN
 BEGIN
  SX:=0;
  SY:=0;
  SH:=PIC^.GETHEIGHT;
  SB:=PIC^.GETWIDTH;
  RELOADBUF;
  REDRAW;
 END;
END;
PROCEDURE TPICTUREFIELD.ONPAINT;
BEGIN
 BAR(0,0,GETH,GETB,BACKCOLOR);
 PIC^.SHOWCENTER(0,0,GETH,GETB);
 IF ZOOMING THEN BARFTRA(ZOOMX,ZOOMY,ZOOMH,ZOOMB,CL_LBLUE,16384);
END;
PROCEDURE TPICTUREFIELD.SETCOLORM(R,G,B:DWORD);
BEGIN
 PIC^.SETCOLORM(R,G,B);
 RELOADBUF;
END;
PROCEDURE TPICTUREFIELD.GETCOLORM(VAR R,G,B:DWORD);
BEGIN
 PIC^.GETCOLORM(R,G,B);
END;
CONSTRUCTOR TPICTUREFIELD.INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;BCL:DWORD;DSK:PDESKTOP);
BEGIN
 WRITELN(CRSTR,'Create TPicturefield (',DWORD(@SELF),') :',X,':',Y,'  ',H,'*',B);
 IF GR=NIL THEN GR:=BAS;
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS,GT_NULL);
 CRLEA;
 NEW(PIC,CREATE);
 IF DSK=NIL THEN FULL:=NIL ELSE NEW(FULL,INIT(DSK,@SELF));
 BACKCOLOR:=BCL;
 STAT:=0;
 DESK:=DSK;
 PIXX:=1;
END;
END.
