UNIT WINSTD;
INTERFACE
USES ALLBAS,GRAPH,WINBAS,DOS;
CONST BT_OK=1;
      BT_YES=2;
      BT_NO=4;
      BT_RETRY=8;
      BT_IGNORE=16;
      BT_CANCEL=32;
TYPE PBUTTON=^TBUTTON;
     TBUTTON=OBJECT(TWIN)
      ONCLICKP:PROCEDURE(SENDER:PBUTTON);
      CONSTRUCTOR INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;
                       TXT:STRING;PI:GRAPH.PPICTURE;FON:PFONT);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE ONKEY(C,C2:CHAR);VIRTUAL;
      PROCEDURE ONCLICK;VIRTUAL;
      PROCEDURE ONSELECT(FOC:BOOLEAN);VIRTUAL;
      PROCEDURE ONUNSELECT;VIRTUAL;
      FUNCTION ISDOWN:BOOLEAN;
      PRIVATE
      FONT:PFONT;
      DOWN:BOOLEAN;
      CAPTION:STRING;
      PIC:GRAPH.PPICTURE;
     END;
TYPE PWINDOW_TITLE=^TWINDOW_TITLE;
     PWINDOW=^TWINDOW;
     PWINDOW_SIZE=^TWINDOW_SIZE;
     PWINDOW_CLOSEB=^TWINDOW_CLOSEB;
     TWINDOW_SIZE=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PWINDOW;T:DWORD);
      FUNCTION GETMOUSEPIC(VAR HX,HY:LONGINT):GRAPH.PPICTURE;VIRTUAL;
      PROCEDURE ADJUST;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PRIVATE
      MP:GRAPH.PPICTURE;
      MX,MY,BX,BY,OX,OY:LONGINT;
      TYP,OH,OB:DWORD;
      WINDOW:PWINDOW;
      SIZEING:BOOLEAN;
     END;
     TWINDOW_TITLE=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PWINDOW);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PRIVATE
      WINDOW:PWINDOW;
      DRAGGING:BOOLEAN;
      BX,BY,OX,OY:LONGINT;
     END;
     TWINDOW_CLOSEB=OBJECT(TBUTTON)
      CONSTRUCTOR INIT(BAS:PWINDOW);
      PROCEDURE ONCLICK;VIRTUAL;
      PROCEDURE ONPAINT;VIRTUAL;
      PRIVATE
      WINDOW:PWINDOW;
     END;
     TWINDOW=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;CAP:STRING;
                       SZ:BOOLEAN;F:PFONT);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONSELECT(FOC:BOOLEAN);VIRTUAL;
      PROCEDURE ONUNSELECT;VIRTUAL;
      PROCEDURE ONRESIZE;VIRTUAL;
      PROCEDURE CHECKSIZE(VAR H,B:DWORD);VIRTUAL;
      FUNCTION CANCLOSE:BOOLEAN;VIRTUAL;
      FUNCTION CLOSE:BOOLEAN;
      PRIVATE
      CLOSEBUTTON:PWINDOW_CLOSEB;
      APPF:PWIN;
      TITLE:PWINDOW_TITLE;
      FONT:PFONT;
      SIZEF:ARRAY[1..9] OF PWINDOW_SIZE;
      CAPTION:STRING;
      SIZEABLE:BOOLEAN;
      SELECTED:BOOLEAN;
     END;
TYPE PLABEL=^TLABEL;
     TLABEL=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;TXT:STRING;F:PFONT);
      CONSTRUCTOR INIT(BAS,GR:PWIN;X,Y:LONGINT;B:DWORD;VIS:BOOLEAN;TXT:STRING;F:PFONT);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE SETCAPTION(S:STRING);
      FUNCTION GETCAPTION:STRING;
      PRIVATE
      FONT:PFONT;
      CAPTION:STRING;
     END;
TYPE PVSCROLLBAR=^TVSCROLLBAR;
     TVSCROLLBAR=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SP,MP:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      FUNCTION GETPOS:DWORD;
      PROCEDURE SETPOS(W:DWORD);
      PROCEDURE ONCHANGE;VIRTUAL;
      PROCEDURE SIZE(H,B:DWORD);VIRTUAL;
      PROCEDURE SETRANGE(W:DWORD);
      PRIVATE
      POINTS:DWORD;
      POS:DWORD;
      BSTAT:DWORD;
      BARVIS:BOOLEAN;
      BARPOS:DWORD;
      BARSIZE:DWORD;
      MULTIPL:EXTENDED;
      OLDPOS:DWORD;
      PROCEDURE CALCBAR;
     END;
TYPE PHSCROLLBAR=^THSCROLLBAR;
     THSCROLLBAR=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SP,MP:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      FUNCTION GETPOS:DWORD;
      PROCEDURE SETPOS(W:DWORD);
      PROCEDURE ONCHANGE;VIRTUAL;
      PROCEDURE SIZE(H,B:DWORD);VIRTUAL;
      PROCEDURE SETRANGE(W:DWORD);
      PRIVATE
      POINTS:DWORD;
      POS:DWORD;
      BSTAT:DWORD;
      BARVIS:BOOLEAN;
      BARPOS:DWORD;
      BARSIZE:DWORD;
      MULTIPL:EXTENDED;
      OLDPOS:DWORD;
      PROCEDURE CALCBAR;
     END;
TYPE PINPUTLINE=^TINPUTLINE;
     TINPUTLINE=OBJECT(TWIN)
      ONRETURNP:PROCEDURE(SENDER:PINPUTLINE);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(MX,MY:LONGINT;MB:DWORD;ABX,ABY:LONGINT);VIRTUAL;
      PROCEDURE ONKEY(C1,C2:CHAR);VIRTUAL;
      PROCEDURE ONCHANGE;VIRTUAL;
      PROCEDURE ONRETURN;VIRTUAL;
      CONSTRUCTOR INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;F:PFONT);
      FUNCTION GETTEXT:STRING;
      PROCEDURE SETTEXT(S:STRING);
      PROCEDURE ONSELECT(FOC:BOOLEAN);VIRTUAL;
      PROCEDURE INSERTCHAR(C:CHAR);
      PROCEDURE DELETELAST;
      PROCEDURE GOTOPOS1;
      PROCEDURE GOTOLAST;
      PROCEDURE GOTONEXT;
      PROCEDURE GOTOEND;
      PROCEDURE GOTOP(X:DWORD);
      PROCEDURE DELETE;
      PRIVATE
      FONT:PFONT;
      CONT:STRING;
      CURX,CURS:LONGINT;
      PROCEDURE CALCCURX;
     END;
TYPE PMEMOF=^TMEMOF;
     PMEMO=^TMEMO;
     PMEMOV=^TMEMOV;
     PMEMOH=^TMEMOH;
     TMEMOV=OBJECT(TVSCROLLBAR)
      CONSTRUCTOR INIT(BAS:PMEMO;X,H:DWORD;VIS:BOOLEAN);
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      MEMO:PMEMO;
     END;
     TMEMOH=OBJECT(THSCROLLBAR)
      CONSTRUCTOR INIT(BAS:PMEMO;Y,B:DWORD;VIS:BOOLEAN);
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      MEMO:PMEMO;
     END;
     TMEMOF=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PMEMO;H,B:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PRIVATE
      MEMO:PMEMO;
     END;
     TMEMO=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SC:DWORD;F:PFONT);
      PROCEDURE ONDONE;VIRTUAL;
      PROCEDURE SIZE(H,B:DWORD);VIRTUAL;
      PROCEDURE CHECKSIZE(VAR H,B:DWORD);VIRTUAL;
      PROCEDURE ONKEY(C,C2:CHAR);VIRTUAL;
      PROCEDURE ONCHANGE;VIRTUAL;
      PROCEDURE ONNEWPOS(LIN,COL:DWORD);VIRTUAL;
      FUNCTION GETCOLUM:DWORD;
      FUNCTION GETLINE:DWORD;
      FUNCTION LOAD(FN:STRING):BOOLEAN;
      FUNCTION SAVE(FN:STRING):BOOLEAN;
      PROCEDURE CLEAR;
      PRIVATE
      FONT:PFONT;
      SCV:PMEMOV;
      SCH:PMEMOH;
      XSCROLL:LONGINT;
      E:PMEMOF;
      TEXT:PSTRINGLIST;
      SCB,SCRLINE,AKTLINE,AKTCOLUM:DWORD;
      MAXSCH:DWORD;
      PROCEDURE CALCSCROLL;
      PROCEDURE CALCSCH;
     END;
TYPE PMEMOWINF=^TMEMOWINF;
     PMEMOWIN=^TMEMOWIN;
     TMEMOWINF=OBJECT(TMEMO)
      CONSTRUCTOR INIT(BAS:PMEMOWIN;SC:DWORD;TF:PFONT);
      PROCEDURE ONCHANGE;VIRTUAL;
      PROCEDURE ONNEWPOS;VIRTUAL;
      PRIVATE
      MEMOWIN:PMEMOWIN;
     END;
     TMEMOWIN=OBJECT(TWINDOW)
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;TIT:STRING;
                       SZ:BOOLEAN;SCB:DWORD;F,TF:PFONT);
      PROCEDURE ONRESIZE;VIRTUAL;
      PROCEDURE CHECKSIZE(VAR H,B:DWORD);VIRTUAL;
      PROCEDURE ONCHANGE;VIRTUAL;
      PROCEDURE ONNEWPOS;VIRTUAL;
      FUNCTION GETLINE:DWORD;
      FUNCTION GETCOLUM:DWORD;
      FUNCTION LOAD(FN:STRING):BOOLEAN;
      FUNCTION SAVE(FN:STRING):BOOLEAN;
      PROCEDURE CLEAR;
      PRIVATE
      MEMO:PMEMOWINF;
     END;
TYPE PSTRLISTBOXF=^TSTRLISTBOXF;
     PSTRLISTBOX=^TSTRLISTBOX;
     PSTRLISTBOXV=^TSTRLISTBOXV;
     PSTRLISTBOXH=^TSTRLISTBOXH;
     TSTRLISTBOXV=OBJECT(TVSCROLLBAR)
      CONSTRUCTOR INIT(BAS:PSTRLISTBOX;X,H:DWORD;VIS:BOOLEAN);
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      STRLISTBOX:PSTRLISTBOX;
     END;
     TSTRLISTBOXH=OBJECT(THSCROLLBAR)
      CONSTRUCTOR INIT(BAS:PSTRLISTBOX;Y,B:DWORD;VIS:BOOLEAN);
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      STRLISTBOX:PSTRLISTBOX;
     END;
     TSTRLISTBOXF=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PSTRLISTBOX;H,B:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PRIVATE
      STRLISTBOX:PSTRLISTBOX;
     END;
     TSTRLISTBOX=OBJECT(TWIN)
      ONSELECTP:PROCEDURE(LIN:DWORD;SENDER:PSTRLISTBOX);
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SC:DWORD;F:PFONT);
      PROCEDURE SIZE(H,B:DWORD);VIRTUAL;
      PROCEDURE CHECKSIZE(VAR H,B:DWORD);VIRTUAL;
      PROCEDURE ONKEY(C,C2:CHAR);VIRTUAL;
      PROCEDURE ONSELECT(LIN:DWORD);VIRTUAL;
      FUNCTION GETLINE:DWORD;
      FUNCTION LOAD(FN:STRING):BOOLEAN;
      FUNCTION SAVE(FN:STRING):BOOLEAN;
      PROCEDURE SORT;
      PROCEDURE LOADDIR(BAS:STRING);
      PROCEDURE ONSELECT(FOC:BOOLEAN);VIRTUAL;
      PROCEDURE ONUNSELECT;VIRTUAL;
      FUNCTION READLINE(NR:DWORD):STRING;
      PROCEDURE ADDLINE(S:STRING);
      PRIVATE
      FONT:PFONT;
      SCV:PSTRLISTBOXV;
      SCH:PSTRLISTBOXH;
      XSCROLL:LONGINT;
      E:PSTRLISTBOXF;
      TEXT:PSTRINGLIST;
      SCB,SCRLINE,AKTLINE:DWORD;
      MAXSCH:DWORD;
      PROCEDURE CALCSCROLL;
      PROCEDURE CALCSCH;
     END;
TYPE PSTRLISTWINF=^TSTRLISTWINF;
     PSTRLISTWIN=^TSTRLISTWIN;
     TSTRLISTWINF=OBJECT(TSTRLISTBOX)
      CONSTRUCTOR INIT(BAS:PSTRLISTWIN;SC:DWORD;TF:PFONT);
      PROCEDURE ONSELECT(LIN:DWORD);VIRTUAL;
      PRIVATE
      STRLISTWIN:PSTRLISTWIN;
     END;
     TSTRLISTWIN=OBJECT(TWINDOW)
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;TIT:STRING;SZ:BOOLEAN;SCB:DWORD;F,TF:PFONT);
      PROCEDURE ONSELECT(LIN:DWORD);VIRTUAL;
      PROCEDURE ONRESIZE;VIRTUAL;
      PROCEDURE CHECKSIZE(VAR H,B:DWORD);VIRTUAL;
      FUNCTION GETLINE:DWORD;
      FUNCTION LOAD(FN:STRING):BOOLEAN;
      FUNCTION SAVE(FN:STRING):BOOLEAN;
      PROCEDURE SORT;
      PROCEDURE ADDLINE(S:STRING);
      PRIVATE
      STRLISTBOX:PSTRLISTWINF;
     END;
TYPE PBAR=^TBAR;
     TBAR=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;GT,COL:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PRIVATE
      COLOR:DWORD;
     END;
TYPE PDESKTOPM=^TDESKTOPM;
     PDESKTOP=^TDESKTOP;
     PDESKTOPB=^TDESKTOPB;
     TDESKTOPM=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PDESKTOP);
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PRIVATE
      DESKTOP:PDESKTOP;
     END;
     TDESKTOPB=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PDESKTOP);
      PROCEDURE ONPAINT;VIRTUAL;
      PRIVATE
      DESKTOP:PDESKTOP;
     END;
     TDESKTOP=OBJECT(TWIN)
      CONSTRUCTOR INIT(COL:DWORD);
      FUNCTION ONTOP:PWIN;
      FUNCTION ONMODAL:PWIN;
      PROCEDURE MODAL;
      PROCEDURE NORMAL;
      PROCEDURE SETCOLOR(COL:DWORD);
      PRIVATE
      BACKGR:PDESKTOPB;
      TOP:PWIN;
      MODALW:PDESKTOPM;
      COLOR:DWORD;
     END;
TYPE PSTRTREEVIEW=^TSTRTREEVIEW;
     PSTRTREEVIEWF=^TSTRTREEVIEWF;
     PSTRTREEVIEWV=^TSTRTREEVIEWV;
     PSTRTREEVIEWH=^TSTRTREEVIEWH;
     TSTRTREEVIEWV=OBJECT(TVSCROLLBAR)
      CONSTRUCTOR INIT(BAS:PSTRTREEVIEW;X:LONGINT;H:DWORD;VIS:BOOLEAN);
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      STRTREEVIEW:PSTRTREEVIEW;
     END;
     TSTRTREEVIEWH=OBJECT(THSCROLLBAR)
      CONSTRUCTOR INIT(BAS:PSTRTREEVIEW;Y:LONGINT;B:DWORD;VIS:BOOLEAN);
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      STRTREEVIEW:PSTRTREEVIEW;
     END;
     TSTRTREEVIEWF=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PSTRTREEVIEW;H,B:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PRIVATE
      STRTREEVIEW:PSTRTREEVIEW;
     END;
     TSTRTREEVIEW=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SC:DWORD;R:STRING;F:PFONT);
      PROCEDURE ONSELECT(P:PSTRTREENODE);VIRTUAL;
      PROCEDURE ONKEY(C,C2:CHAR);VIRTUAL;
      PROCEDURE ONDONE;VIRTUAL;
      PROCEDURE CLEAR;
      PROCEDURE LOADDIRS(BAS:STRING);
      PROCEDURE SORT;
      PROCEDURE CHECKSIZE(VAR H,B:DWORD);VIRTUAL;
      PROCEDURE SIZE(H,B:DWORD);VIRTUAL;
      PRIVATE
      TREE:PSTRTREE;
      SCRLINE:DWORD;
      SCB:DWORD;
      SCV:PSTRTREEVIEWV;
      SCH:PSTRTREEVIEWH;
      E:PSTRTREEVIEWF;
      AKTSEL:PSTRTREENODE;
      FONT:PFONT;
      MAXSCH:DWORD;
      XSCROLL:DWORD;
      PROCEDURE CALCSCROLL(M:BOOLEAN);
      PROCEDURE CALCSCH;
     END;
TYPE PSTRTREEWIN=^TSTRTREEWIN;
     PSTRTREEWINF=^TSTRTREEWINF;
     TSTRTREEWINF=OBJECT(TSTRTREEVIEW)
      CONSTRUCTOR INIT(BAS:PSTRTREEWIN;SC:DWORD;R:STRING;F:PFONT);
      PROCEDURE ONSELECT(P:PSTRTREENODE);VIRTUAL;
      PRIVATE
      STRTREEWIN:PSTRTREEWIN;
     END;
     TSTRTREEWIN=OBJECT(TWINDOW)
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;TIT:STRING;SZ:BOOLEAN;SC:DWORD;R:STRING;F,TF:PFONT);
      PROCEDURE ONRESIZE;VIRTUAL;
      PROCEDURE CHECKSIZE(VAR H,B:DWORD);VIRTUAL;
      PROCEDURE ONSELECT(P:PSTRTREENODE);VIRTUAL;
      PROCEDURE CLEAR;
      PROCEDURE SORT;
      PROCEDURE LOADDIRS(BAS:STRING);
      PRIVATE
      STRTREEVIEW:PSTRTREEWINF;
     END;
TYPE PCHECKBOX=^TCHECKBOX;
     TCHECKBOX=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;TXT:STRING;CHK:BOOLEAN;F:PFONT);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONSELECT(FOC:BOOLEAN);VIRTUAL;
      PROCEDURE ONUNSELECT;VIRTUAL;
      PROCEDURE ONCHANGE(STAT:BOOLEAN);VIRTUAL;
      PROCEDURE ONKEY(C,C2:CHAR);VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE DISABLE;
      PROCEDURE ENABLE;
      PRIVATE
      CHECK:BOOLEAN;
      CAPTION:STRING;
      FONT:PFONT;
      DOWN:BOOLEAN;
      ENABLED:BOOLEAN;
     END;
TYPE PRADIOGROUP=^TRADIOGROUP;
     PRADIOFIELD=^TRADIOFIELD;
     TRADIOGROUP=OBJECT
      CONSTRUCTOR INIT(LD:BOOLEAN);
      DESTRUCTOR DONE;
      PROCEDURE GOTOLAST;
      PROCEDURE GOTONEXT;
      PROCEDURE GOTOFIRST;
      PROCEDURE GOTOEND;
      PROCEDURE SELECT(P:PRADIOFIELD);
      PROCEDURE ONCHANGE;VIRTUAL;
      FUNCTION GETCURID:DWORD;
      PRIVATE
      LASTDEL:BOOLEAN;
      FIRST,LASTU:PRADIOFIELD;
      CURF:PRADIOFIELD;
      PROCEDURE REDRAWALL;
     END;
     TRADIOFIELD=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;CAP:STRING;GR:PRADIOGROUP;PID:DWORD;F:PFONT);
      PROCEDURE ONDONE;VIRTUAL;
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE ONKEY(C,C2:CHAR);VIRTUAL;
      PRIVATE
      GROUP:PRADIOGROUP;
      CAPTION:STRING;
      NEXT,LAST:PRADIOFIELD;
      ID:DWORD;
      FONT:PFONT;
      DOWN:BOOLEAN;
     END;
TYPE PFILEDIRBOXF=^TFILEDIRBOXF;
     PFILEDIRBOX=^TFILEDIRBOX;
     PFILEDIRBOXE=^TFILEDIRBOXE;
     TFILEDIRBOXF=OBJECT(TSTRLISTBOX)
      CONSTRUCTOR INIT(BAS:PFILEDIRBOX);
      PROCEDURE ONSELECT(LIN:DWORD);VIRTUAL;
      PRIVATE
      BOX:PFILEDIRBOX;
     END;
     TFILEDIRBOXE=OBJECT(TINPUTLINE)
      CONSTRUCTOR INIT(BAS:PFILEDIRBOX);
      PROCEDURE ONRETURN;VIRTUAL;
      PRIVATE
      BOX:PFILEDIRBOX;
     END;
     TFILEDIRBOX=OBJECT(TWIN)
      PROCEDURE ONSELECTFILE(FN:STRING);VIRTUAL;
      PROCEDURE ONCHANGEDIR(DIR:STRING);VIRTUAL;
      PROCEDURE GOTODIR(DIR:STRING);
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;DIR:STRING;F:PFONT);
      PRIVATE
      PATHONLY,FILEONLY,EXTONLY:STRING;
      CURDIR:STRING;
      FBOX:PFILEDIRBOXF;
      EBOX:PFILEDIRBOXE;
      FONT:PFONT;
     END;
TYPE PVSLIDECONTROL=^TVSLIDECONTROL;
     TVSLIDECONTROL=OBJECT(TWIN)
      ONCHANGEP:PROCEDURE(SENDER:PVSLIDECONTROL);
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SP,MP,LC:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE SETPOS(P:DWORD);
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE ONCHANGE;VIRTUAL;
      FUNCTION GETPOS:DWORD;
      PROCEDURE ONKEY(C,C2:CHAR);VIRTUAL;
      PRIVATE
      LINC:DWORD;
      BARPOS,OLDPOS,POS,POINTS:DWORD;
      BSTAT:DWORD;
      MULTIPL:EXTENDED;
      PROCEDURE CALCBAR;
     END;
TYPE PHSLIDECONTROL=^THSLIDECONTROL;
     THSLIDECONTROL=OBJECT(TWIN)
      ONCHANGEP:PROCEDURE(SENDER:PHSLIDECONTROL);
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SP,MP,LC:DWORD);
      PROCEDURE ONPAINT;VIRTUAL;
      PROCEDURE SETPOS(P:DWORD);
      PROCEDURE ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);VIRTUAL;
      PROCEDURE ONCHANGE;VIRTUAL;
      FUNCTION GETPOS:DWORD;
      PROCEDURE ONKEY(C,C2:CHAR);VIRTUAL;
      PRIVATE
      LINC:DWORD;
      BARPOS,OLDPOS,POS,POINTS:DWORD;
      BSTAT:DWORD;
      MULTIPL:EXTENDED;
      PROCEDURE CALCBAR;
     END;
TYPE PINPUTINT=^TINPUTINT;
     TINPUTINT=OBJECT(TINPUTLINE)
      CONSTRUCTOR INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;F:PFONT);
      PROCEDURE ONKEY(C1,C2:CHAR);VIRTUAL;
     END;
TYPE PCOLORCONTROL_SH=^TCOLORCONTROL_SH;
     PCOLORCONTROL=^TCOLORCONTROL;
     PCOLORCONTROL_EL=^TCOLORCONTROL_EL;
     TCOLORCONTROL_SH=OBJECT(THSLIDECONTROL)
      CONSTRUCTOR INIT(BAS:PCOLORCONTROL;Y:LONGINT;B:DWORD;SHF:DWORD);
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      COLC:PCOLORCONTROL;
      SHIFT:DWORD;
     END;
     TCOLORCONTROL_EL=OBJECT(TINPUTINT)
      CONSTRUCTOR INIT(BAS:PCOLORCONTROL;X,Y:LONGINT;SHF:DWORD;F:PFONT);
      PROCEDURE ONRETURN;VIRTUAL;
      PRIVATE
      COLC:PCOLORCONTROL;
      SHIFT:DWORD;
     END;
     TCOLORCONTROL=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;F:PFONT);
      PROCEDURE SETCOLOR(C:DWORD);
      FUNCTION GETCOLOR:DWORD;
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      REDL,GREENL,BLUEL:PLABEL;
      REDC,GREENC,BLUEC:PCOLORCONTROL_SH;
      REDE,GREENE,BLUEE:PCOLORCONTROL_EL;
      COLOR:DWORD;
     END;
TYPE PGROUPFRAME=^TGROUPFRAME;
     TGROUPFRAME=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;CAP:STRING;F:PFONT);
      PROCEDURE ONPAINT;VIRTUAL;
      PRIVATE
      FONT:PFONT;
      FH:DWORD;
      CAPTION:STRING;
      SUBWIN:PWIN;
     END;
TYPE PCOLORPERCONTROL_SH=^TCOLORPERCONTROL_SH;
     PCOLORPERCONTROL=^TCOLORPERCONTROL;
     PCOLORPERCONTROL_EL=^TCOLORPERCONTROL_EL;
     TCOLORPERCONTROL_SH=OBJECT(THSLIDECONTROL)
      CONSTRUCTOR INIT(BAS:PCOLORPERCONTROL;Y:LONGINT;B:DWORD;SHF:DWORD);
      PROCEDURE ONCHANGE;VIRTUAL;
      PRIVATE
      COLC:PCOLORPERCONTROL;
      SHIFT:DWORD;
     END;
     TCOLORPERCONTROL_EL=OBJECT(TINPUTINT)
      CONSTRUCTOR INIT(BAS:PCOLORPERCONTROL;X,Y:LONGINT;SHF:DWORD;F:PFONT);
      PROCEDURE ONRETURN;VIRTUAL;
      PRIVATE
      COLC:PCOLORPERCONTROL;
      SHIFT:DWORD;
     END;
     TCOLORPERCONTROL=OBJECT(TWIN)
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;F:PFONT);
      PROCEDURE SETCOLOR(SHIFT,COL:DWORD);
      PROCEDURE ONCHANGE;VIRTUAL;
      FUNCTION GETREDV:DWORD;
      FUNCTION GETGREENV:DWORD;
      FUNCTION GETBLUEV:DWORD;
      PRIVATE
      REDL,GREENL,BLUEL:PLABEL;
      REDC,GREENC,BLUEC:PCOLORPERCONTROL_SH;
      REDE,GREENE,BLUEE:PCOLORPERCONTROL_EL;
      REDV,GREENV,BLUEV:DWORD;
     END;
FUNCTION MESSAGEBOX(BAS:PDESKTOP;TIT,TXT:STRING;BUTTONS:DWORD;F:PFONT):DWORD;
IMPLEMENTATION
FUNCTION TCOLORPERCONTROL.GETREDV:DWORD;
BEGIN
 GETREDV:=REDV;
END;
FUNCTION TCOLORPERCONTROL.GETGREENV:DWORD;
BEGIN
 GETGREENV:=GREENV;
END;
FUNCTION TCOLORPERCONTROL.GETBLUEV:DWORD;
BEGIN
 GETBLUEV:=BLUEV;
END;
PROCEDURE TCOLORPERCONTROL_EL.ONRETURN;
VAR VL:DWORD;
    E:INTEGER;
BEGIN
 VAL(GETTEXT,VL,E);
 IF E<>0 THEN VL:=0;
 IF VL>65536 THEN VL:=65536;
 COLC^.SETCOLOR(SHIFT,VL);
END;
CONSTRUCTOR TCOLORPERCONTROL_EL.INIT(BAS:PCOLORPERCONTROL;X,Y:LONGINT;SHF:DWORD;F:PFONT);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,20,50,TRUE,F);
 SHIFT:=SHF;
 COLC:=BAS;
END;
PROCEDURE TCOLORPERCONTROL.SETCOLOR(SHIFT,COL:DWORD);
VAR S:STRING;
BEGIN
 CASE SHIFT OF
  0:IF COL<>BLUEV THEN
  BEGIN
   BLUEV:=COL;
   STR(COL,S);
   BLUEC^.SETPOS(COL);
   BLUEE^.SETTEXT(S);
   ONCHANGE;
  END;
  8:IF COL<>GREENV THEN
  BEGIN
   GREENV:=COL;
   STR(COL,S);
   GREENC^.SETPOS(COL);
   GREENE^.SETTEXT(S);
   ONCHANGE;
  END;
  16:IF COL<>REDV THEN
  BEGIN
   REDV:=COL;
   STR(COL,S);
   REDC^.SETPOS(COL);
   REDE^.SETTEXT(S);
   ONCHANGE;
  END;
 END;
END;
PROCEDURE TCOLORPERCONTROL.ONCHANGE;
BEGIN
END;
PROCEDURE TCOLORPERCONTROL_SH.ONCHANGE;
BEGIN
 COLC^.SETCOLOR(SHIFT,GETPOS);
END;
CONSTRUCTOR TCOLORPERCONTROL_SH.INIT(BAS:PCOLORPERCONTROL;Y:LONGINT;B:DWORD;SHF:DWORD);
BEGIN
 INHERITED INIT(BAS,50,Y,20,B,TRUE,0,65537,3);
 SHIFT:=SHF;
 COLC:=BAS;
END;
CONSTRUCTOR TCOLORPERCONTROL.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;F:PFONT);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_NULL);
 NEW(REDL,INIT(@SELF,NIL,0,0,20,50,TRUE,'Rot',F));
 NEW(REDC,INIT(@SELF,0,B-105,16));
 NEW(REDE,INIT(@SELF,B-50,0,16,F));
 NEW(GREENL,INIT(@SELF,NIL,0,20,20,50,TRUE,'Grn',F));
 NEW(GREENC,INIT(@SELF,20,B-105,8));
 NEW(GREENE,INIT(@SELF,B-50,20,8,F));
 NEW(BLUEL,INIT(@SELF,NIL,0,40,20,50,TRUE,'Blau',F));
 NEW(BLUEC,INIT(@SELF,40,B-105,0));
 NEW(BLUEE,INIT(@SELF,B-50,40,0,F));
END;
PROCEDURE TGROUPFRAME.ONPAINT;
BEGIN
 BAR(0,0,GETH,GETB,CL_SILVER);
 FRAMEC3D(0,FH DIV 2,GETH-FH DIV 2,GETB);
 BAR(4,0,FH,GETSTRINGWIDTH(CAPTION,FONT)+3,CL_SILVER);
 PUTSTRING(6,0,CAPTION,CL_BLACK,FONT);
END;
CONSTRUCTOR TGROUPFRAME.INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;CAP:STRING;F:PFONT);
BEGIN
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS,GT_NULL);
 CAPTION:=CAP;
 FONT:=F;
 FH:=FONT^.HEIGHT;
 NEW(SUBWIN,INIT(@SELF,NIL,4,FH+4,H-FH-8,B-8,TRUE,GT_NULL));
 SETAPPFRAME(SUBWIN);
END;
PROCEDURE TCOLORCONTROL_EL.ONRETURN;
VAR VL:DWORD;
    E:INTEGER;
BEGIN
 VAL(GETTEXT,VL,E);
 IF E<>0 THEN VL:=0;
 IF VL>255 THEN VL:=255;
 COLC^.SETCOLOR(COLC^.COLOR AND (NOT ($FF SHL SHIFT)) OR (VL SHL SHIFT));
END;
CONSTRUCTOR TCOLORCONTROL_EL.INIT(BAS:PCOLORCONTROL;X,Y:LONGINT;SHF:DWORD;F:PFONT);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,20,40,TRUE,F);
 SHIFT:=SHF;
 COLC:=BAS;
END;
FUNCTION TCOLORCONTROL.GETCOLOR:DWORD;
BEGIN
 GETCOLOR:=COLOR;
END;
PROCEDURE TCOLORCONTROL.SETCOLOR(C:DWORD);
VAR S:STRING;
    C1:DWORD;
BEGIN
 IF C<>COLOR THEN
 BEGIN
  COLOR:=C;
  C1:=C AND $FF;
  STR(C1,S);
  REDC^.SETPOS(C1);
  REDE^.SETTEXT(S);
  C1:=C SHR 8 AND $FF;
  STR(C1,S);
  GREENC^.SETPOS(C1);
  GREENE^.SETTEXT(S);
  C1:=C SHR 16 AND $FF;
  STR(C1,S);
  BLUEC^.SETPOS(C1);
  BLUEE^.SETTEXT(S);
  ONCHANGE;
 END;
END;
PROCEDURE TCOLORCONTROL.ONCHANGE;
BEGIN
END;
PROCEDURE TCOLORCONTROL_SH.ONCHANGE;
BEGIN
 COLC^.SETCOLOR(COLC^.COLOR AND (NOT ($FF SHL SHIFT)) OR (GETPOS SHL SHIFT));
END;
CONSTRUCTOR TCOLORCONTROL_SH.INIT(BAS:PCOLORCONTROL;Y:LONGINT;B:DWORD;SHF:DWORD);
BEGIN
 INHERITED INIT(BAS,50,Y,20,B,TRUE,0,256,3);
 SHIFT:=SHF;
 COLC:=BAS;
END;
CONSTRUCTOR TCOLORCONTROL.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;F:PFONT);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_NULL);
 NEW(REDL,INIT(@SELF,NIL,0,0,20,50,TRUE,'Rot',F));
 NEW(REDC,INIT(@SELF,0,B-95,0));
 NEW(REDE,INIT(@SELF,B-40,0,0,F));
 NEW(GREENL,INIT(@SELF,NIL,0,20,20,50,TRUE,'Grn',F));
 NEW(GREENC,INIT(@SELF,20,B-95,8));
 NEW(GREENE,INIT(@SELF,B-40,20,8,F));
 NEW(BLUEL,INIT(@SELF,NIL,0,40,20,50,TRUE,'Blau',F));
 NEW(BLUEC,INIT(@SELF,40,B-95,16));
 NEW(BLUEE,INIT(@SELF,B-40,40,16,F));
END;
CONSTRUCTOR TINPUTINT.INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;F:PFONT);
VAR S:STRING;
BEGIN
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS,F);
 SETTEXT('0');
END;
PROCEDURE TINPUTINT.ONKEY(C1,C2:CHAR);
VAR O,S:STRING;
BEGIN
 O:=GETTEXT;
 IF O='0' THEN SETTEXT('');
 CASE C1 OF
  #0:
  BEGIN
   CASE C2 OF
    #71:GOTOPOS1;
    #75:GOTOLAST;
    #77:GOTONEXT;
    #79:GOTOEND;
    #83:DELETE;
   END;
  END;
  #8:DELETELAST;
  #13:ONRETURN;
  ELSE IF (C1 IN ['0'..'9']) THEN INSERTCHAR(C1);
 END;
 O:=GETTEXT;
 S:=O;
 WHILE (S<>'') AND (S[1]='0') DO SYSTEM.DELETE(S,1,1);
 IF S='' THEN S:='0';
 IF O<>S THEN SETTEXT(S);
END;
FUNCTION THSLIDECONTROL.GETPOS:DWORD;
BEGIN
 GETPOS:=POS;
END;
PROCEDURE THSLIDECONTROL.ONCHANGE;
BEGIN
 IF ONCHANGEP<>NIL THEN ONCHANGEP(@SELF);
END;
PROCEDURE THSLIDECONTROL.SETPOS(P:DWORD);
BEGIN
 IF LONGINT(P)>=LONGINT(POINTS) THEN P:=POINTS-1;
 IF LONGINT(P)<0 THEN P:=0;
 IF P<>POS THEN
 BEGIN
  POS:=P;
  CALCBAR;
  ONCHANGE;
 END;
END;
PROCEDURE THSLIDECONTROL.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
VAR NY:LONGINT;
BEGIN
 CASE BSTAT OF
  0:IF (GETOLDMOUSEB=0) AND (B=1) THEN
  BEGIN
   OLDPOS:=POS;
   BSTAT:=1;
   NY:=X-4;
   IF NY<0 THEN NY:=0;
   IF NY>GETB-8 THEN NY:=GETB-8;
   SETPOS(ROUND(NY/MULTIPL));
  END;
  1:IF B=1 THEN
  BEGIN
   NY:=X-4;
   IF NY<0 THEN NY:=0;
   IF NY>GETB-8 THEN NY:=GETB-8;
   SETPOS(ROUND(NY/MULTIPL));
  END
  ELSE
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
  END;
 END;
END;
PROCEDURE THSLIDECONTROL.CALCBAR;
VAR H:DWORD;
BEGIN
 IF POINTS>1 THEN
 BEGIN
  MULTIPL:=(GETB-8)/(POINTS-1);
 END ELSE MULTIPL:=1;
 BARPOS:=ROUND(POS*MULTIPL);
 REDRAW;
END;
PROCEDURE THSLIDECONTROL.ONPAINT;
VAR B2,I:DWORD;
BEGIN
 B2:=GETH DIV 2;
 BAR(0,0,GETH,GETB,CL_SILVER);
 FOR I:=1 TO LINC DO
 BEGIN
  BAR(GETB*I DIV (LINC+1)-1,B2-5,10,2,CL_BLACK);
 END;
 FRAMEI3D(0,B2-2,4,GETB);
 IF HASFOCUS THEN BARI3D(BARPOS,0,GETH,8) ELSE BAR3D(BARPOS,0,GETH,8);
END;
PROCEDURE THSLIDECONTROL.ONKEY(C,C2:CHAR);
BEGIN
 CASE C OF
  #0:
  BEGIN
   CASE C2 OF
    #75:SETPOS(POS-1);
    #77:SETPOS(POS+1);
   END;
  END;
 END;
END;
CONSTRUCTOR THSLIDECONTROL.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SP,MP,LC:DWORD);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_STDOBJ);
 POS:=SP;
 POINTS:=MP;
 CALCBAR;
 BSTAT:=0;
 ONCHANGEP:=NIL;
 LINC:=LC;
END;
FUNCTION TVSLIDECONTROL.GETPOS:DWORD;
BEGIN
 GETPOS:=POS;
END;
PROCEDURE TVSLIDECONTROL.ONCHANGE;
BEGIN
 IF ONCHANGEP<>NIL THEN ONCHANGEP(@SELF);
END;
PROCEDURE TVSLIDECONTROL.SETPOS(P:DWORD);
BEGIN
 IF LONGINT(P)>=LONGINT(POINTS) THEN P:=POINTS-1;
 IF LONGINT(P)<0 THEN P:=0;
 IF P<>POS THEN
 BEGIN
  POS:=P;
  CALCBAR;
  ONCHANGE;
 END;
END;
PROCEDURE TVSLIDECONTROL.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
VAR NY:LONGINT;
BEGIN
 CASE BSTAT OF
  0:IF (GETOLDMOUSEB=0) AND (B=1) THEN
  BEGIN
   OLDPOS:=POS;
   BSTAT:=1;
   NY:=Y-4;
   IF NY<0 THEN NY:=0;
   IF NY>GETH-8 THEN NY:=GETH-8;
   SETPOS(ROUND(NY/MULTIPL));
  END;
  1:IF B=1 THEN
  BEGIN
   NY:=Y-4;
   IF NY<0 THEN NY:=0;
   IF NY>GETH-8 THEN NY:=GETH-8;
   SETPOS(ROUND(NY/MULTIPL));
  END
  ELSE
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
  END;
 END;
END;
PROCEDURE TVSLIDECONTROL.CALCBAR;
VAR H:DWORD;
BEGIN
 IF POINTS>1 THEN
 BEGIN
  MULTIPL:=(GETH-8)/(POINTS-1);
 END ELSE MULTIPL:=1;
 BARPOS:=ROUND(POS*MULTIPL);
 REDRAW;
END;
PROCEDURE TVSLIDECONTROL.ONPAINT;
VAR B2,I:DWORD;
BEGIN
 B2:=GETB DIV 2;
 BAR(0,0,GETH,GETB,CL_SILVER);
 FOR I:=1 TO LINC DO
 BEGIN
  BAR(B2-5,GETH*I DIV (LINC+1)-1,2,10,CL_BLACK);
 END;
 FRAMEI3D(B2-2,0,GETH,4);
 IF HASFOCUS THEN BARI3D(0,BARPOS,8,GETB) ELSE BAR3D(0,BARPOS,8,GETB);
END;
PROCEDURE TVSLIDECONTROL.ONKEY(C,C2:CHAR);
BEGIN
 CASE C OF
  #0:
  BEGIN
   CASE C2 OF
    #72:SETPOS(POS-1);
    #80:SETPOS(POS+1);
   END;
  END;
 END;
END;
CONSTRUCTOR TVSLIDECONTROL.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SP,MP,LC:DWORD);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_STDOBJ);
 POS:=SP;
 POINTS:=MP;
 CALCBAR;
 BSTAT:=0;
 ONCHANGEP:=NIL;
 LINC:=LC;
END;
PROCEDURE TFILEDIRBOXE.ONRETURN;
BEGIN
 BOX^.GOTODIR(GETTEXT);
END;
CONSTRUCTOR TFILEDIRBOXE.INIT(BAS:PFILEDIRBOX);
BEGIN
 INHERITED INIT(BAS,NIL,0,BAS^.GETH-25,25,BAS^.GETB,TRUE,BAS^.FONT);
 BOX:=BAS;
END;
CONSTRUCTOR TFILEDIRBOX.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;DIR:STRING;F:PFONT);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_NULL);
 FONT:=F;
 NEW(FBOX,INIT(@SELF));
 NEW(EBOX,INIT(@SELF));
 GOTODIR(DIR);
END;
PROCEDURE TFILEDIRBOX.ONSELECTFILE(FN:STRING);
BEGIN
END;
PROCEDURE TFILEDIRBOX.ONCHANGEDIR(DIR:STRING);
BEGIN
END;
PROCEDURE TFILEDIRBOXF.ONSELECT(LIN:DWORD);
VAR SE:SEARCHREC;
    LS,NAME:STRING;
BEGIN
 WITH BOX^ DO
 BEGIN
  LS:=READLINE(LIN);
  IF (LS='.') OR (LS='..') THEN
   BEGIN
   IF LS='..' THEN
   BEGIN
    IF PATHONLY<>'' THEN
    BEGIN
     DEC(BYTE(PATHONLY[0]));
     WHILE (LENGTH(PATHONLY)>0) AND (PATHONLY[LENGTH(PATHONLY)]<>'\') DO
     BEGIN
      DEC(BYTE(PATHONLY[0]));
     END;
    END;
    LS:=PATHONLY+FILEONLY+EXTONLY;
    GOTODIR(LS);
   END
  END
  ELSE
  BEGIN
   NAME:=PATHONLY+LS;
   FINDFIRST(NAME,ANYFILE,SE);
   IF SE.ATTR AND DIRECTORY<>0 THEN
   BEGIN
    LS:=PATHONLY+LS+'\'+FILEONLY+EXTONLY;
    GOTODIR(LS);
   END ELSE ONSELECTFILE(NAME);
  END;
 END;
END;
PROCEDURE TFILEDIRBOX.GOTODIR(DIR:STRING);
BEGIN
 IF DIR<>CURDIR THEN
 BEGIN
  CURDIR:=DIR;
  FSPLIT(CURDIR,PATHONLY,FILEONLY,EXTONLY);
  IF (PATHONLY<>'') AND (PATHONLY[LENGTH(PATHONLY)]<>'\') THEN PATHONLY:=PATHONLY+'\';
  FBOX^.LOADDIR(DIR);
  FBOX^.SORT;
  EBOX^.SETTEXT(DIR);
  ONCHANGEDIR(DIR);
 END;
END;
CONSTRUCTOR TFILEDIRBOXF.INIT(BAS:PFILEDIRBOX);
BEGIN
 INHERITED INIT(BAS,0,0,BAS^.GETH-25,BAS^.GETB,TRUE,3,BAS^.FONT);
 BOX:=BAS;
END;
PROCEDURE TRADIOFIELD.ONKEY(C,C2:CHAR);
BEGIN
 CASE C OF
  #32:GROUP^.SELECT(@SELF);
  #0:
  BEGIN
   CASE C2 OF
    #71:GROUP^.GOTOFIRST;
    #72,#75:GROUP^.GOTOLAST;
    #77,#80:GROUP^.GOTONEXT;
    #79:GROUP^.GOTOEND;
   END;
  END;
 END;
END;
PROCEDURE TRADIOFIELD.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
VAR H,H2:DWORD;
    X2,Y2:LONGINT;
BEGIN
 H:=GETH;
 H2:=H DIV 2;
 X2:=(H-X-1);
 Y2:=(H-Y-1);
 IF DOWN THEN
 BEGIN
  IF B=0 THEN
  BEGIN
   DOWN:=FALSE;
   IF (X<H) AND (X+Y>=H2) AND (X2+Y>=H2) AND (X+Y2>=H2) AND (X2+Y2>=H2) THEN
   BEGIN
    GROUP^.SELECT(@SELF);
   END;
  END;
 END
 ELSE
 BEGIN
  IF (GETOLDMOUSEB=0) AND (B=1) AND (X<H) AND (X+Y>=H2) AND (X2+Y>=H2) AND
     (X+Y2>=H2) AND (X2+Y2>=H2) THEN DOWN:=TRUE;
 END;
END;
PROCEDURE TRADIOFIELD.ONPAINT;
BEGIN
 BAR(0,0,GETH,GETB,CL_SILVER);
 DRAWFQI3DRAUTE(0,0,GETH,CL_WHITE);
 IF HASFOCUS THEN DRAWQRAUTE(4,4,GETH-8,CL_RED);
 IF GROUP^.CURF=@SELF THEN DRAWFQRAUTE(6,6,GETH-12,CL_BLACK,CL_BLACK);
 PUTSTRING(GETH+3,(GETH-FONT^.HEIGHT) DIV 2,CAPTION,CL_BLACK,FONT)
END;
PROCEDURE TRADIOFIELD.ONDONE;
BEGIN
 IF NEXT<>NIL THEN NEXT^.LAST:=LAST ELSE GROUP^.LASTU:=LAST;
 IF LAST<>NIL THEN LAST^.NEXT:=NEXT ELSE GROUP^.FIRST:=NEXT;
 IF (GROUP^.LASTDEL) AND (GROUP^.FIRST=NIL) THEN DISPOSE(GROUP,DONE);
END;
CONSTRUCTOR TRADIOFIELD.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;CAP:STRING;GR:PRADIOGROUP;PID:DWORD;F:PFONT);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_STDOBJ);
 ID:=PID;
 CAPTION:=CAP;
 GROUP:=GR;
 NEXT:=NIL;
 LAST:=GR^.LASTU;
 FONT:=F;
 IF LAST<>NIL THEN LAST^.NEXT:=@SELF ELSE GR^.FIRST:=@SELF;
 GR^.LASTU:=@SELF;
 IF GR^.CURF=NIL THEN GR^.CURF:=@SELF;
 DOWN:=FALSE;
END;
PROCEDURE TRADIOGROUP.ONCHANGE;
BEGIN
END;
FUNCTION TRADIOGROUP.GETCURID:DWORD;
BEGIN
 IF CURF<>NIL THEN GETCURID:=CURF^.ID ELSE GETCURID:=$FFFFFFFF;
END;
PROCEDURE TRADIOGROUP.SELECT(P:PRADIOFIELD);
BEGIN
 IF P=CURF THEN EXIT;
 CURF:=P;
 REDRAWALL;
 ONCHANGE;
END;
PROCEDURE TRADIOGROUP.GOTOFIRST;
BEGIN
 IF FIRST=LASTU THEN EXIT;
 CURF:=FIRST;
 CURF^.SELECT;
 REDRAWALL;
END;
PROCEDURE TRADIOGROUP.GOTOEND;
BEGIN
 IF FIRST=LASTU THEN EXIT;
 CURF:=LASTU;
 CURF^.SELECT;
 REDRAWALL;
END;
PROCEDURE TRADIOGROUP.REDRAWALL;
VAR P:PRADIOFIELD;
BEGIN
 P:=FIRST;
 WHILE P<>NIL DO
 BEGIN
  P^.REDRAW;
  P:=P^.NEXT;
 END;
END;
PROCEDURE TRADIOGROUP.GOTOLAST;
BEGIN
 IF CURF^.LAST<>NIL THEN CURF:=CURF^.LAST ELSE
 BEGIN
  IF FIRST=LASTU THEN EXIT;
  CURF:=LASTU;
 END;
 CURF^.SELECT;
 REDRAWALL;
END;
PROCEDURE TRADIOGROUP.GOTONEXT;
BEGIN
 IF CURF^.NEXT<>NIL THEN CURF:=CURF^.NEXT ELSE
 BEGIN
  IF FIRST=LASTU THEN EXIT;
  CURF:=FIRST;
 END;
 CURF^.SELECT;
 REDRAWALL;
END;
CONSTRUCTOR TRADIOGROUP.INIT(LD:BOOLEAN);
BEGIN
 LASTDEL:=LD;
 CURF:=NIL;
END;
DESTRUCTOR TRADIOGROUP.DONE;
VAR P,P2:PRADIOFIELD;
BEGIN
 P:=FIRST;
 WHILE P<>NIL DO
 BEGIN
  P2:=P^.NEXT;
  DISPOSE(P);
  P:=P2;
 END;
END;
PROCEDURE TCHECKBOX.DISABLE;
BEGIN
 IF ENABLED THEN
 BEGIN
  ENABLED:=FALSE;
  REDRAW;
 END;
END;
PROCEDURE TCHECKBOX.ENABLE;
BEGIN
 IF NOT ENABLED THEN
 BEGIN
  ENABLED:=TRUE;
  REDRAW;
 END;
END;
PROCEDURE TCHECKBOX.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
BEGIN
 IF DOWN THEN
 BEGIN
  IF B=0 THEN
  BEGIN
   IF (DWORD(X)<GETH) AND (DWORD(Y)<GETH) THEN
   BEGIN
    CHECK:=NOT CHECK;
    ONCHANGE(CHECK);
    REDRAW;
   END;
   DOWN:=FALSE;
   REDRAW;
  END;
 END
 ELSE
 BEGIN
  IF ENABLED AND (B=1) AND (GETOLDMOUSEB=0) AND (DWORD(X)<GETH) AND (DWORD(Y)<GETH) THEN
  BEGIN
   DOWN:=TRUE;
   REDRAW;
  END;
 END;
END;
PROCEDURE TCHECKBOX.ONCHANGE(STAT:BOOLEAN);
BEGIN
END;
PROCEDURE TCHECKBOX.ONKEY(C,C2:CHAR);
BEGIN
 CASE C OF
  #32:IF ENABLED THEN
  BEGIN
   CHECK:=NOT CHECK;
   ONCHANGE(CHECK);
   REDRAW;
  END;
 END;
END;
PROCEDURE TCHECKBOX.ONSELECT(FOC:BOOLEAN);
BEGIN
 REDRAW;
END;
PROCEDURE TCHECKBOX.ONUNSELECT;
BEGIN
 REDRAW;
END;
PROCEDURE TCHECKBOX.ONPAINT;
BEGIN
 BAR(GETH,0,GETH,GETB,CL_SILVER);
 FRAMEI3D(0,0,GETH,GETH);
 IF ENABLED THEN BAR(2,2,GETH-4,GETH-4,CL_WHITE)
  ELSE BAR(2,2,GETH-4,GETH-4,CL_SILVER);
 IF HASFOCUS THEN RECTANGLE(2,2,GETH-4,GETH-4,CL_RED);
 IF CHECK THEN DRAWCROSS(4,4,GETH-8,CL_BLACK);
 PUTSTRING(GETH+3,(GETH-FONT^.HEIGHT) DIV 2,CAPTION,CL_BLACK,FONT)
END;
CONSTRUCTOR TCHECKBOX.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;TXT:STRING;CHK:BOOLEAN;F:PFONT);
BEGIN
 WRITELN(CRSTR,'Create TCheckbox (',DWORD(@SELF),') : ',X,':',Y,'  ',H,'*',B);
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_STDOBJ);
 CRLEA;
 CAPTION:=TXT;
 CHECK:=CHK;
 FONT:=F;
 DOWN:=FALSE;
 ENABLED:=TRUE;
END;
TYPE PMESSAGEBOXWINB=^TMESSAGEBOXWINB;
     PMESSAGEBOXWIN=^TMESSAGEBOXWIN;
     TMESSAGEBOXWINB=OBJECT(TBUTTON)
      CONSTRUCTOR INIT(BAS:PMESSAGEBOXWIN;X,Y:LONGINT;S:STRING;F:PFONT;AMSG:POINTER;NR:DWORD);
      PROCEDURE ONCLICK;VIRTUAL;
      PRIVATE
      MSG:POINTER;
      MSGN:DWORD;
     END;
     TMESSAGEBOXWIN=OBJECT(TWINDOW)
      CONSTRUCTOR INIT(BAS:PDESKTOP;TIT,TXT:STRING;BUTTONS:DWORD;F:PFONT;MSG:POINTER);
      PRIVATE
     END;
PROCEDURE TSTRTREEWIN.CLEAR;
BEGIN
 STRTREEVIEW^.CLEAR;
END;
PROCEDURE TSTRTREEWIN.SORT;
BEGIN
 STRTREEVIEW^.SORT;
END;
PROCEDURE TSTRTREEWIN.LOADDIRS(BAS:STRING);
BEGIN
 STRTREEVIEW^.LOADDIRS(BAS);
END;
PROCEDURE TSTRTREEWINF.ONSELECT(P:PSTRTREENODE);
BEGIN
 STRTREEWIN^.ONSELECT(P);
END;
PROCEDURE TSTRTREEWIN.ONSELECT(P:PSTRTREENODE);
BEGIN
END;
PROCEDURE TSTRTREEWIN.CHECKSIZE(VAR H,B:DWORD);
BEGIN
 INHERITED CHECKSIZE(H,B);
 IF LONGINT(H)<93 THEN H:=93;
 IF LONGINT(B)<68 THEN B:=68;
END;
PROCEDURE TSTRTREEWIN.ONRESIZE;
BEGIN
 INHERITED ONRESIZE;
 STRTREEVIEW^.SIZE(GETAFH,GETAFB);
END;
CONSTRUCTOR TSTRTREEWINF.INIT(BAS:PSTRTREEWIN;SC:DWORD;R:STRING;F:PFONT);
BEGIN
 INHERITED INIT(BAS,0,0,BAS^.GETAFH,BAS^.GETAFB,TRUE,SC,R,F);
 STRTREEWIN:=BAS;
END;
CONSTRUCTOR TSTRTREEWIN.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;TIT:STRING;SZ:BOOLEAN;SC:DWORD;R:STRING;F,TF:PFONT);
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,VIS,TIT,SZ,F);
 NEW(STRTREEVIEW,INIT(@SELF,SC,R,TF));
END;
PROCEDURE TSTRTREEVIEW.CHECKSIZE(VAR H,B:DWORD);
BEGIN
 IF LONGINT(H)<21 THEN H:=21;
 IF LONGINT(B)<21 THEN B:=21;
END;
PROCEDURE TSTRTREEVIEW.SIZE(H,B:DWORD);
VAR L:LONGINT;
BEGIN
 INHERITED SIZE(H,B);
 CASE SCB OF
  0:E^.SIZE(GETH,GETB);
  1:
  BEGIN
   SCV^.MOVESIZE(GETB-20,0,GETH,20);
   E^.SIZE(GETH,GETB-20);
  END;
  2:
  BEGIN
   SCV^.MOVESIZE(0,GETH-20,20,GETB);
   E^.SIZE(GETH-20,GETB);
  END;
  3:
  BEGIN
   SCV^.MOVESIZE(GETB-20,0,GETH-20,20);
   SCH^.MOVESIZE(0,GETH-20,20,GETB-20);
   E^.SIZE(GETH-20,GETB-20);
  END;
 END;
 L:=MAXSCH-E^.GETB+10;
 IF L<0 THEN L:=0;
 SCH^.SETRANGE(L);
 L:=TREE^.GETLINECOUNT-(E^.GETH DIV (FONT^.HEIGHT+1))+1;
 IF L<0 THEN L:=0;
 SCV^.SETRANGE(L);
END;
PROCEDURE TSTRTREEVIEW.SORT;
BEGIN
 TREE^.SORT;
END;
PROCEDURE TSTRTREEVIEW.LOADDIRS(BAS:STRING);
BEGIN
 AKTSEL:=NIL;
 SCRLINE:=0;
 XSCROLL:=0;
 TREE^.LOADDIRS(BAS);
 CALCSCROLL(TRUE);
END;
PROCEDURE TSTRTREEVIEW.CLEAR;
BEGIN
 AKTSEL:=NIL;
 SCRLINE:=0;
 XSCROLL:=0;
 TREE^.CLEAR;
 CALCSCROLL(TRUE);
END;
PROCEDURE TSTRTREEVIEW.ONDONE;
BEGIN
 TREE^.CLEAR;
END;
PROCEDURE TSTRTREEVIEW.ONKEY(C,C2:CHAR);
VAR NEWSEL:PSTRTREENODE;
    LEV:DWORD;
BEGIN
 NEWSEL:=AKTSEL;
 IF AKTSEL=NIL THEN
 BEGIN
  NEWSEL:=TREE^.ROOT;
 END
 ELSE
 BEGIN
  CASE C OF
   #0:
   BEGIN
    CASE C2 OF
     #72:NEWSEL:=TREE^.GETLAST(LEV,AKTSEL);
     #75:
     BEGIN
      TREE^.REDUCE(AKTSEL);
      CALCSCROLL(FALSE);
      CALCSCH;
     END;
     #77:
     BEGIN
      TREE^.EXPAND(AKTSEL);
      CALCSCROLL(FALSE);
      CALCSCH;
     END;
     #80:NEWSEL:=TREE^.GETNEXT(LEV,AKTSEL);
    END;
   END;
  END;
 END;
 IF (NEWSEL<>AKTSEL) AND (NEWSEL<>NIL) THEN
 BEGIN
  AKTSEL:=NEWSEL;
  ONSELECT(AKTSEL);
  CALCSCROLL(TRUE);
 END;
END;
PROCEDURE TSTRTREEVIEW.ONSELECT(P:PSTRTREENODE);
BEGIN
END;
PROCEDURE TSTRTREEVIEW.CALCSCH;
VAR P:PSTRTREENODE;
    LEV:DWORD;
    B:DWORD;
    L:LONGINT;
BEGIN
 P:=TREE^.ROOT;
 LEV:=0;
 MAXSCH:=0;
 WHILE P<>NIL DO
 BEGIN
  B:=LEV*10+10+GETSTRINGWIDTH(P^.STR,FONT);
  IF B>MAXSCH THEN MAXSCH:=B;
  P:=TREE^.GETNEXT(LEV,P);
 END;
 L:=MAXSCH-E^.GETB+10;
 IF L<0 THEN L:=0;
 SCH^.SETRANGE(L);
END;
PROCEDURE TSTRTREEVIEWH.ONCHANGE;
BEGIN
 STRTREEVIEW^.XSCROLL:=GETPOS;
 STRTREEVIEW^.REDRAW;
END;
PROCEDURE TSTRTREEVIEWV.ONCHANGE;
BEGIN
 STRTREEVIEW^.SCRLINE:=GETPOS;
 STRTREEVIEW^.REDRAW;
END;
PROCEDURE TSTRTREEVIEW.CALCSCROLL(M:BOOLEAN);
VAR L:LONGINT;
    S:STRING;
BEGIN
 IF M AND (AKTSEL<>NIL) THEN
 BEGIN
  L:=TREE^.EXTRLINE(AKTSEL);
  IF SCRLINE>L THEN SCRLINE:=L;
  IF SCRLINE+(E^.GETH DIV (FONT^.HEIGHT+1))-1<L THEN
  BEGIN
   SCRLINE:=L-(E^.GETH DIV (FONT^.HEIGHT+1))+1;
  END;
 END;
 L:=TREE^.GETLINECOUNT-(E^.GETH DIV (FONT^.HEIGHT+1))+1;
 IF L<0 THEN L:=0;
 SCV^.SETRANGE(L);
 SCV^.SETPOS(SCRLINE);
 REDRAW;
END;
PROCEDURE TSTRTREEVIEWF.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
VAR NO:PSTRTREENODE;
    LEV:DWORD;
    FONT:PFONT;
BEGIN
 IF (GETOLDMOUSEB=0) AND (B=1) THEN
 BEGIN
  FONT:=STRTREEVIEW^.FONT;
  Y:=Y DIV (FONT^.HEIGHT+1);
  INC(X,STRTREEVIEW^.XSCROLL);
  NO:=STRTREEVIEW^.TREE^.GETLINE(LEV,Y+STRTREEVIEW^.SCRLINE);
  IF (NO<>NIL) AND (X>=LEV*10) THEN
  BEGIN
   IF (X<LEV*10+10) THEN
   BEGIN
    IF NO^.UNDER<>NIL THEN
    BEGIN
     STRTREEVIEW^.TREE^.CHANGE(NO);
     STRTREEVIEW^.TREE^.CORRECTSEL(STRTREEVIEW^.AKTSEL);
     STRTREEVIEW^.CALCSCROLL(FALSE);
     STRTREEVIEW^.CALCSCH;
    END;
   END
   ELSE
   BEGIN
    IF (X<LEV*10+10+GETSTRINGWIDTH(NO^.STR,FONT)) AND
       (STRTREEVIEW^.AKTSEL<>NO) THEN
    BEGIN
     STRTREEVIEW^.AKTSEL:=NO;
     STRTREEVIEW^.ONSELECT(NO);
     REDRAW;
    END;
   END;
  END;
 END;
END;
CONSTRUCTOR TSTRTREEVIEWH.INIT(BAS:PSTRTREEVIEW;Y:LONGINT;B:DWORD;VIS:BOOLEAN);
BEGIN
 INHERITED INIT(BAS,BAS,0,Y,20,B,VIS,0,0);
 STRTREEVIEW:=BAS;
END;
CONSTRUCTOR TSTRTREEVIEWV.INIT(BAS:PSTRTREEVIEW;X:LONGINT;H:DWORD;VIS:BOOLEAN);
BEGIN
 INHERITED INIT(BAS,BAS,X,0,H,20,VIS,0,0);
 STRTREEVIEW:=BAS;
END;
CONSTRUCTOR TSTRTREEVIEWF.INIT(BAS:PSTRTREEVIEW;H,B:DWORD);
BEGIN
 INHERITED INIT(BAS,BAS,0,0,H,B,TRUE,GT_NULL);
 STRTREEVIEW:=BAS;
END;
PROCEDURE TSTRTREEVIEWF.ONPAINT;
VAR P:PSTRTREENODE;
    Y:DWORD;
    LEV:DWORD;
BEGIN
 BAR(0,0,GETH,GETB,CL_WHITE);
 WITH STRTREEVIEW^ DO
 BEGIN
  P:=TREE^.GETLINE(LEV,SCRLINE);
  Y:=0;
  WHILE (P<>NIL) AND (Y<GETH) DO
  BEGIN
   IF AKTSEL=P THEN
   BEGIN
    BAR(-XSCROLL+LEV*10+10,Y,FONT^.HEIGHT,GETSTRINGWIDTH(P^.STR,FONT),CL_BLUE);
    PUTSTRING(-XSCROLL+LEV*10+10,Y,P^.STR,CL_YELLOW,FONT);
   END ELSE PUTSTRING(-XSCROLL+LEV*10+10,Y,P^.STR,CL_BLACK,FONT);
   IF P^.UNDER=NIL THEN
   BEGIN
    PUTSTRING(-XSCROLL+LEV*10,Y,' ',CL_BLACK,FONT);
   END ELSE IF P^.EXP THEN
   BEGIN
    PUTSTRING(-XSCROLL+LEV*10,Y,'-',CL_BLACK,FONT)
   END ELSE PUTSTRING(-XSCROLL+LEV*10,Y,'+',CL_BLACK,FONT);
   INC(Y,FONT^.HEIGHT+1);
   P:=TREE^.GETNEXT(LEV,P);
  END;
 END;
END;
CONSTRUCTOR TSTRTREEVIEW.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SC:DWORD;R:STRING;F:PFONT);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_STDOBJ);
 SCB:=SC;
 SCRLINE:=0;
 AKTSEL:=NIL;
 FONT:=F;
 XSCROLL:=0;
 CASE SC OF
  0:
  BEGIN
   NEW(E,INIT(@SELF,GETH,GETB));
   NEW(SCV,INIT(@SELF,GETB-20,GETH-20,FALSE));
   NEW(SCH,INIT(@SELF,GETH-20,GETB-20,FALSE));
  END;
  1:
  BEGIN
   NEW(E,INIT(@SELF,GETH,GETB-20));
   NEW(SCV,INIT(@SELF,GETB-20,GETH,TRUE));
   NEW(SCH,INIT(@SELF,GETH-20,GETB-20,FALSE));
  END;
  2:
  BEGIN
   NEW(E,INIT(@SELF,GETH-20,GETB));
   NEW(SCV,INIT(@SELF,GETB-20,GETH-20,FALSE));
   NEW(SCH,INIT(@SELF,GETH-20,GETB,TRUE));
  END;
  3:
  BEGIN
   NEW(E,INIT(@SELF,GETH-20,GETB-20));
   NEW(SCV,INIT(@SELF,GETB-20,GETH-20,TRUE));
   NEW(SCH,INIT(@SELF,GETH-20,GETB-20,TRUE));
  END;
 END;
 NEW(TREE,INIT(R,0));
 CALCSCROLL(TRUE);
 CALCSCH;
END;
PROCEDURE TMESSAGEBOXWINB.ONCLICK;
BEGIN
 DWORD(MSG^):=MSGN;
END;
CONSTRUCTOR TMESSAGEBOXWINB.INIT(BAS:PMESSAGEBOXWIN;X,Y:LONGINT;S:STRING;F:PFONT;AMSG:POINTER;NR:DWORD);
BEGIN
 INHERITED INIT(BAS,NIL,X,Y,25,120,TRUE,S,NIL,F);
 MSG:=AMSG;
 MSGN:=NR;
END;
CONSTRUCTOR TMESSAGEBOXWIN.INIT(BAS:PDESKTOP;TIT,TXT:STRING;BUTTONS:DWORD;F:PFONT;MSG:POINTER);
CONST MSGSTR:ARRAY[0..5] OF STRING=('Ok','Ja','Nein','Wiederholen','Ignorieren','Abbrechen');
VAR BTS:DWORD;
    X,Y:DWORD;
    WID,HIE:DWORD;
    BUT:PMESSAGEBOXWINB;
    LAB:PLABEL;
    I:DWORD;
    BUTW,STRW:DWORD;
BEGIN
 BTS:=COUNTBITS(BUTTONS);
 IF BTS=0 THEN
 BEGIN
  WRITELN('A Message Window without any buttons ?');
  HALT;
 END;
 BUTW:=BTS*125-5;
 WID:=BUTW;
 STRW:=GETSTRINGWIDTH(TXT,F);
 IF (STRW>WID) THEN
 BEGIN
  IF (STRW<=BAS^.GETB DIV 2) THEN WID:=STRW ELSE
  BEGIN
   IF (BUTW<BAS^.GETB DIV 2) THEN WID:=BAS^.GETB DIV 2;
  END;
 END;
 HIE:=GETMAXWIDTHSTRLINES(TXT,WID,F)*(F^.HEIGHT+1);
 INHERITED INIT(BAS^.ONMODAL,(BAS^.GETB-WID-8) DIV 2,(BAS^.GETH-HIE-64) DIV 2,
                HIE+64,WID+8,TRUE,TIT,FALSE,F);
 NEW(LAB,INIT(@SELF,@SELF,0,0,HIE-1,WID,TRUE,TXT,F));
 X:=(WID+BUTW) DIV 2-120;
 Y:=HIE+5;
 FOR I:=5 DOWNTO 0 DO
 BEGIN
  IF BUTTONS SHR I AND 1<>0 THEN
  BEGIN
   NEW(BUT,INIT(@SELF,X,Y,MSGSTR[I],F,MSG,1 SHL I));
   DEC(X,125);
  END;
 END;
END;
FUNCTION MESSAGEBOX(BAS:PDESKTOP;TIT,TXT:STRING;BUTTONS:DWORD;F:PFONT):DWORD;
VAR W:PMESSAGEBOXWIN;
    MSG:DWORD;
BEGIN
 MSG:=0;
 NEW(W,INIT(BAS,TIT,TXT,BUTTONS,F,@MSG));
 BAS^.MODAL;
 W^.SELECT;
 REPEAT
  RUNWINENGINE;
 UNTIL MSG<>0;
 DISPOSE(W,DONE);
 BAS^.NORMAL;
 MESSAGEBOX:=MSG;
END;
PROCEDURE TDESKTOP.SETCOLOR(COL:DWORD);
BEGIN
 COLOR:=COL;
 BACKGR^.REDRAW;
END;
FUNCTION TDESKTOP.ONMODAL:PWIN;
BEGIN
 ONMODAL:=MODALW;
END;
PROCEDURE TDESKTOP.MODAL;
BEGIN
 MODALW^.SHOW;
END;
PROCEDURE TDESKTOP.NORMAL;
BEGIN
 MODALW^.HIDE;
END;
FUNCTION TDESKTOP.ONTOP:PWIN;
BEGIN
 ONTOP:=TOP;
END;
PROCEDURE TDESKTOPB.ONPAINT;
BEGIN
 BAR(0,0,GETH,GETB,DESKTOP^.COLOR);
END;
CONSTRUCTOR TDESKTOPB.INIT(BAS:PDESKTOP);
BEGIN
 WRITELN(CRSTR,'Create TDesktopb (',DWORD(@SELF),')');
 INHERITED INIT(BAS,NIL,0,0,BAS^.GETH,BAS^.GETB,TRUE,GT_WIN);
 CRLEA;
 DESKTOP:=BAS;
END;
PROCEDURE TDESKTOPM.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
BEGIN
END;
CONSTRUCTOR TDESKTOPM.INIT(BAS:PDESKTOP);
BEGIN
 WRITELN(CRSTR,'Create TDesktopm (',DWORD(@SELF),')');
 INHERITED INIT(BAS,NIL,0,0,BAS^.GETH,BAS^.GETB,FALSE,GT_NULL);
 CRLEA;
 DESKTOP:=BAS;
 ENABLEBLOCK;
END;
CONSTRUCTOR TDESKTOP.INIT(COL:DWORD);
BEGIN
 WRITELN(CRSTR,'Create TDesktop (',DWORD(@SELF),')');
 INHERITED INIT(NIL,NIL,0,0,GRAPH.HEIGHT,GRAPH.WIDTH,TRUE,GT_NULL);
 CRLEA;
 COLOR:=COL;
 NEW(MODALW,INIT(@SELF));
 NEW(TOP,INIT(@SELF,@SELF,0,0,GETH,GETB,TRUE,GT_TRANSPARENT));
 NEW(BACKGR,INIT(@SELF));
 SETAPPFRAME(BACKGR);
END;
PROCEDURE TBAR.ONPAINT;
BEGIN
 BAR(0,0,GETH,GETB,COLOR);
END;
CONSTRUCTOR TBAR.INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;GT,COL:DWORD);
BEGIN
 WRITELN(CRSTR,'Create TBar (',DWORD(@SELF),') : ',X,':',Y,'  ',H,'*',B);
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS,GT);
 CRLEA;
 COLOR:=COL;
END;
PROCEDURE TSTRLISTWIN.SORT;
BEGIN
 STRLISTBOX^.SORT;
END;
FUNCTION TSTRLISTWIN.GETLINE:DWORD;
BEGIN
 GETLINE:=STRLISTBOX^.GETLINE;
END;
PROCEDURE TSTRLISTWIN.CHECKSIZE(VAR H,B:DWORD);
BEGIN
 INHERITED CHECKSIZE(H,B);
 IF LONGINT(H)<93 THEN H:=93;
 IF LONGINT(B)<68 THEN B:=68;
END;
PROCEDURE TSTRLISTWIN.ONRESIZE;
BEGIN
 INHERITED ONRESIZE;
 STRLISTBOX^.SIZE(GETAFH,GETAFB);
END;
FUNCTION TSTRLISTWIN.SAVE(FN:STRING):BOOLEAN;
BEGIN
 SAVE:=STRLISTBOX^.SAVE(FN);
END;
FUNCTION TSTRLISTWIN.LOAD(FN:STRING):BOOLEAN;
BEGIN
 LOAD:=STRLISTBOX^.LOAD(FN);
END;
PROCEDURE TSTRLISTWIN.ONSELECT(LIN:DWORD);
BEGIN
END;
PROCEDURE TSTRLISTWINF.ONSELECT(LIN:DWORD);
BEGIN
 STRLISTWIN^.ONSELECT(LIN);
END;
CONSTRUCTOR TSTRLISTWINF.INIT(BAS:PSTRLISTWIN;SC:DWORD;TF:PFONT);
BEGIN
 INHERITED INIT(BAS,0,0,BAS^.GETAFH,BAS^.GETAFB,TRUE,SC,TF);
 STRLISTWIN:=BAS;
END;
PROCEDURE TSTRLISTWIN.ADDLINE(S:STRING);
BEGIN
 STRLISTBOX^.ADDLINE(S);
END;
CONSTRUCTOR TSTRLISTWIN.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;TIT:STRING;SZ:BOOLEAN;SCB:DWORD;F,TF:PFONT);
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,VIS,TIT,SZ,F);
 NEW(STRLISTBOX,INIT(@SELF,SCB,TF));
END;
PROCEDURE TSTRLISTBOXF.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
VAR NY:LONGINT;
    I,L:DWORD;
    S:STRING;
BEGIN
 IF (GETOLDMOUSEB=0) AND (B=1) THEN
 BEGIN
  NY:=STRLISTBOX^.SCRLINE+Y DIV (STRLISTBOX^.FONT^.HEIGHT+1);
  L:=STRLISTBOX^.TEXT^.LINECOUNT;
  IF NY<0 THEN NY:=0;
  IF NY>=L THEN
  BEGIN
   IF L=0 THEN NY:=0 ELSE NY:=L-1;
  END;
  IF (NY<>STRLISTBOX^.AKTLINE) THEN
  BEGIN
   STRLISTBOX^.AKTLINE:=NY;
   STRLISTBOX^.CALCSCROLL;
   STRLISTBOX^.ONSELECT(NY);
  END;
 END;
END;
PROCEDURE TSTRLISTBOXF.ONPAINT;
VAR Y:LONGINT;
    I,CO:DWORD;
    TXT:PSTRINGLIST;
    IT:PSTRINGITEM;
    S:STRING;
    BX:LONGINT;
BEGIN
 BAR(0,0,GETH,GETB,CL_WHITE);
 TXT:=STRLISTBOX^.TEXT;
 Y:=0;
 CO:=GETH DIV STRLISTBOX^.FONT^.HEIGHT;
 IF TXT^.LINECOUNT<>0 THEN
 BEGIN
  TXT^.GOTOLINE(STRLISTBOX^.SCRLINE);
  FOR I:=0 TO CO DO
  BEGIN
   IT:=TXT^.GETLINE;
   IF IT<>NIL THEN
   BEGIN
    S:=IT^.S;
    IF (IT^.FLAG AND $80000000=0) THEN
    BEGIN
     IF STRLISTBOX^.SCRLINE+I=STRLISTBOX^.AKTLINE THEN
     BEGIN
      IF STRLISTBOX^.HASFOCUS THEN
      BEGIN
       BAR(0,Y,STRLISTBOX^.FONT^.HEIGHT,GETB,CL_BLUE);
       PUTSTRING(-STRLISTBOX^.XSCROLL,Y,S,CL_YELLOW,STRLISTBOX^.FONT);
      END
      ELSE
      BEGIN
       BAR(0,Y,STRLISTBOX^.FONT^.HEIGHT,GETB,CL_GRAY);
       PUTSTRING(-STRLISTBOX^.XSCROLL,Y,S,CL_SILVER,STRLISTBOX^.FONT);
      END;
     END
     ELSE PUTSTRING(-STRLISTBOX^.XSCROLL,Y,S,CL_BLACK,STRLISTBOX^.FONT);
    END
    ELSE
    BEGIN
     IF STRLISTBOX^.SCRLINE+I=STRLISTBOX^.AKTLINE THEN
     BEGIN
      IF STRLISTBOX^.HASFOCUS THEN
      BEGIN
       BAR(0,Y,STRLISTBOX^.FONT^.HEIGHT,GETB,CL_BLUE);
       PUTSTRING(-STRLISTBOX^.XSCROLL,Y,S,CL_RED,STRLISTBOX^.FONT);
      END
      ELSE
      BEGIN
       BAR(0,Y,STRLISTBOX^.FONT^.HEIGHT,GETB,CL_GRAY);
       PUTSTRING(-STRLISTBOX^.XSCROLL,Y,S,CL_BLUE,STRLISTBOX^.FONT);
      END;
     END
     ELSE PUTSTRING(-STRLISTBOX^.XSCROLL,Y,S,CL_GREEN,STRLISTBOX^.FONT);
    END;
    INC(Y,STRLISTBOX^.FONT^.HEIGHT+1);
   END;
  END;
 END;
END;
CONSTRUCTOR TSTRLISTBOXF.INIT(BAS:PSTRLISTBOX;H,B:DWORD);
BEGIN
 WRITELN(CRSTR,'Create TStrlistboxf (',DWORD(@SELF),') : 0:0   ',H,'*',B);
 INHERITED INIT(BAS,BAS,0,0,H,B,TRUE,GT_NULL);
 CRLEA;
 STRLISTBOX:=BAS;
END;
PROCEDURE TSTRLISTBOXV.ONCHANGE;
BEGIN
 STRLISTBOX^.SCRLINE:=GETPOS;
 STRLISTBOX^.REDRAW;
END;
CONSTRUCTOR TSTRLISTBOXV.INIT(BAS:PSTRLISTBOX;X,H:DWORD;VIS:BOOLEAN);
BEGIN
 WRITELN(CRSTR,'Create TStrlistboxv (',DWORD(@SELF),')');
 INHERITED INIT(BAS,BAS,X,0,H,20,VIS,0,0);
 CRLEA;
 STRLISTBOX:=BAS;
END;
PROCEDURE TSTRLISTBOXH.ONCHANGE;
BEGIN
 STRLISTBOX^.XSCROLL:=GETPOS;
 STRLISTBOX^.REDRAW;
END;
CONSTRUCTOR TSTRLISTBOXH.INIT(BAS:PSTRLISTBOX;Y,B:DWORD;VIS:BOOLEAN);
BEGIN
 WRITELN(CRSTR,'Create TSTRLISTBOXh (',DWORD(@SELF),')');
 INHERITED INIT(BAS,BAS,0,Y,20,B,VIS,0,0);
 CRLEA;
 STRLISTBOX:=BAS;
END;
PROCEDURE TSTRLISTBOX.LOADDIR(BAS:STRING);
BEGIN
 TEXT^.LOADDIR(BAS);
 AKTLINE:=$FFFFFFFF;
 XSCROLL:=0;
 SCRLINE:=0;
 CALCSCROLL;
 CALCSCH;
END;
PROCEDURE TSTRLISTBOX.SORT;
BEGIN
 IF TEXT^.LINECOUNT<>0 THEN
 BEGIN
  TEXT^.SORT;
  IF AKTLINE<>$FFFFFFFF THEN ONSELECT(AKTLINE);
  REDRAW;
 END;
END;
FUNCTION TSTRLISTBOX.SAVE(FN:STRING):BOOLEAN;
BEGIN
 SAVE:=TEXT^.SAVE(FN);
END;
FUNCTION TSTRLISTBOX.LOAD(FN:STRING):BOOLEAN;
BEGIN
 LOAD:=TEXT^.LOAD(FN);
 AKTLINE:=0;
 XSCROLL:=0;
 CALCSCROLL;
 IF TEXT^.LINECOUNT<>0 THEN ONSELECT(AKTLINE);
END;
FUNCTION TSTRLISTBOX.GETLINE:DWORD;
BEGIN
 GETLINE:=AKTLINE;
END;
PROCEDURE TSTRLISTBOX.ONSELECT(LIN:DWORD);
BEGIN
 IF ONSELECTP<>NIL THEN ONSELECTP(LIN,@SELF);
END;
PROCEDURE TSTRLISTBOX.CALCSCH;
VAR I,L,S:DWORD;
BEGIN
 MAXSCH:=0;
 L:=TEXT^.LINECOUNT;
 IF L<>0 THEN
 BEGIN
  TEXT^.GOTOLINE(0);
  IF L<>0 THEN
  BEGIN
   FOR I:=0 TO L-1 DO
   BEGIN
    S:=GETSTRINGWIDTH(TEXT^.READLINE,FONT);
    IF S>MAXSCH THEN MAXSCH:=S;
   END;
  END;
 END;
 L:=MAXSCH-E^.GETB+10;
 IF LONGINT(L)<0 THEN L:=0;
 SCH^.SETRANGE(L);
END;
PROCEDURE TSTRLISTBOX.CALCSCROLL;
VAR L:LONGINT;
    AX:LONGINT;
    CONT:STRING;
BEGIN
 IF (TEXT^.LINECOUNT<>0) AND (AKTLINE<>$FFFFFFFF) THEN
 BEGIN
  TEXT^.GOTOLINE(AKTLINE);
  CONT:=TEXT^.READLINE;
  IF SCRLINE>AKTLINE THEN SCRLINE:=AKTLINE;
  IF SCRLINE+(E^.GETH DIV (FONT^.HEIGHT+1))-1<AKTLINE THEN
  BEGIN
   SCRLINE:=AKTLINE-(E^.GETH DIV (FONT^.HEIGHT+1))+1;
  END;
 END;
 L:=TEXT^.LINECOUNT-(E^.GETH DIV (FONT^.HEIGHT+1))+1;
 IF L<0 THEN L:=0;
 SCV^.SETPOS(SCRLINE);
 SCV^.SETRANGE(L);
 CALCSCH;
 SCH^.SETPOS(XSCROLL);
 REDRAW;
END;
PROCEDURE TSTRLISTBOX.ONKEY(C,C2:CHAR);
VAR LIM,OL:DWORD;
BEGIN
 OL:=AKTLINE;
 IF AKTLINE=$FFFFFFFF THEN
 BEGIN
  AKTLINE:=0;
 END
 ELSE
 BEGIN
  CASE C OF
   #13:ONSELECT(AKTLINE);
   #0:
   BEGIN
    CASE C2 OF
     #71:IF AKTLINE>0 THEN AKTLINE:=0;
     #72:IF AKTLINE>0 THEN DEC(AKTLINE);
     #79:
     BEGIN
      LIM:=TEXT^.LINECOUNT;
      IF LIM<>0 THEN IF AKTLINE<LIM-1 THEN AKTLINE:=LIM-1;
     END;
     #80:
     BEGIN
      LIM:=TEXT^.LINECOUNT;
      IF (LIM<>0) AND (AKTLINE<LIM-1) THEN INC(AKTLINE);
     END;
    END;
   END;
  END;
 END;
 IF (AKTLINE<>OL) THEN CALCSCROLL;
END;
PROCEDURE TSTRLISTBOX.CHECKSIZE(VAR H,B:DWORD);
BEGIN
 IF LONGINT(H)<21 THEN H:=21;
 IF LONGINT(B)<21 THEN B:=21;
END;
PROCEDURE TSTRLISTBOX.SIZE(H,B:DWORD);
VAR L:LONGINT;
BEGIN
 INHERITED SIZE(H,B);
 CASE SCB OF
  0:E^.SIZE(GETH,GETB);
  1:
  BEGIN
   SCV^.MOVESIZE(GETB-20,0,GETH,20);
   E^.SIZE(GETH,GETB-20);
  END;
  2:
  BEGIN
   SCV^.MOVESIZE(0,GETH-20,20,GETB);
   E^.SIZE(GETH-20,GETB);
  END;
  3:
  BEGIN
   SCV^.MOVESIZE(GETB-20,0,GETH-20,20);
   SCH^.MOVESIZE(0,GETH-20,20,GETB-20);
   E^.SIZE(GETH-20,GETB-20);
  END;
 END;
 L:=MAXSCH-E^.GETB+10;
 IF L<0 THEN L:=0;
 SCH^.SETRANGE(L);
 L:=TEXT^.LINECOUNT-(E^.GETH DIV (FONT^.HEIGHT+1))+1;
 IF L<0 THEN L:=0;
 SCV^.SETRANGE(L);
END;
PROCEDURE TSTRLISTBOX.ONSELECT(FOC:BOOLEAN);
BEGIN
 IF FOC THEN REDRAW;
END;
PROCEDURE TSTRLISTBOX.ONUNSELECT;
BEGIN
 REDRAW;
END;
FUNCTION TSTRLISTBOX.READLINE(NR:DWORD):STRING;
BEGIN
 IF NR<TEXT^.LINECOUNT THEN
 BEGIN
  READLINE:=TEXT^.READLINE(NR);
 END ELSE READLINE:='';
END;
PROCEDURE TSTRLISTBOX.ADDLINE(S:STRING);
BEGIN
 TEXT^.INSERT(TEXT^.LINECOUNT,0,S);
 CALCSCH;
 CALCSCROLL;
END;
CONSTRUCTOR TSTRLISTBOX.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SC:DWORD;F:PFONT);
BEGIN
 WRITELN(CRSTR,'Create TStrlistbox (',DWORD(@SELF),') : ',X,':',Y,'  ',H,'*',B);
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_STDOBJ);
 CRLEA;
 NEW(TEXT,INIT);
 FONT:=F;
 SCB:=SC;
 XSCROLL:=0;
 AKTLINE:=$FFFFFFFF;
 SCRLINE:=0;
 ONSELECTP:=NIL;
 CASE SC OF
  0:
  BEGIN
   NEW(E,INIT(@SELF,GETH,GETB));
   NEW(SCV,INIT(@SELF,GETB-20,GETH-20,SCB AND 1<>0));
   NEW(SCH,INIT(@SELF,GETH-20,GETB-20,SCB AND 2<>0));
  END;
  1:
  BEGIN
   NEW(E,INIT(@SELF,GETH,GETB-20));
   NEW(SCV,INIT(@SELF,GETB-20,GETH,SCB AND 1<>0));
   NEW(SCH,INIT(@SELF,GETH-20,GETB-20,SCB AND 2<>0));
  END;
  2:
  BEGIN
   NEW(E,INIT(@SELF,GETH-20,GETB));
   NEW(SCV,INIT(@SELF,GETB-20,GETH-20,SCB AND 1<>0));
   NEW(SCH,INIT(@SELF,GETH-20,GETB,SCB AND 2<>0));
  END;
  3:
  BEGIN
   NEW(E,INIT(@SELF,GETH-20,GETB-20));
   NEW(SCV,INIT(@SELF,GETB-20,GETH-20,SCB AND 1<>0));
   NEW(SCH,INIT(@SELF,GETH-20,GETB-20,SCB AND 2<>0));
  END;
 END;
 CALCSCH;
END;
PROCEDURE TMEMOWIN.CLEAR;
BEGIN
 MEMO^.CLEAR;
END;
FUNCTION TMEMOWIN.LOAD(FN:STRING):BOOLEAN;
BEGIN
 LOAD:=MEMO^.LOAD(FN);
END;
FUNCTION TMEMOWIN.SAVE(FN:STRING):BOOLEAN;
BEGIN
 SAVE:=MEMO^.SAVE(FN);
END;
FUNCTION TMEMOWIN.GETLINE:DWORD;
BEGIN
 GETLINE:=MEMO^.GETLINE;
END;
FUNCTION TMEMOWIN.GETCOLUM:DWORD;
BEGIN
 GETCOLUM:=MEMO^.GETCOLUM;
END;
PROCEDURE TMEMOWIN.ONCHANGE;
BEGIN
END;
PROCEDURE TMEMOWIN.ONNEWPOS;
BEGIN
END;
PROCEDURE TMEMOWINF.ONCHANGE;
BEGIN
 MEMOWIN^.ONCHANGE;
END;
PROCEDURE TMEMOWINF.ONNEWPOS;
BEGIN
 MEMOWIN^.ONNEWPOS;
END;
CONSTRUCTOR TMEMOWINF.INIT(BAS:PMEMOWIN;SC:DWORD;TF:PFONT);
BEGIN
 INHERITED INIT(BAS,0,0,BAS^.GETAFH,BAS^.GETAFB,TRUE,SCB,TF);
 MEMOWIN:=BAS;
END;
PROCEDURE TMEMOWIN.CHECKSIZE(VAR H,B:DWORD);
BEGIN
 INHERITED CHECKSIZE(H,B);
 IF LONGINT(H)<93 THEN H:=93;
 IF LONGINT(B)<68 THEN B:=68;
END;
PROCEDURE TMEMOWIN.ONRESIZE;
BEGIN
 INHERITED ONRESIZE;
 MEMO^.SIZE(GETAFH,GETAFB);
END;
CONSTRUCTOR TMEMOWIN.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;
                          TIT:STRING;SZ:BOOLEAN;SCB:DWORD;F,TF:PFONT);
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,VIS,TIT,SZ,F);
 NEW(MEMO,INIT(@SELF,SCB,TF));
END;
PROCEDURE TMEMOF.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
VAR NX,NY:LONGINT;
    I,L:DWORD;
    S:STRING;
BEGIN
 IF B=1 THEN
 BEGIN
  NY:=MEMO^.SCRLINE+Y DIV (MEMO^.FONT^.HEIGHT+1);
  L:=MEMO^.TEXT^.LINECOUNT;
  IF NY<0 THEN NY:=0;
  IF NY>=L THEN
  BEGIN
   IF L=0 THEN NY:=0 ELSE NY:=L-1;
  END;
  MEMO^.TEXT^.GOTOLINE(NY);
  S:=MEMO^.TEXT^.READLINE;
  NX:=0;
  INC(X,MEMO^.XSCROLL);
  WHILE (NX<LENGTH(S)) AND (X>LONGINT(GETSTRINGWIDTH(SYSTEM.COPY(S,1,NX+1),MEMO^.FONT))) DO INC(NX);
  IF (NX<>MEMO^.AKTCOLUM) OR (NY<>MEMO^.AKTLINE) THEN
  BEGIN
   MEMO^.AKTCOLUM:=NX;
   MEMO^.AKTLINE:=NY;
   MEMO^.ONNEWPOS(NY,NX);
   MEMO^.CALCSCROLL;
  END;
 END;
END;
PROCEDURE TMEMOF.ONPAINT;
VAR Y:LONGINT;
    I,CO:DWORD;
    TXT:PSTRINGLIST;
    S:STRING;
    BX:LONGINT;
BEGIN
 BAR(0,0,GETH,GETB,CL_WHITE);
 TXT:=MEMO^.TEXT;
 Y:=0;
 CO:=GETH DIV MEMO^.FONT^.HEIGHT;
 TXT^.GOTOLINE(MEMO^.SCRLINE);
 FOR I:=0 TO CO DO
 BEGIN
  S:=TXT^.READLINE;
  PUTSTRING(-MEMO^.XSCROLL,Y,S,CL_BLACK,MEMO^.FONT);
  IF MEMO^.SCRLINE+I=MEMO^.AKTLINE THEN
  BEGIN
   BX:=GETSTRINGWIDTH(SYSTEM.COPY(S,1,MEMO^.AKTCOLUM),MEMO^.FONT)-MEMO^.XSCROLL;
   BAR(BX,Y,MEMO^.FONT^.HEIGHT,2,CL_RED);
  END;
  INC(Y,MEMO^.FONT^.HEIGHT+1);
 END;
END;
CONSTRUCTOR TMEMOF.INIT(BAS:PMEMO;H,B:DWORD);
BEGIN
 WRITELN(CRSTR,'Create Memof (',DWORD(@SELF),') : 0:0   ',H,'*',B);
 INHERITED INIT(BAS,BAS,0,0,H,B,TRUE,GT_NULL);
 CRLEA;
 MEMO:=BAS;
END;
PROCEDURE TMEMOV.ONCHANGE;
BEGIN
 MEMO^.SCRLINE:=GETPOS;
 MEMO^.REDRAW;
END;
CONSTRUCTOR TMEMOV.INIT(BAS:PMEMO;X,H:DWORD;VIS:BOOLEAN);
BEGIN
 WRITELN(CRSTR,'Create TMemov (',DWORD(@SELF),')');
 INHERITED INIT(BAS,BAS,X,0,H,20,VIS,0,0);
 CRLEA;
 MEMO:=BAS;
END;
PROCEDURE TMEMOH.ONCHANGE;
BEGIN
 MEMO^.XSCROLL:=GETPOS;
 MEMO^.REDRAW;
END;
CONSTRUCTOR TMEMOH.INIT(BAS:PMEMO;Y,B:DWORD;VIS:BOOLEAN);
BEGIN
 WRITELN(CRSTR,'Create TMemoh (',DWORD(@SELF),')');
 INHERITED INIT(BAS,BAS,0,Y,20,B,VIS,0,0);
 CRLEA;
 MEMO:=BAS;
END;
PROCEDURE TMEMO.CLEAR;
BEGIN
 TEXT^.CLEAR;
END;
FUNCTION TMEMO.SAVE(FN:STRING):BOOLEAN;
BEGIN
 SAVE:=TEXT^.SAVE(FN);
END;
FUNCTION TMEMO.LOAD(FN:STRING):BOOLEAN;
BEGIN
 LOAD:=TEXT^.LOAD(FN);
 AKTLINE:=0;
 AKTCOLUM:=0;
 CALCSCROLL;
END;
FUNCTION TMEMO.GETCOLUM:DWORD;
BEGIN
 GETCOLUM:=AKTCOLUM;
END;
FUNCTION TMEMO.GETLINE:DWORD;
BEGIN
 GETLINE:=AKTLINE;
END;
PROCEDURE TMEMO.ONNEWPOS(LIN,COL:DWORD);
BEGIN
END;
PROCEDURE TMEMO.ONCHANGE;
BEGIN
END;
PROCEDURE TMEMO.CALCSCH;
VAR I,L,S:DWORD;
BEGIN
 TEXT^.GOTOLINE(0);
 L:=TEXT^.LINECOUNT;
 MAXSCH:=0;
 IF L<>0 THEN
 BEGIN
  FOR I:=0 TO L-1 DO
  BEGIN
   S:=GETSTRINGWIDTH(TEXT^.READLINE,FONT);
   IF S>MAXSCH THEN MAXSCH:=S;
  END;
 END;
 L:=MAXSCH-E^.GETB+10;
 IF LONGINT(L)<0 THEN L:=0;
 SCH^.SETRANGE(L);
END;
PROCEDURE TMEMO.CALCSCROLL;
VAR L:LONGINT;
    AX:LONGINT;
    CONT:STRING;
BEGIN
 TEXT^.GOTOLINE(AKTLINE);
 CONT:=TEXT^.READLINE;
 AX:=GETSTRINGWIDTH(SYSTEM.COPY(CONT,1,AKTCOLUM),FONT);
 IF XSCROLL>AX THEN
 BEGIN
  IF AX>20 THEN XSCROLL:=AX-20 ELSE XSCROLL:=0;
 END;
 IF XSCROLL+E^.GETB-11<=AX THEN XSCROLL:=AX-E^.GETB+10;
 IF SCRLINE>AKTLINE THEN SCRLINE:=AKTLINE;
 IF SCRLINE+(E^.GETH DIV (FONT^.HEIGHT+1))-1<AKTLINE THEN
 BEGIN
  SCRLINE:=AKTLINE-(E^.GETH DIV (FONT^.HEIGHT+1))+1;
 END;
 L:=TEXT^.LINECOUNT-(E^.GETH DIV (FONT^.HEIGHT+1))+1;
 IF L<0 THEN L:=0;
 SCV^.SETRANGE(L);
 SCV^.SETPOS(SCRLINE);
 CALCSCH;
 SCH^.SETPOS(XSCROLL);
 REDRAW;
END;
PROCEDURE TMEMO.ONKEY(C,C2:CHAR);
VAR LIM:DWORD;
    OL,OC:DWORD;
BEGIN
 OL:=AKTLINE;
 OC:=AKTCOLUM;
 CASE C OF
  #0:
  BEGIN
   CASE C2 OF
    #71:IF AKTCOLUM>0 THEN
    BEGIN
     AKTCOLUM:=0;
     CALCSCROLL;
    END;
    #72:
    BEGIN
     IF AKTLINE>0 THEN
     BEGIN
      DEC(AKTLINE);
      LIM:=TEXT^.LINELEN(AKTLINE);
      IF AKTCOLUM>LIM THEN AKTCOLUM:=LIM;
      CALCSCROLL;
     END;
    END;
    #75:
    BEGIN
     IF AKTCOLUM>0 THEN
     BEGIN
      DEC(AKTCOLUM);
      CALCSCROLL;
     END
     ELSE
     BEGIN
      IF AKTLINE>0 THEN
      BEGIN
       DEC(AKTLINE);
       AKTCOLUM:=TEXT^.LINELEN(AKTLINE);
       CALCSCROLL;
      END;
     END;
    END;
    #77:
    BEGIN
     LIM:=TEXT^.LINELEN(AKTLINE);
     IF AKTCOLUM<LIM THEN
     BEGIN
      INC(AKTCOLUM);
      CALCSCROLL;
     END
     ELSE
     BEGIN
      INC(AKTLINE);
      AKTCOLUM:=0;
      CALCSCROLL;
     END;
    END;
    #79:
    BEGIN
     LIM:=TEXT^.LINELEN(AKTLINE);
     IF AKTCOLUM<LIM THEN
     BEGIN
      AKTCOLUM:=LIM;
      CALCSCROLL;
     END;
    END;
    #80:
    BEGIN
     INC(AKTLINE);
     LIM:=TEXT^.LINELEN(AKTLINE);
     IF AKTCOLUM>LIM THEN AKTCOLUM:=LIM;
     CALCSCROLL;
    END;
    #83:
    BEGIN
     TEXT^.DELETE(AKTLINE,AKTCOLUM);
     ONCHANGE;
     CALCSCROLL;
    END;
   END;
  END;
  #8:
  BEGIN
   TEXT^.DELETELAST(AKTLINE,AKTCOLUM);
   IF AKTCOLUM=0 THEN
   BEGIN
    IF AKTLINE>0 THEN
    BEGIN
     DEC(AKTLINE);
     AKTCOLUM:=TEXT^.LINELEN(AKTLINE);
     ONCHANGE;
    END;
   END
   ELSE
   BEGIN
    DEC(AKTCOLUM);
    ONCHANGE;
   END;
   CALCSCROLL;
  END;
  #13:
  BEGIN
   TEXT^.INSERTLINE(AKTLINE,AKTCOLUM);
   INC(AKTLINE);
   AKTCOLUM:=0;
   ONCHANGE;
   CALCSCROLL;
  END;
  ELSE
  BEGIN
   IF AKTCOLUM<255 THEN
   BEGIN
    TEXT^.INSERT(AKTLINE,AKTCOLUM,C);
    INC(AKTCOLUM);
    ONCHANGE;
    CALCSCROLL;
   END;
  END;
 END;
 IF (AKTLINE<>OL) OR (AKTCOLUM<>OC) THEN ONNEWPOS(AKTLINE,AKTCOLUM);
END;
PROCEDURE TMEMO.CHECKSIZE(VAR H,B:DWORD);
BEGIN
 IF LONGINT(H)<21 THEN H:=21;
 IF LONGINT(B)<21 THEN B:=21;
END;
PROCEDURE TMEMO.SIZE(H,B:DWORD);
VAR L:LONGINT;
BEGIN
 INHERITED SIZE(H,B);
 CASE SCB OF
  0:E^.SIZE(GETH,GETB);
  1:
  BEGIN
   SCV^.MOVESIZE(GETB-20,0,GETH,20);
   E^.SIZE(GETH,GETB-20);
  END;
  2:
  BEGIN
   SCV^.MOVESIZE(0,GETH-20,20,GETB);
   E^.SIZE(GETH-20,GETB);
  END;
  3:
  BEGIN
   SCV^.MOVESIZE(GETB-20,0,GETH-20,20);
   SCH^.MOVESIZE(0,GETH-20,20,GETB-20);
   E^.SIZE(GETH-20,GETB-20);
  END;
 END;
 L:=MAXSCH-E^.GETB+10;
 IF L<0 THEN L:=0;
 SCH^.SETRANGE(L);
 L:=TEXT^.LINECOUNT-(E^.GETH DIV (FONT^.HEIGHT+1))+1;
 IF L<0 THEN L:=0;
 SCV^.SETRANGE(L);
END;
PROCEDURE TMEMO.ONDONE;
BEGIN
 DISPOSE(TEXT,DONE);
END;
CONSTRUCTOR TMEMO.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SC:DWORD;F:PFONT);
BEGIN
 WRITELN(CRSTR,'Create Memo (',DWORD(@SELF),') : ',X,':',Y,'  ',H,'*',B);
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_STDOBJ);
 NEW(TEXT,INIT);
 CRLEA;
 FONT:=F;
 SCB:=SC;
 XSCROLL:=0;
 AKTLINE:=0;
 AKTCOLUM:=0;
 SCRLINE:=0;
 CASE SC OF
  0:
  BEGIN
   NEW(E,INIT(@SELF,GETH,GETB));
   NEW(SCV,INIT(@SELF,GETB-20,GETH-20,FALSE));
   NEW(SCH,INIT(@SELF,GETH-20,GETB-20,FALSE));
  END;
  1:
  BEGIN
   NEW(E,INIT(@SELF,GETH,GETB-20));
   NEW(SCV,INIT(@SELF,GETB-20,GETH,TRUE));
   NEW(SCH,INIT(@SELF,GETH-20,GETB-20,FALSE));
  END;
  2:
  BEGIN
   NEW(E,INIT(@SELF,GETH-20,GETB));
   NEW(SCV,INIT(@SELF,GETB-20,GETH-20,FALSE));
   NEW(SCH,INIT(@SELF,GETH-20,GETB,TRUE));
  END;
  3:
  BEGIN
   NEW(E,INIT(@SELF,GETH-20,GETB-20));
   NEW(SCV,INIT(@SELF,GETB-20,GETH-20,TRUE));
   NEW(SCH,INIT(@SELF,GETH-20,GETB-20,TRUE));
  END;
 END;
 CALCSCH;
END;
PROCEDURE TINPUTLINE.GOTOP(X:DWORD);
BEGIN
 IF X>LENGTH(CONT) THEN X:=LENGTH(CONT);
 IF CURS<>X THEN
 BEGIN
  CURS:=X;
  CALCCURX;
 END;
END;
PROCEDURE TINPUTLINE.DELETE;
BEGIN
 IF CURS<LENGTH(CONT) THEN
 BEGIN
  SYSTEM.DELETE(CONT,CURS+1,1);
  ONCHANGE;
  REDRAW;
 END;
END;
PROCEDURE TINPUTLINE.GOTOEND;
BEGIN
 CURS:=LENGTH(CONT);
 CALCCURX;
END;
PROCEDURE TINPUTLINE.GOTONEXT;
BEGIN
 IF CURS<LENGTH(CONT) THEN
 BEGIN
  INC(CURS);
  CALCCURX;
 END;
END;
PROCEDURE TINPUTLINE.GOTOLAST;
BEGIN
 IF CURS>0 THEN
 BEGIN
  DEC(CURS);
  CALCCURX;
 END;
END;
PROCEDURE TINPUTLINE.CALCCURX;
VAR AX:LONGINT;
BEGIN
 AX:=GETSTRINGWIDTH(SYSTEM.COPY(CONT,1,CURS),FONT);
 IF CURX>AX THEN
 BEGIN
  IF AX>20 THEN CURX:=AX-20 ELSE CURX:=0;
 END;
 IF CURX+GETB-11<=AX THEN CURX:=AX-GETB+10;
 REDRAW;
END;
PROCEDURE TINPUTLINE.GOTOPOS1;
BEGIN
 CURS:=0;
 CALCCURX;
END;
PROCEDURE TINPUTLINE.DELETELAST;
BEGIN
 IF CURS>0 THEN
 BEGIN
  SYSTEM.DELETE(CONT,CURS,1);
  DEC(CURS);
  ONCHANGE;
  CALCCURX;
 END;
END;
PROCEDURE TINPUTLINE.INSERTCHAR(C:CHAR);
BEGIN
 IF LENGTH(CONT)<255 THEN
 BEGIN
  INC(CURS);
  INSERT(C,CONT,CURS);
  ONCHANGE;
  CALCCURX;
 END;
END;
PROCEDURE TINPUTLINE.ONSELECT(FOC:BOOLEAN);
BEGIN
 IF FOC THEN REDRAW;
END;
PROCEDURE TINPUTLINE.ONRETURN;
BEGIN
 IF ONRETURNP<>NIL THEN ONRETURNP(@SELF);
END;
PROCEDURE TINPUTLINE.ONCHANGE;
BEGIN
END;
PROCEDURE TINPUTLINE.SETTEXT(S:STRING);
BEGIN
 IF CONT<>S THEN
 BEGIN
  CONT:=S;
  IF CURS>LENGTH(S) THEN CURS:=LENGTH(S);
  ONCHANGE;
  CALCCURX;
 END;
END;
FUNCTION TINPUTLINE.GETTEXT:STRING;
BEGIN
 GETTEXT:=CONT;
END;
PROCEDURE TINPUTLINE.ONMOUSE(MX,MY:LONGINT;MB:DWORD;ABX,ABY:LONGINT);
VAR AX,NEWS:DWORD;
BEGIN
 IF MB=1 THEN
 BEGIN
  NEWS:=GETSTRINGCHARXPOS(CONT,MX+CURX-3,FONT);
  IF NEWS>LENGTH(CONT) THEN NEWS:=LENGTH(CONT);
  IF NEWS<>CURS THEN
  BEGIN
   CURS:=NEWS;
   AX:=GETSTRINGWIDTH(SYSTEM.COPY(CONT,1,NEWS),FONT);
   IF CURX>AX THEN
   BEGIN
    IF AX>20 THEN CURX:=AX-20 ELSE CURX:=0;
   END;
   IF CURX+GETB-11<=AX THEN CURX:=AX-GETB+10;
   REDRAW;
  END;
 END;
END;
PROCEDURE TINPUTLINE.ONKEY(C1,C2:CHAR);
BEGIN
 CASE C1 OF
  #0:
  BEGIN
   CASE C2 OF
    #71:GOTOPOS1;
    #75:GOTOLAST;
    #77:GOTONEXT;
    #79:GOTOEND;
    #83:DELETE;
   END;
  END;
  #8:DELETELAST;
  #13:ONRETURN;
  ELSE INSERTCHAR(C1);
 END;
END;
PROCEDURE TINPUTLINE.ONPAINT;
BEGIN
 BAR(2,2,GETH-4,GETB-4,CL_WHITE);
 PUTSTRING(-CURX+4,(GETH-FONT^.HEIGHT) DIV 2,CONT,CL_BLACK,FONT);
 IF HASFOCUS THEN
 BEGIN
  BAR(GETSTRINGWIDTH(SYSTEM.COPY(CONT,1,CURS),FONT)+3-CURX,4,GETH-8,2,CL_RED);
 END ELSE BAR(GETSTRINGWIDTH(SYSTEM.COPY(CONT,1,CURS),FONT)+3-CURX,4,GETH-8,2,CL_GRAY);
 FRAMEI3D(0,0,GETH,GETB);
END;
CONSTRUCTOR TINPUTLINE.INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;F:PFONT);
BEGIN
 WRITELN(CRSTR,'Create Inputline (',DWORD(@SELF),') : ',X,':',Y,'  ',H,'*',B);
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS,GT_STDOBJ);
 CRLEA;
 CONT:='';
 CURX:=0;
 CURS:=0;
 FONT:=F;
 ONRETURNP:=NIL;
END;
PROCEDURE THSCROLLBAR.SETRANGE(W:DWORD);
BEGIN
 IF W<>POINTS THEN
 BEGIN
  POINTS:=W;
  CALCBAR;
  SETPOS(POS);
 END;
END;
PROCEDURE THSCROLLBAR.SIZE(H,B:DWORD);
BEGIN
 INHERITED SIZE(H,B);
 CALCBAR;
END;
PROCEDURE THSCROLLBAR.ONCHANGE;
BEGIN
END;
FUNCTION THSCROLLBAR.GETPOS:DWORD;
BEGIN
 GETPOS:=POS;
END;
PROCEDURE THSCROLLBAR.SETPOS(W:DWORD);
BEGIN
 IF LONGINT(W)>LONGINT(POINTS-1) THEN W:=POINTS-1;
 IF LONGINT(W)<0 THEN W:=0;
 IF POS<>W THEN
 BEGIN
  POS:=W;
  IF BARVIS THEN BARPOS:=ROUND(POS*MULTIPL);
  ONCHANGE;
  REDRAW;
 END;
END;
PROCEDURE THSCROLLBAR.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
VAR NY:LONGINT;
BEGIN
 CASE BSTAT OF
  0:IF (GETOLDMOUSEB=0) AND (B=1) THEN
  BEGIN
   OLDPOS:=POS;
   IF (X<20) THEN
   BEGIN
    BSTAT:=2;
    SETPOS(POS-1);
    REDRAW;
   END ELSE IF (X>=GETB-20) THEN
   BEGIN
    BSTAT:=3;
    SETPOS(POS+1);
    REDRAW;
   END ELSE IF (BARVIS) THEN
   BEGIN
    BSTAT:=1;
    NY:=X-20-BARSIZE DIV 2;
    IF NY<0 THEN NY:=0;
    IF NY>GETB-40-BARSIZE THEN NY:=GETB-40-BARSIZE;
    SETPOS(ROUND(NY/MULTIPL));
   END;
  END;
  1:IF B=1 THEN
  BEGIN
   NY:=X-20-BARSIZE DIV 2;
   IF NY<0 THEN NY:=0;
   IF NY>GETB-40-BARSIZE THEN NY:=GETB-40-BARSIZE;
   SETPOS(ROUND(NY/MULTIPL));
  END
  ELSE
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
  END;
  2:IF B<>1 THEN
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
   REDRAW;
  END;
  3:IF B<>1 THEN
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
   REDRAW;
  END;
 END;
END;
PROCEDURE THSCROLLBAR.CALCBAR;
VAR H:DWORD;
BEGIN
 IF GETB>=52 THEN
 BEGIN
  H:=GETB-40;
  BARVIS:=TRUE;
  IF POINTS<>0 THEN BARSIZE:=H-(POINTS-1) ELSE BARSIZE:=H;
  IF LONGINT(BARSIZE)<12 THEN BARSIZE:=12; { Force ! }
  IF POINTS>1 THEN
  BEGIN
   MULTIPL:=(H-BARSIZE)/(POINTS-1);
  END
  ELSE
  BEGIN
   MULTIPL:=1;
  END;
  BARPOS:=ROUND(POS*MULTIPL);
 END ELSE BARVIS:=FALSE;
END;
PROCEDURE THSCROLLBAR.ONPAINT;
VAR X:LONGINT;
    H:DWORD;
BEGIN
 BAR(0,0,GETH,GETB,CL_RED);
 IF BSTAT<>3 THEN
 BEGIN
  BAR3D(GETB-20,0,GETH,20);
  DRAWSPOINTERRIGHT(GETB-12,GETH DIV 2-4,4,CL_BLACK);
 END
 ELSE
 BEGIN
  BARI3D(GETB-20,0,GETH,20);
  DRAWSPOINTERRIGHT(GETB-11,GETH DIV 2-3,4,CL_BLACK);
 END;
 IF BSTAT<>2 THEN
 BEGIN
  BAR3D(0,0,GETH,20);
  DRAWSPOINTERLEFT(8,GETH DIV 2-4,4,CL_BLACK);
 END
 ELSE
 BEGIN
  BARI3D(0,0,GETH,20);
  DRAWSPOINTERLEFT(9,GETH DIV 2-3,4,CL_BLACK);
 END;
 IF BARVIS THEN
 BEGIN
  BAR3D(20+BARPOS,0,GETH,BARSIZE);
  X:=20+BARPOS+BARSIZE DIV 2;
  H:=GETH-8;
  BAR(X-4,4,H,1,CL_GRAY);
  BAR(X-3,4,H,1,CL_LSILVER);
  BAR(X-1,4,H,1,CL_GRAY);
  BAR(X,4,H,1,CL_LSILVER);
  BAR(X+2,4,H,1,CL_GRAY);
  BAR(X+3,4,H,1,CL_LSILVER);
 END;
END;
CONSTRUCTOR THSCROLLBAR.INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SP,MP:DWORD);
BEGIN
 WRITELN(CRSTR,'Create HScrollbar (',DWORD(@SELF),') : ',X,':',Y,'  ',H,'*',B);
 IF GR=NIL THEN GR:=BAS;
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS,GT_NULL);
 CRLEA;
 POINTS:=MP;
 IF MP=0 THEN SP:=0 ELSE IF SP>=MP THEN SP:=MP-1;
 POS:=SP;
 BSTAT:=0;
 CALCBAR;
END;
PROCEDURE TVSCROLLBAR.SETRANGE(W:DWORD);
BEGIN
 IF W<>POINTS THEN
 BEGIN
  POINTS:=W;
  CALCBAR;
  SETPOS(POS);
 END;
END;
PROCEDURE TVSCROLLBAR.SIZE(H,B:DWORD);
BEGIN
 INHERITED SIZE(H,B);
 CALCBAR;
END;
PROCEDURE TVSCROLLBAR.ONCHANGE;
BEGIN
END;
FUNCTION TVSCROLLBAR.GETPOS:DWORD;
BEGIN
 GETPOS:=POS;
END;
PROCEDURE TVSCROLLBAR.SETPOS(W:DWORD);
BEGIN
 IF LONGINT(W)>LONGINT(POINTS-1) THEN W:=POINTS-1;
 IF LONGINT(W)<0 THEN W:=0;
 IF POS<>W THEN
 BEGIN
  POS:=W;
  IF BARVIS THEN BARPOS:=ROUND(POS*MULTIPL);
  ONCHANGE;
  REDRAW;
 END;
END;
PROCEDURE TVSCROLLBAR.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
VAR NY:LONGINT;
BEGIN
 CASE BSTAT OF
  0:IF (GETOLDMOUSEB=0) AND (B=1) THEN
  BEGIN
   OLDPOS:=POS;
   IF (Y<20) THEN
   BEGIN
    BSTAT:=2;
    SETPOS(POS-1);
    REDRAW;
   END ELSE IF (Y>=GETH-20) THEN
   BEGIN
    BSTAT:=3;
    SETPOS(POS+1);
    REDRAW;
   END ELSE IF (BARVIS) THEN
   BEGIN
    BSTAT:=1;
    NY:=Y-20-BARSIZE DIV 2;
    IF NY<0 THEN NY:=0;
    IF NY>GETH-40-BARSIZE THEN NY:=GETH-40-BARSIZE;
    SETPOS(ROUND(NY/MULTIPL));
   END;
  END;
  1:IF B=1 THEN
  BEGIN
   NY:=Y-20-BARSIZE DIV 2;
   IF NY<0 THEN NY:=0;
   IF NY>GETH-40-BARSIZE THEN NY:=GETH-40-BARSIZE;
   SETPOS(ROUND(NY/MULTIPL));
  END
  ELSE
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
  END;
  2:IF B<>1 THEN
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
   REDRAW;
  END;
  3:IF B<>1 THEN
  BEGIN
   IF B<>0 THEN SETPOS(OLDPOS);
   BSTAT:=0;
   REDRAW;
  END;
 END;
END;
PROCEDURE TVSCROLLBAR.CALCBAR;
VAR H:DWORD;
BEGIN
 IF GETH>=52 THEN
 BEGIN
  H:=GETH-40;
  BARVIS:=TRUE;
  IF POINTS<>0 THEN BARSIZE:=H-(POINTS-1) ELSE BARSIZE:=H;
  IF LONGINT(BARSIZE)<12 THEN BARSIZE:=12; { Force ! }
  IF POINTS>1 THEN
  BEGIN
   MULTIPL:=(H-BARSIZE)/(POINTS-1);
  END
  ELSE
  BEGIN
   MULTIPL:=1;
  END;
  BARPOS:=ROUND(POS*MULTIPL);
 END ELSE BARVIS:=FALSE;
END;
PROCEDURE TVSCROLLBAR.ONPAINT;
VAR Y:LONGINT;
    B:DWORD;
BEGIN
 BAR(0,0,GETH,GETB,CL_RED);
 IF BSTAT<>3 THEN
 BEGIN
  BAR3D(0,GETH-20,20,GETB);
  DRAWSPOINTERDOWN(GETB DIV 2-4,GETH-12,4,CL_BLACK);
 END
 ELSE
 BEGIN
  BARI3D(0,GETH-20,20,GETB);
  DRAWSPOINTERDOWN(GETB DIV 2-3,GETH-11,4,CL_BLACK);
 END;
 IF BSTAT<>2 THEN
 BEGIN
  BAR3D(0,0,20,GETB);
  DRAWSPOINTERUP(GETB DIV 2-4,8,4,CL_BLACK);
 END
 ELSE
 BEGIN
  BARI3D(0,0,20,GETB);
  DRAWSPOINTERUP(GETB DIV 2-3,9,4,CL_BLACK);
 END;
 IF BARVIS THEN
 BEGIN
  BAR3D(0,20+BARPOS,BARSIZE,GETB);
  Y:=20+BARPOS+BARSIZE DIV 2;
  B:=GETB-8;
  BAR(4,Y-4,1,B,CL_GRAY);
  BAR(4,Y-3,1,B,CL_LSILVER);
  BAR(4,Y-1,1,B,CL_GRAY);
  BAR(4,Y,1,B,CL_LSILVER);
  BAR(4,Y+2,1,B,CL_GRAY);
  BAR(4,Y+3,1,B,CL_LSILVER);
 END;
END;
CONSTRUCTOR TVSCROLLBAR.INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;SP,MP:DWORD);
BEGIN
 WRITELN(CRSTR,'Create VScrollbar (',DWORD(@SELF),') : ',X,':',Y,'  ',H,'*',B);
 IF GR=NIL THEN GR:=BAS;
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS,GT_NULL);
 CRLEA;
 POINTS:=MP;
 IF MP=0 THEN SP:=0 ELSE IF SP>=MP THEN SP:=MP-1;
 POS:=SP;
 BSTAT:=0;
 CALCBAR;
END;
PROCEDURE TLABEL.ONPAINT;
VAR Y:LONGINT;
    P:DWORD;
    LIN:STRING;
BEGIN
 BAR(0,0,GETH,GETB,CL_SILVER);
 Y:=0;
 P:=1;
 LIN:='';
 REPEAT
  LIN:=GETMAXWIDTHSTR(P,CAPTION,GETB,FONT);
  IF LIN<>'' THEN
  BEGIN
   PUTSTRING(0,Y,LIN,CL_BLACK,FONT);
   INC(Y,FONT^.HEIGHT+1);
  END;
 UNTIL LIN='';
END;
PROCEDURE TLABEL.SETCAPTION(S:STRING);
BEGIN
 CAPTION:=S;
 REDRAW;
END;
FUNCTION TLABEL.GETCAPTION:STRING;
BEGIN
 GETCAPTION:=CAPTION;
END;
CONSTRUCTOR TLABEL.INIT(BAS,GR:PWIN;X,Y:LONGINT;B:DWORD;VIS:BOOLEAN;TXT:STRING;F:PFONT);
VAR H:DWORD;
BEGIN
 WRITELN(CRSTR,'Create TLabel (',DWORD(@SELF),') : ',X,':',Y,'  ',H,'*',B);
 H:=GETMAXWIDTHSTRLINES(TXT,B,F)*(F^.HEIGHT+1)-1;
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS,GT_NULL);
 CRLEA;
 FONT:=F;
 CAPTION:=TXT;
END;
CONSTRUCTOR TLABEL.INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;TXT:STRING;F:PFONT);
BEGIN
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS,GT_NULL);
 FONT:=F;
 CAPTION:=TXT;
END;
CONSTRUCTOR TWINDOW_CLOSEB.INIT(BAS:PWINDOW);
BEGIN
 INHERITED INIT(BAS^.TITLE,BAS,BAS^.TITLE^.GETB-22,1,21,21,TRUE,'',NIL,BAS^.FONT);
 WINDOW:=BAS;
END;
PROCEDURE TWINDOW_CLOSEB.ONPAINT;
BEGIN
 IF ISDOWN THEN
 BEGIN
  BARI3D(0,0,GETH,GETB);
  DRAWCROSS(5,5,GETH-9,CL_BLACK);
 END
 ELSE
 BEGIN
  BAR3D(0,0,GETH,GETB);
  DRAWCROSS(4,4,GETH-9,CL_BLACK);
 END
END;
PROCEDURE TWINDOW_CLOSEB.ONCLICK;
BEGIN
 WINDOW^.CLOSE;
END;
PROCEDURE TWINDOW_SIZE.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
BEGIN
 IF SIZEING THEN
 BEGIN
  CASE TYP OF
   1:WINDOW^.MOVESIZE(OX+AX-BX,OY,OH+AY-BY,OB-AX+BX);
   2:WINDOW^.SIZE(OH+AY-BY,OB);
   3:WINDOW^.SIZE(OH+AY-BY,OB+AX-BX);
   4:WINDOW^.MOVESIZE(OX+AX-BX,OY,OH,OB-AX+BX);
   6:WINDOW^.SIZE(OH,OB+AX-BX);
   7:WINDOW^.MOVESIZE(OX+AX-BX,OY+AY-BY,OH-AY+BY,OB-AX+BX);
   8:WINDOW^.MOVESIZE(OX,OY+AY-BY,OH-AY+BY,OB);
   9:WINDOW^.MOVESIZE(OX,OY+AY-BY,OH-AY+BY,OB+AX-BX);
  END;
  IF B<>1 THEN
  BEGIN
   IF B<>0 THEN WINDOW^.MOVESIZE(OX,OY,OH,OB);
   SIZEING:=FALSE;
  END;
 END
 ELSE
 BEGIN
  IF (WINDOW^.SIZEABLE) AND (GETOLDMOUSEB=0) AND (B=1) THEN
  BEGIN
   SIZEING:=TRUE;
   OX:=WINDOW^.GETX;
   OY:=WINDOW^.GETY;
   OH:=WINDOW^.GETH;
   OB:=WINDOW^.GETB;
   BX:=AX;
   BY:=AY;
  END;
 END;
END;
FUNCTION TWINDOW_SIZE.GETMOUSEPIC(VAR HX,HY:LONGINT):GRAPH.PPICTURE;
BEGIN
 IF WINDOW^.SIZEABLE THEN
 BEGIN
  HX:=MX;
  HY:=MY;
  GETMOUSEPIC:=MP;
 END
 ELSE
 BEGIN
  HX:=0;
  HY:=0;
  GETMOUSEPIC:=@QSTDMSPIC_POINTER;
 END;
END;
PROCEDURE TWINDOW_SIZE.ADJUST;
BEGIN
 CASE TYP OF
  1:MOVE(0,WINDOW^.GETH-4);
  2:MOVESIZE(4,WINDOW^.GETH-4,4,WINDOW^.GETB-8);
  3:MOVE(WINDOW^.GETB-4,WINDOW^.GETH-4);
  4:SIZE(WINDOW^.GETH-8,4);
  6:MOVESIZE(WINDOW^.GETB-4,4,WINDOW^.GETH-8,4);
  8:SIZE(4,WINDOW^.GETB-8);
  9:MOVE(WINDOW^.GETB-4,0);
 END;
END;
CONSTRUCTOR TWINDOW_SIZE.INIT(BAS:PWINDOW;T:DWORD);
BEGIN
 TYP:=T;
 WINDOW:=BAS;
 CASE T OF
  1:
  BEGIN
   MP:=@QSTDMSPIC_SIZE19;
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,0,BAS^.GETH-4,4,4,TRUE,GT_NULL);
  END;
  2:
  BEGIN
   MP:=@QSTDMSPIC_SIZE28;
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,4,BAS^.GETH-4,4,BAS^.GETB-8,TRUE,GT_NULL);
  END;
  3:
  BEGIN
   MP:=@QSTDMSPIC_SIZE37;
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,BAS^.GETB-4,BAS^.GETH-4,4,4,TRUE,GT_NULL);
  END;
  4:
  BEGIN
   MP:=@QSTDMSPIC_SIZE46;
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,0,4,BAS^.GETH-8,4,TRUE,GT_NULL);
  END;
  6:
  BEGIN
   MP:=@QSTDMSPIC_SIZE46;
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,BAS^.GETB-4,4,BAS^.GETH-8,4,TRUE,GT_NULL);
  END;
  7:
  BEGIN
   MP:=@QSTDMSPIC_SIZE37;
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,0,0,4,4,TRUE,GT_NULL);
  END;
  8:
  BEGIN
   MP:=@QSTDMSPIC_SIZE28;
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,4,0,4,BAS^.GETB-8,TRUE,GT_NULL);
  END;
  9:
  BEGIN
   MP:=@QSTDMSPIC_SIZE19;
   MX:=7;
   MY:=7;
   INHERITED INIT(BAS,BAS,BAS^.GETB-4,0,4,4,TRUE,GT_NULL);
  END;
 END;
END;
PROCEDURE TWINDOW_TITLE.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
BEGIN
 IF DRAGGING THEN
 BEGIN
  WINDOW^.MOVE(OX+AX-BX,OY+AY-BY);
  IF B<>1 THEN
  BEGIN
   IF B<>0 THEN WINDOW^.MOVE(OX,OY);
   DRAGGING:=FALSE;
  END;
 END
 ELSE
 BEGIN
  IF (GETOLDMOUSEB=0) AND (B=1) THEN
  BEGIN
   DRAGGING:=TRUE;
   BX:=AX;
   BY:=AY;
   OX:=WINDOW^.GETX;
   OY:=WINDOW^.GETY;
   REDRAW;
  END;
 END;
END;
PROCEDURE TWINDOW_TITLE.ONPAINT;
BEGIN
 IF WINDOW^.SELECTED THEN
 BEGIN
  BAR(0,0,GETH,GETB,CL_BLUE);
  PUTSTRING(2,
            LONGINT(GETH-WINDOW^.FONT^.HEIGHT) DIV 2,WINDOW^.CAPTION,
            CL_YELLOW,WINDOW^.FONT);
 END
 ELSE
 BEGIN
  BAR(0,0,GETH,GETB,CL_GRAY);
  PUTSTRING(2,
            LONGINT(GETH-WINDOW^.FONT^.HEIGHT) DIV 2,WINDOW^.CAPTION,
            CL_SILVER,WINDOW^.FONT);
 END;
END;
CONSTRUCTOR TWINDOW_TITLE.INIT(BAS:PWINDOW);
BEGIN
 INHERITED INIT(BAS,BAS,4,4,23,BAS^.GETB-8,TRUE,GT_NULL);
 WINDOW:=BAS;
END;
PROCEDURE TWINDOW.ONRESIZE;
VAR I:DWORD;
BEGIN
 TITLE^.SIZE(23,GETB-8);
 CLOSEBUTTON^.MOVE(TITLE^.GETB-22,1);
 APPF^.SIZE(GETH-33,GETB-8);
 FOR I:=1 TO 9 DO SIZEF[I]^.ADJUST;
END;
FUNCTION TWINDOW.CANCLOSE:BOOLEAN;
BEGIN
 CANCLOSE:=FALSE;
END;
FUNCTION TWINDOW.CLOSE:BOOLEAN;
BEGIN
 CLOSE:=CANCLOSE;
 IF CLOSE THEN
 BEGIN
  DISPOSE(PWINDOW(@SELF),DONE);
 END;
END;
PROCEDURE TWINDOW.CHECKSIZE(VAR H,B:DWORD);
BEGIN
 IF LONGINT(H)<33 THEN H:=33;
 IF LONGINT(B)<33 THEN B:=33;
END;
PROCEDURE TWINDOW.ONUNSELECT;
BEGIN
 SELECTED:=FALSE;
 REDRAW;
END;
PROCEDURE TWINDOW.ONSELECT(FOC:BOOLEAN);
BEGIN
 SELECTED:=TRUE;
 BRINGTOFRONT;
 REDRAW;
END;
PROCEDURE TWINDOW.ONPAINT;
BEGIN
 BAR3D(0,0,GETH,GETB);
END;
CONSTRUCTOR TWINDOW.INIT(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;
                         CAP:STRING;SZ:BOOLEAN;F:PFONT);
VAR I:DWORD;
BEGIN
 WRITELN(CRSTR,'Create Window (',DWORD(@SELF),') : ',X,':',Y,'  ',H,'*',B);
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS,GT_WIN);
 CRLEA;
 CAPTION:=CAP;
 FONT:=F;
 SIZEABLE:=SZ;
 NEW(TITLE,INIT(@SELF));
 NEW(CLOSEBUTTON,INIT(@SELF));
 FOR I:=1 TO 9 DO NEW(SIZEF[I],INIT(@SELF,I));
 NEW(APPF,INIT(@SELF,@SELF,4,29,H-33,B-8,TRUE,GT_NULL));
 SETAPPFRAME(APPF);
END;
PROCEDURE TBUTTON.ONKEY(C,C2:CHAR);
BEGIN
 IF (C IN [#13,#32]) THEN ONCLICK;
END;
PROCEDURE TBUTTON.ONSELECT(FOC:BOOLEAN);
BEGIN
 REDRAW;
END;
PROCEDURE TBUTTON.ONUNSELECT;
BEGIN
 REDRAW;
END;
PROCEDURE TBUTTON.ONCLICK;
BEGIN
 IF ONCLICKP<>NIL THEN ONCLICKP(@SELF);
END;
PROCEDURE TBUTTON.ONMOUSE(X,Y:LONGINT;B:DWORD;AX,AY:LONGINT);
BEGIN
 IF DOWN THEN
 BEGIN
  IF B<>1 THEN
  BEGIN
   DOWN:=FALSE;
   IF (DWORD(X)<GETB) AND (DWORD(Y)<GETH) AND (B=0) THEN ONCLICK;
   REDRAW;
  END;
 END ELSE IF (GETOLDMOUSEB=0) AND (B=1) THEN
 BEGIN
  DOWN:=TRUE;
  REDRAW;
 END;
END;
PROCEDURE TBUTTON.ONPAINT;
VAR PX,PY,PX2,PY2:LONGINT;
    PB:DWORD;
BEGIN
 IF DOWN THEN
 BEGIN
  BARI3D(0,0,GETH,GETB);
  IF HASFOCUS THEN RECTANGLE(3,3,GETH-5,GETB-5,CL_RED);
 END
 ELSE
 BEGIN
  BAR3D(0,0,GETH,GETB);
  IF HASFOCUS THEN RECTANGLE(2,2,GETH-5,GETB-5,CL_RED);
 END;
 PB:=GETSTRINGWIDTH(CAPTION,FONT);
 IF PIC<>NIL THEN
 BEGIN
  PX:=(GETB-PIC^.B) DIV 2;
  IF CAPTION='' THEN
  BEGIN
   PY:=(GETH-PIC^.H) DIV 2;
   IF DOWN THEN
   BEGIN
    PUTPIC(PX+1,PY+1,PIC);
   END
   ELSE
   BEGIN
    PUTPIC(PX,PY,PIC);
   END;
  END
  ELSE
  BEGIN
   PX2:=(GETB-PB) DIV 2;
   PY:=(GETH-(PIC^.H+FONT^.HEIGHT+5)) DIV 2;
   PY2:=PY+PIC^.H;
   IF DOWN THEN
   BEGIN
    PUTPIC(PX+1,PY+1,PIC);
    PUTSTRING(PX2+1,PY2+1,CAPTION,CL_BLACK,FONT);
   END
   ELSE
   BEGIN
    PUTPIC(PX,PY,PIC);
    PUTSTRING(PX2,PY2,CAPTION,CL_BLACK,FONT);
   END;
  END;
 END
 ELSE
 BEGIN
  PX:=(GETB-PB) DIV 2;
  PY:=(GETH-FONT^.HEIGHT) DIV 2;
  IF DOWN THEN
  BEGIN
   PUTSTRING(PX+1,PY+1,CAPTION,CL_BLACK,FONT);
  END
  ELSE
  BEGIN
   PUTSTRING(PX,PY,CAPTION,CL_BLACK,FONT);
  END;
 END;
END;
FUNCTION TBUTTON.ISDOWN:BOOLEAN;
BEGIN
 ISDOWN:=DOWN;
END;
CONSTRUCTOR TBUTTON.INIT(BAS,GR:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;
            TXT:STRING;PI:GRAPH.PPICTURE;FON:PFONT);
BEGIN
 WRITELN(CRSTR,'Create Button (',DWORD(@SELF),' ) : ',X,':',Y,'  ',H,'*',B);
 INHERITED INIT(BAS,GR,X,Y,H,B,VIS,GT_STDOBJ);
 CRLEA;
 DOWN:=FALSE;
 CAPTION:=TXT;
 PIC:=PI;
 FONT:=FON;
END;
END.
